#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <bitset>
 
using namespace std;
 
const int K = 26;
const int L = 21;
const int N = 5e5 + 7;

const int BASE = 31;
const int MOD = 1e9 + 7;

int add(int a, int b) {
	if (a + b < MOD) {
		return a + b;
	}
	return a + b - MOD;
}

int mul(int a, int b) {
	return 1LL * a * b;
}
 
int A[K][K];

int n;
string s;

vector<int> st;
vector<int> all;

int link[N];

//
int up[L][N];
int hup[L][N];

void cup(int p) {
	up[0][p] = link[p];
	hup[0][p] = s[p];
	int cp = BASE;
	for (int i = 0; i + 1 < L; i++) {
		int mid = up[i][p];
		if (mid == n) {
			up[i + 1][p] = n;
		} else {
			up[i + 1][p] = up[i][mid];
			hup[i + 1][p] = add(mul(hup[i][p], cp), hup[i][mid]);
		}
		cp = mul(cp, cp);
	} 
}

void trim(int &a, int &b) {
	if (a == -1 || b == -1) return;
	for (int i = L - 1; i >= 0; i--) {
		if (up[i][a] != n && up[i][b] != n && hup[i][a] == hup[i][b]) {
			a = up[i][a];
			b = up[i][b];
		}
	}
}

int les(int a, int b) {
	trim(a, b);
	while (true) {
		if (b == -1) {
			return 1;
		}
		if (b == n) {
			return 0;
		}
		if (a == n) {
			return 1;
		}
		if (s[a] < s[b]) {
			return 1;
		}
		if (s[a] > s[b]) {
			return 0;
		}
		a = link[a];
		b = link[b];
	}
}
 
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

    int k;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c;
            cin >> c;
            A[i][j] = (c - '0');
        }
    }
    cin >> s;
    for (int i = n - 1; i >= 0; i--) {
    	string add = string(1, s[i]);
    	int mn = -1;
    	while (!st.empty() && A[s[i] - 'a'][s[st.back()] - 'a']) {
    		if (les(all.back(), mn)) {
    			mn = all.back();
    		}
    		st.pop_back();
    		all.pop_back();
    	}
    	if (st.empty()) {
    		mn = n;
    	} else {
    		if (les(st.back(), mn)) mn = st.back();
    	}
    	link[i] = mn;
    	cup(i);
    	st.push_back(i);
    	int rmn = mn;
    	if (les(i, mn)) {
    		rmn = i;
    	}
    	all.push_back(rmn);
    }
    int c = 0;
    while (c < n) {
    	cout << s[c];
    	c = link[c];
    }
    cout << '\n';
}