#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <bitset>
#include <algorithm>

using namespace std;

const int K = 8;
const int INF = 1e9 + 239;
const int N = 2001;

int n;
vector<int> g[N];
vector<int> num[N];

int dp[1 << K];
int sdp[N][N + 1];
vector<int> et;

void dfs(int cur) {
	for (auto t : g[cur]) {
		dfs(t);
	}
	et.push_back(cur);
}
 
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	vector<int> zp;
    cin >> n;
    for (int i = 0; i < n; i++) {
    	int tp, sz;
    	cin >> tp >> sz;
    	if (tp == 1) {
    		g[i].resize(sz);
    		for (auto &t : g[i]) {
    			cin >> t;
    			t--;
    		} 
    	} else {
    		num[i].resize(sz);
    		for (auto &t : num[i]) {
    			cin >> t;
    			zp.push_back(t);
    		}
    	}
    }
    int sz = 0;
    {
    	sort(zp.begin(), zp.end());
    	zp.resize(unique(zp.begin(), zp.end()) - zp.begin());
    	for (int i = 0; i < n; i++) {
    		for (auto &t : num[i]) {
    			t = lower_bound(zp.begin(), zp.end(), t) - zp.begin();
    		}
    	}
    	sz = (int)zp.size();
    }
    dfs(0);
    for (auto i : et) {
    	if (num[i].empty()) {
    		int cnt = (int)g[i].size();
    		for (int j = 0; j <= sz; j++) {
    			for (int mask = 0; mask < (1 << cnt); mask++) {
    				dp[mask] = INF;
    			}
    			dp[0] = j;
    			for (int mask = 0; mask < (1 << cnt); mask++) {
    				if (dp[mask] == INF) continue;
    				for (int add = 0; add < cnt; add++) {
    					if (!((mask >> add) & 1)) {
    						dp[mask | (1 << add)] = min(dp[mask | (1 << add)], sdp[g[i][add]][dp[mask]] + 1);
    					}
    				}
    			}
    			sdp[i][j] = dp[(1 << cnt) - 1];  
    		}
    	} else {
    		fill(sdp[i], sdp[i] + sz, INF);
    		for (auto t : num[i]) {
    			for (int j = t; j < sz; j++) {
    				sdp[i][j] = min(sdp[i][j], t);
    			}
    		}
    		sdp[i][sz] = INF;
    	}
    }
    // cerr << sdp[1][0] << endl;
    // cerr << sdp[2][1] << endl;
    if (sdp[0][0] != INF) {
    	cout << "Yes\n";
    } else {
    	cout << "No\n";
    }
}