#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <bitset>
#include <algorithm>
#include <cassert>

using namespace std;

const int K = 8;
const int INF = 1e9 + 239;
const int N = 2001;

int n;
vector<int> g[N];
vector<int> num[N];

int dp[1 << K];
int sdp[N][N + 1];
vector<int> et;

void dfs(int cur) {
	for (auto t : g[cur]) {
		dfs(t);
	}
	et.push_back(cur);
}

vector<int> zp;
int wr[1 << K];
vector<int> ans[N];

void recover(int i, int j) {
	if (num[i].empty()) {
		int cnt = (int)g[i].size();
		for (int mask = 0; mask < (1 << cnt); mask++) {
			wr[mask] = -1;
			dp[mask] = INF;
		}
		dp[0] = j;
		for (int mask = 0; mask < (1 << cnt); mask++) {
			if (dp[mask] == INF) continue;
			for (int add = 0; add < cnt; add++) {
				if (!((mask >> add) & 1)) {
					if (dp[mask | (1 << add)] > sdp[g[i][add]][dp[mask]] + 1) {
						dp[mask | (1 << add)] = sdp[g[i][add]][dp[mask]] + 1;
						wr[mask | (1 << add)] = add;
					}
				}
			}
		}
		// cerr << i << endl;
		// cerr << dp[(1 << cnt) - 1] << endl;
		assert(wr[(1 << cnt) - 1] != -1);
		int cur = (1 << cnt) - 1;
		for (int c = 0; c < cnt; c++) {
			ans[i].push_back(g[i][wr[cur]]);
			cur ^= (1 << wr[cur]);
		}
		reverse(ans[i].begin(), ans[i].end());
		int cmx = j;
		for (auto &s : ans[i]) {
			recover(s, cmx);
			cmx = max(cmx, sdp[s][cmx] + 1);
			s++;
		}
	} else {
		int mn = INF;
		for (auto t : num[i]) {
			if (j <= t) mn = min(mn, t);
		}
		ans[i].push_back(zp[mn]);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

    cin >> n;
    for (int i = 0; i < n; i++) {
    	int tp, sz;
    	cin >> tp >> sz;
    	if (tp == 1) {
    		g[i].resize(sz);
    		for (auto &t : g[i]) {
    			cin >> t;
    			t--;
    		} 
    	} else {
    		num[i].resize(sz);
    		for (auto &t : num[i]) {
    			cin >> t;
    			zp.push_back(t);
    		}
    	}
    }
    int sz = 0;
    {
    	sort(zp.begin(), zp.end());
    	zp.resize(unique(zp.begin(), zp.end()) - zp.begin());
    	for (int i = 0; i < n; i++) {
    		for (auto &t : num[i]) {
    			t = lower_bound(zp.begin(), zp.end(), t) - zp.begin();
    		}
    	}
    	sz = (int)zp.size();
    }
    dfs(0);
    for (auto i : et) {
    	if (num[i].empty()) {
    		int cnt = (int)g[i].size();
    		for (int j = 0; j <= sz; j++) {
    			for (int mask = 0; mask < (1 << cnt); mask++) {
    				dp[mask] = INF;
    			}
    			dp[0] = j;
    			for (int mask = 0; mask < (1 << cnt); mask++) {
    				if (dp[mask] == INF) continue;
    				for (int add = 0; add < cnt; add++) {
    					if (!((mask >> add) & 1)) {
    						dp[mask | (1 << add)] = min(dp[mask | (1 << add)], sdp[g[i][add]][dp[mask]] + 1);
    					}
    				}
    			}
    			if (dp[(1 << cnt) - 1] == INF) {
    				sdp[i][j] = INF;
    			} else {
    				sdp[i][j] = dp[(1 << cnt) - 1] - 1;
    			}
    		}
    	} else {
    		fill(sdp[i], sdp[i] + sz + 1, INF);
    		for (auto t : num[i]) {
    			for (int j = 0; j <= t; j++) {
    				sdp[i][j] = min(sdp[i][j], t);
    			}
    		}
    		sdp[i][sz] = INF;
    	}
    }
    if (sdp[0][0] != INF) {
    	cout << "Yes\n";
    	recover(0, 0);
    	for (int i = 0; i < n; i++) {
    		for (auto t : ans[i]) {
    			cout << t << ' ';
    		}
    		cout << '\n';
    	}
    } else {
    	cout << "No\n";
    }
}