#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <bitset>
#include <set>
#include <algorithm>
#include <numeric>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
//#define int ll

vector<vector<int>> g;
vector<vector<vector<int>>> c;

vector<vector<int>> solve1(int i, vector<vector<vector<int>>>& a, vector<int>& ans) {
	if (i == a.size()) {
		vector<int> res;
		for (int i = 0; i < a.size(); ++i) {
			for (int j = 0; j < a[i][ans[i]].size(); ++j)
				res.emplace_back(a[i][ans[i]][j]);
		}
		for (int k = 0; k < res.size() - 1; ++k)
			if (res[k] > res[k + 1])
				return {};
		return { res };
	}
	vector<vector<int>> res;
	for (int k = 0; k < a[i].size(); ++k) {
		ans.emplace_back(k);
		for (auto& it : solve1(i + 1, a, ans))
			res.emplace_back(it);
		ans.pop_back();
	}
	return res;
}

vector<vector<int>> ssolve1(int i, vector<vector<vector<int>>>& a, vector<int>& ans, vector<int>& need) {
	if (i == a.size()) {
		vector<int> res;
		for (int i = 0; i < a.size(); ++i) {
			for (int j = 0; j < a[i][ans[i]].size(); ++j)
				res.emplace_back(a[i][ans[i]][j]);
		}
		for (int k = 0; k < res.size() - 1; ++k)
			if (res[k] > res[k + 1])
				return {};
		if (res == need) {
			vector<vector<int>> temp;
			for (int i = 0; i < ans.size(); ++i)
				temp.emplace_back(a[i][ans[i]]);
			return temp;
		}
	}
	vector<vector<int>> res;
	for (int k = 0; k < a[i].size(); ++k) {
		ans.emplace_back(k);
		auto it = ssolve1(i + 1, a, ans, need);
		if (!it.empty())
			return it;
		ans.pop_back();
	}
}


vector<vector<int>> solve(int v) {
	if (g[v].empty())
		return c[v];
	vector<vector<vector<int>>> a;
	for (int& i : g[v])
		a.emplace_back(solve(i));
	vector<vector<int>> ans;
	vector<int> ord(a.size());
	iota(all(ord), 0);
	auto a1 = a;
	do {
		for (int i = 0; i < a.size(); ++i)
			a1[i] = a[ord[i]];
		vector<int> temp;
		for (auto& it : solve1(0, a1, temp))
			ans.emplace_back(it);
	} while (next_permutation(all(ord)));
	return ans;
}

vector<vector<int>> aans;

void ssolve(int v, vector<int> need) {
	if (g[v].empty()) {
		for (int i = 0; i < c[v].size(); ++i)
			if (c[v][i][0] == need[0]) {
				aans[v] = { c[v][i][0] };
				return;
			}
	}
	vector<vector<vector<int>>> a;
	for (int& i : g[v])
		a.emplace_back(solve(i));
	vector<int> ord(a.size());
	iota(all(ord), 0);
	auto a1 = a;
	do {
		for (int i = 0; i < a.size(); ++i)
			a1[i] = a[ord[i]];
		vector<int> temp;
		for (auto& it : solve1(0, a1, temp)) {
			if (it == need) {
				auto it1 = ssolve1(0, a1, temp, need);
				for (int i = 0; i < ord.size(); ++i) {
					ssolve(g[v][ord[i]], it1[i]);
				}
				for (int i = 0; i < ord.size(); ++i) {
					aans[v].emplace_back(g[v][ord[i]] + 1);
				}
				return;
			}
		}
	} while (next_permutation(all(ord)));
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	int n;
	cin >> n;
	g.resize(n);
	c.resize(n);
	int t, k, a;
	for (int i = 0; i < n; ++i) {
		cin >> t >> k;
		if (t == 1) {
			for (int j = 0; j < k; ++j) {
				cin >> a;
				g[i].emplace_back(a - 1);
			}
		}
		else {
			for (int j = 0; j < k; ++j) {
				cin >> a;
				c[i].push_back({a});
			}
		}
	}
	auto it = solve(0);
	if (it.empty())
		cout << "No";
	else {
		cout << "Yes\n";
		aans.resize(n);
		ssolve(0, it[0]);
		for (auto& it : aans) {
			for (int& i : it)
				cout << i << " ";
			cout << '\n';
		}
	}
	return 0;
}