#include <bits/stdc++.h>

using namespace std;
#define MAXN 32
int shift = 0;
string message;
int m, n;
int cur_field[MAXN][MAXN];

void draw(int x, int y) {
    for (int i = x; i < n; ++i) {
        for (int j = y; j < n; ++j) {
            if (cur_field[i][j]) {
                break;
            }
            cur_field[i][j] = 1;
        }
    }
}

int will(int x, int y) {
    int ans = 0;
    for (int i = x; i < n; ++i) {
        for (int j = y; j < n; ++j) {
            if (cur_field[i][j]) {
                break;
            }
            ans++;
            if (ans > 3) {
                return ans;
            }
        }
    }
    return ans;
}

void go(int x, int y) {
    cout << x + 1 << " " << y + 1 << endl;
    draw(x, y);
}

int create(int sz) {
    int pw = 0;
    while ((1 << (pw + 1)) <= sz) {
        pw++;
    }
    int bits = min(pw, m - shift);
    int res = 0;
    for (int i = 0; i < bits; ++i) {
        res += ((message[i + shift] - '0') << i);
    }
    shift += bits;
    //cerr << sz << " " << pw << " " << bits << " " << res << "\n";
    return res;
}

void recognize(int sz, int pos) {
    int pw = 0;
    while ((1 << (pw + 1)) <= sz) {
        pw++;
    }
    int bits = min(pw, m - shift);
    for (int i = 0; i < bits; ++i) {
        message += pos % 2 + '0';
        pos /= 2;
    }
    shift += bits;
}

void play_game(bool first) {
    memset(cur_field, 0, sizeof(cur_field));
    if (!first) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        draw(x, y);
    }
    while (true) {
        if (shift == m) {
            go(0, 0);
            return;
        }
        int bit = message[shift] - '0';
        //cerr << shift << " " << bit << "\n";
        int x = 0, y = 0;
        vector<pair<int, int>> one;
        vector<pair<int, int>> two;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == 0 && j == 0) {
                    continue;
                }
                if (cur_field[i][j]) {
                    continue;
                }
                if (will(i, j) == 1) {
                    one.push_back({i, j});
                }
                if (will(i, j) == 2) {
                    two.push_back({i, j});
                }
            }
        }
        shift++;
        if (bit == 0) {
            if (one.size() == 0) {
                x = 0, y = 0;
            } else {
                int pos = create(one.size());
                x = one[pos].first;
                y = one[pos].second;
            }
        }else{
            if (two.size() == 0) {
                x = 0, y = 0;
            } else {
                int pos = create(two.size());
                x = two[pos].first;
                y = two[pos].second;
            }
        }
        //cerr << x << " " << y << "\n";
        go(x, y);
        if (x + y == 0) {
            break;
        }
        int xs, ys;
        cin >> xs >> ys;
        xs--;
        ys--;
        draw(xs, ys);
        if (xs + ys == 0) {
            break;
        }
    }
}

void play() {
    int k;
    cin >> n >> k >> m;
    cin >> message;
    int ind = 0;
    while (shift < m) {
        play_game(ind % 2 == 0);
        ind++;
    }
    cout << 0 << endl;
}

void recover_game(bool first) {
    memset(cur_field, 0, sizeof(cur_field));
    if (!first) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        draw(x, y);
    }
    while (true) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if (x + y == 0) {
            break;
        }
        message += (char) (will(x, y) - 1 + '0');
        shift++;

        vector<pair<int, int>> one;
        vector<pair<int, int>> two;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == 0 && j == 0) {
                    continue;
                }
                if (cur_field[i][j]) {
                    continue;
                }
                if (will(i, j) == 1) {
                    one.push_back({i, j});
                }
                if (will(i, j) == 2) {
                    two.push_back({i, j});
                }
            }
        }
        if (find(one.begin(), one.end(), make_pair(x, y)) != one.end()) {
            int pos = find(one.begin(), one.end(), make_pair(x, y)) - one.begin();
            recognize(one.size(), pos);
        } else {
            int pos = find(two.begin(), two.end(), make_pair(x, y)) - two.begin();
            recognize(two.size(), pos);
        }

        draw(x, y);
        int xs, ys;
        cin >> xs >> ys;
        xs--;
        ys--;
        draw(xs, ys);
        if (xs + ys == 0) {
            break;
        }
    }
}

void recover() {

    int k;
    cin >> n >> k >> m;
    int l;
    cin >> l;
    for (int i = 0; i < l; ++i) {
        recover_game(i % 2 == 0);
    }
    cout << message << "\n";
}

int main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    int k;
    cin >> k;
    if (k == 1) {
        play();
    } else {
        recover();
    }
    return 0;
}
