#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.end()

bool comp(string s, string t) {
	int n = s.length();
	if (t.length() < n) n = t.length();
	for (int i{}; i < n; ++i) {
		if (s[i] == t[i]) continue;
		if (s[i] < t[i]) return true;
		if (s[i] > t[i]) return false;
	}
	return s.length() < t.length();
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int k, n;
	cin >> k >> n;
	vector<vector<char>> can(255, vector<char>(255));

	for (int i{}; i < k; ++i) {
		string t;
		cin >> t;
		for (int j{}; j < k; ++j) {
			if (t[j] == '0') can['a' + i]['a' + j] = false;
			else can['a' + i]['a' + j] = true;
		}
	}

	string s;
	cin >> s;

	vector<vector<char>> dp(n + 1, vector<char>(n + 1, false));
	for (int i{}; i <= n; ++i) dp[i][i] = true;
	vector<int> used(n);
	int usd = 0;

	for (int i{ 1 }; i < n; ++i) {
		stack<int> st;
		for (int k{ i }; k >= 0; --k) {
			while (!st.empty()) {
				auto x = st.top();
				if (can[s[k]][x]) st.pop();
				else break;
			}
			if (st.empty()) {
				dp[k + 1][i + 1] = true;
			}
			st.push(s[k]);
		}
	}
	

	int ind{};

	vector<string> ans(n + 1);
	ans[n] = "";;
	for (int i{ n - 1 }; i >= 0; --i) {
		ans[i] = s[i] + ans[i + 1];
		if (!dp[i][i + 1]) continue;

		for (int j{ i }; j < n; ++j) {
			if (!dp[i][j + 1]) break;
			if (comp(ans[j + 1], ans[i])) ans[i] = ans[j + 1];
		}
	}

	cout << ans[0];

	return 0;
}
