#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

const int N = 5e5 + 5;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

int n, k, m;
bool field[32][32];
string s;
int cur = 0;

void place(int x, int y) {
    if (field[n - y - 1][x]) exit(-1);
    field[n - y - 1][x] = 1;
    for (int i = 0; i <= n - y - 1; ++i) {
        for (int j = x; j < n; ++j) {
            field[i][j] = 1;
        }
    }
}

void move(int x, int y) {
    place(x, y);
    cout << x + 1 << " " << y + 1 << endl;
    if (x == 0 && y == 0) return;
    int a, b; cin >> a >> b; --a; --b;
    place(a, b);
}

int free() {
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (!field[i][j]) ++cnt;
        }
    }
    return cnt;
}

void play() {
    while (free() != 0) {
        int cnt = free();
        if (cnt == 1) move(0, 0);
        else {
            int deg = 0;
            while (cnt > 1) {
                cnt /= 2; ++deg;
            }
            int num = 0;
            for (int i = cur; i < min(cur + deg, m); ++i) {
                num += (s[i] == '1') * (1 << (cur + deg - 1 - i));
            }
            cnt = 0;
            bool f = 1;
            for (int i = 0; i < n; ++i) {
                if (!f) break;
                for (int j = 0; j < n; ++j) {
                    if (!f) break;
                    if (!field[i][j]) {
                        if (cnt == num) {
                            move(j, n - i - 1);
                            f = 0;
                        }
                        ++cnt;
                    }
                }
            }
            if (f) exit(-2);
            cur += deg;
        }
    }
}

void clear() {
    for (int t = 0; t < n; ++t) {
        for (int j = 0; j < n; ++j) field[t][j] = 0;
    }
}

void solve1() {
    cin >> s;
    int i = 0;
    while (cur < m) {
        clear();
        if (i % 2 == 0) play();
        else {
            int x, y; cin >> x >> y; --x; --y;
            place(x, y);
            play();
        }
        ++i;
    }
    cout << 0 << endl;
}

void game(int i) {
    i %= 2; int c = 0;
    while (free() != 0) {
        int x, y; cin >> x >> y; --x; --y;
        if ((c ^ i)) {
            place(x, y);
            continue;
        }
        int cnt = free();
        if (cnt == 1) {
            place(x, y);
            break;
        }
        else {
            int deg = 0;
            while (cnt > 1) {
                cnt /= 2; ++deg;
            }
            int num = 0; cnt = 0;
            bool f = 1;
            for (int i = 0; i < n; ++i) {
                if (!f) break;
                for (int j = 0; j < n; ++j) {
                    if (!f) break;
                    if (!field[i][j]) {
                        if (x == j && i == n - y - 1) {
                            num = cnt;
                            f = 0;
                        }
                        ++cnt;
                    }
                }
            }
            if (f) exit(-2);
            for (int i = 0; i < deg; ++i) {
                if (s.size() == m) break;
                s += '0' + bool((1 << (deg - i - 1)) & num);
            }
            cur += deg;
            place(x, y);
        }
        ++c; c %= 2;
    }
}

void solve2() {
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        clear();
        game(i);
    }
    cout << s << endl;
}

int main() {
//    optimize();
    int t; cin >> t;
    cin >> n >> k >> m;
    if (t == 1) solve1();
    else solve2();



    return 0;
}
