#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <list>
#include <stack>
#include <cassert>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)

#define all(a) a.begin(), a.end()

typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
}

void solve();
int main() {
    setup();
    solve();
    return 0;
}

#ifdef LOCAL
const int MAXN = 100 + 10;
#else
const int MAXN = 1e5 + 10;
#endif

int n;
vector<int> sns[MAXN];
vector<pair<int, int>> doks[MAXN];
vector<pair<pii, int>> what[MAXN];
struct comp{
    int v;
    bool operator()(const int &a, const int &b) const {return doks[v][a].fi < doks[v][b].fi;}
};

void dfs(int v) {
    if (sns[v].empty()) return;
    else if (sns[v].size() == 1) {
        dfs(sns[v][0]);
        doks[v] = doks[sns[v][0]];
        what[v] = what[sns[v][0]];
    } else {
        auto son0 = sns[v][0];
        auto son1 = sns[v][1];
        dfs(son0);
        dfs(son1);
        for (int i1 = 0; i1 < doks[son0].size(); ++i1) {
            auto[f1, s1] = doks[son0][i1];
            auto i2 = lower_bound(all(doks[son1]), make_pair(s1, 0)) - doks[son1].begin();
            auto[f2, s2] = doks[son1][i2];
            if (s1 < f2) {
                doks[v].emplace_back(f1, s2);
                what[v].push_back({{i1, i2}, 0});
            } else if (s2 < f1) {
                doks[v].emplace_back(f2, s1);
                what[v].push_back({{i1, i2}, 1});
            }
        }
        for (int i2 = 0; i2 < doks[son1].size(); ++i2) {
            auto[f2, s2] = doks[son1][i2];
            auto i1 = lower_bound(all(doks[son0]), make_pair(s2, 0)) - doks[son0].begin();
            auto[f1, s1] = doks[son0][i1];
            if (s1 < f2) {
                doks[v].emplace_back(f1, s2);
                what[v].push_back({{i1, i2}, 0});
            } else if (s2 < f1) {
                doks[v].emplace_back(f2, s1);
                what[v].push_back({{i1, i2}, 1});
            }
        }
        vector<int> ins(doks[v].size());
        iota(all(ins), 0);
        sort(all(ins), comp{v});
        vector<int> news;
        stack<int> vs;
        auto &d = doks[v];
        auto &w = what[v];
        for (auto i : ins) {
            while (!vs.empty()) {
                int j = vs.top();
                if (d[i].fi >= d[j].se) {
                    news.push_back(j);
                    vs.pop();
                } else if (d[i].se <= d[j].se) {
                    vs.pop();
                }
            }
        }
        while (!vs.empty()) {
            int j = vs.top();
            news.push_back(j);
            vs.pop();
        }
        int cnt = 0;
        for (auto i : news) {
            d[cnt] = d[i];
            w[cnt] = w[i];
            ++cnt;
        }
        d.resize(news.size());
        w.resize(news.size());
    }
}

pair<int, int> ar[MAXN];
void dd(int v, int w) {
    if (sns[v].empty()) {
        ar[v] = {w, w};
    } else if (sns[v].size() == 1) {
        ar[v] = {sns[v][0], sns[v][0]};
        dd(sns[v][0], w);
    } else {
        auto son0 = sns[v][0];
        auto son1 = sns[v][1];
        if (what[v][w].second == 0) {
            ar[v] = {son0, son1};
        } else {
            ar[v] = {son1, son0};
        }
        dd(son0, what[v][w].fi.fi);
        dd(son1, what[v][w].fi.se);
    }
}

void solve() {
    cin >> n;
    range(i, n) {
        int t = 0; cin >> t;
        int k; cin >> k;
        if (t == 1) {
            range(_, k) {
                int u; cin >> u; --u;
                sns[i].pb(u);
            }
        } else {
            range(_, k) {
                int u; cin >> u;
                doks[i].emplace_back(u, u);
            }
        }
    }
    dfs(0);
    if (doks[0].size()) {
        cout << "Yes\n";
        dd(0, 0);
        range(v, n) {
            if (sns[v].empty()) {
                cout << doks[v][ar[v].fi].fi;
            } else if (sns[v].size() == 1) {
                cout << sns[v][0] + 1;
            } else {
                cout << ar[v].fi + 1 << ' ' << ar[v].se + 1;
            }
            cout << '\n';
        }
    } else {
        cout << "No" << endl;
    }
}
