#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()

int field[40][40];
int gett[40][40];
int n, k, m;

const int M = 2;

bool gameIsEnded = 0;

void clean() {
    gameIsEnded = 0;
    for(int i = 0; i < 40; i++) {
        for(int j = 0; j < 40; j++) {
            field[i][j] = 0;
            gett[i][j] = (n - i + 1) * (n - j + 1);
        }
    }
}

void put(int x, int y) {
    if (x == 1 && y == 1) {
        gameIsEnded = 1;
    }
    for(int i = x; i <= n; i++) {
        for(int j = y; j <= n; j++) {
            field[i][j] = 1;
        }
    }
}

int get(int x, int y) {
    int ret = 0;
    for(int i = x; i <= n; i++) {
        for(int j = y; j <= n; j++) {
            if (!field[i][j]) {
                ret++;
                if (ret >= M) break;
            }
        }
    }
    return ret;
}

vector<pair<int, int>> cnt[M];

void play() {
    cin >> n >> k >> m;
    string s;
    cin >> s;
    int cntOfGame = 0;
    int pos = 0;
    while (pos < m) {
        int turn = cntOfGame++ % 2 == 0;
        clean();
        while (!gameIsEnded) {
            if (turn) {
                for(int i = 0; i < M; i++) cnt[i].clear();
                for(int i = n; i >= 1 && size(cnt[1]) < 2; i--) {
                    for(int j = n; j >= 1 && size(cnt[1]) < 2; j--) {
                       if (field[i][j]) continue;
                       int x = get(i, j);
                       if (x < M)
                         cnt[x].emplace_back(i, j);
                    }
                }
                if (pos == m) {
                    cout << 1 << ' ' << 1 << endl;
                    put(1, 1);
                    continue;
                }
                int same = 1;
                for(int i = pos + 1; i < m; i++) {
                    if (s[i] != s[i - 1]) break;
                    same++;
                }
                bool did = 0;
                for(int i = M - 1; i >= 0; i--) {
                    int w = 0;
                    if (i == 1) w = 1;
                    else w = (1 << (i + 1));
                    if (same >= w && size(cnt[i]) > 1) {
                        if (s[pos] == '1') swap(cnt[i][0], cnt[i].back());
                        cout << cnt[i][0].first << ' ' << cnt[i][0].second << endl;
                        put(cnt[i][0].first, cnt[i][0].second);
                        did = 1;
                        pos += w;
                        break;
                    }
                }
                if (!did) {
                    cout << cnt[1][0].first << ' ' << cnt[1][0].second << endl;
                    put(cnt[1][0].first, cnt[1][0].second);
                }
            } else {
                int x, y;
                cin >> x >> y;
                put(x, y);
            }
            turn ^= 1;
        }

    }
    if (cntOfGame % 2) {
        int x, y;
        cin >> x >> y;
    }
    cout << 0 << endl;
}

void unplay() {
    int n, k, m;
    cin >> n >> k >> m;
    int gamePlayed;
    cin >> gamePlayed;
    string s;
    for(int i = 0; i < gamePlayed; i++) {
        int turn = (i % 2 == 0);
        clean();
        while (!gameIsEnded) {
            if (turn) {
                for(int i = 0; i < M; i++) cnt[i].clear();
                for(int i = n; i >= 1 && size(cnt[1]) < 2; i--) {
                    for(int j = n; j >= 1 && size(cnt[1]) < 2; j--) {
                        if (field[i][j]) continue;
                        int x = get(i, j);
                        if (x < M)
                            cnt[x].emplace_back(i, j);
                    }
                }
                int x, y;
                cin >> x >> y;
                put(x, y);
                pair<int, int> pe = make_pair(x, y);
                for(int i = M - 1; i >= 0; i--) {
                    int w = 0;
                    if (i == 1) w = 1;
                    else w = (1 << (i + 1));
                    if (size(cnt[i]) > 1) {
                        if (cnt[i][0] == pe) {
                            s += string(w, '0');
                            break;
                        } else if (cnt[i].back() == pe){
                            s += string(w, '1');
                            break;
                        }
                    }
                }
            } else {
                int x, y;
                cin >> x >> y;
                put(x, y);
            }
            turn ^= 1;
        }
    }
    while (size(s) > m) s.pop_back();
    reverse(all(s));
    cout << s << endl;
}

int main() {
#ifdef LOCAL
   // freopen("\\\\.\\pipe\\game.in", "r", stdin);
   // freopen("\\\\.\\pipe\\game.out", "w", stdout);
#endif
   // ios::sync_with_stdio(false);
  //  cin.tie(NULL);
    int t;
    cin >> t;
    if (t == 1) play();
    else unplay();
}

