#include <bits/stdc++.h>

using namespace std;


vector< vector<int> > adj;
vector< vector<int> > vals;
vector< vector< tuple<int, int, int> > > dp;

void dfs(int u) {
	if(adj[u].size() == 0) {
		sort(vals[u].begin(), vals[u].end());
		for(int i = 0; i < vals[u].size(); i++) {
			int x = vals[u][i];
			dp[u].emplace_back(x, x, i);
		}
		return;
	}

	sort(adj[u].begin(), adj[u].end());

	for(int v: adj[u]) {
		dfs(v);
	}

	vector< tuple<int, int, int> > selfdp;
	int permid = 0;
	do {
		for(auto [first, _1, _2]: dp[adj[u][0]]) {
			int cur = first;
			bool ok = true;
			for(int v: adj[u]) {
				auto it = lower_bound(dp[v].begin(), dp[v].end(), make_tuple(cur, cur, 0));
				if(it == dp[v].end()) {
					ok = false;
					break;
				}
				cur = get<1>(*it);
			}
			if(ok) {
				selfdp.emplace_back(first, cur, permid);
			}
		}
		permid++;
	} while(next_permutation(adj[u].begin(), adj[u].end()));

	sort(selfdp.begin(), selfdp.end());
	for(auto [l, r, permid]: selfdp) {
		while(dp[u].size() > 0 && get<1>(dp[u].back()) >= r) {
			dp[u].pop_back();
		}
		dp[u].emplace_back(l, r, permid);
	}
}


vector< vector<int> > ans;

int dfsout(int u, int first) {
	if(adj[u].size() == 0) {
		assert(first <= vals[u].back());
		ans[u] = {*lower_bound(vals[u].begin(), vals[u].end(), first)};
		return ans[u][0];
	}

	int permid = get<2>(*lower_bound(dp[u].begin(), dp[u].end(), make_tuple(first, first, 0)));

	sort(adj[u].begin(), adj[u].end());
	for(int i = 0; i < permid; i++) {
		next_permutation(adj[u].begin(), adj[u].end());
	}
	for(int v: adj[u]) {
		ans[u].push_back(v + 1);
		first = dfsout(v, first);
	}
	return first;
}


signed main() {
	int n;
	cin >> n;

	adj.resize(n);
	vals.resize(n);
	for(int i = 0; i < n; i++) {
		int t;
		cin >> t;

		int k;
		cin >> k;

		if(t == 1) {
			for(int j = 0; j < k; j++) {
				int x;
				cin >> x;
				x--;
				adj[i].push_back(x);
			}
		} else {
			for(int j = 0; j < k; j++) {
				int x;
				cin >> x;
				vals[i].push_back(x);
			}
		}
	}

	dp.resize(n);
	dfs(0);

	if(dp[0].size() == 0) {
		cout << "No" << endl;
		return 0;
	}

	cout << "Yes" << endl;
	ans.resize(n);
	dfsout(0, 0);
	for(auto row: ans) {
		for(int x: row) {
			cout << x << " ";
		}
		cout << "\n";
	}

	return 0;
}