#include <iostream>
#include <vector>
#include <set>

bool deletable(std::string str, int32_t k, bool** allow) {
    std::vector<int32_t> candidates = {0};
    for(int32_t i = 1; i < str.size(); i++) {
        bool ok = false;
        for(int32_t j = candidates.size() - 1; j >= 0; j--)
            if( allow[str[candidates[j]] - 'a'][str[i] - 'a']) {
                ok = true;
                for(int32_t p = candidates.size() - 1; p > j; p--)
                    candidates.pop_back();
                break;
            }
        if(!ok)
            return false;
        candidates.push_back(i);
    }
    return true;
}

int main() {
    int32_t k, n;
    std::cin >> k >> n;

    bool** allow = new bool*[k];
    for(int32_t i = 0; i < k; i++) {
        allow[i] = new bool[k];
        std::string str;
        std::cin >> str;

        for(int32_t j = 0; j < k; j++) {
            allow[i][j] = str[j] == '1';
        }
    }

    std::string str;
    std::cin >> str;

    std::pair<std::string, std::string>* dp = new std::pair<std::string, std::string>[n + 1];
    dp[1].first.push_back(str[0]);
    dp[1].second.push_back(str[0]);
    for(int32_t i = 2; i <= n; i++) {
        //the symbol is not deleted
        dp[i].first = std::string (1, (char)('z' + 1));
        for(int32_t suf = 1; suf <= i; suf++)
            dp[i].first = std::min(dp[i].first, dp[i - suf].second + str.substr(i - suf, suf));

        //the symbol IS deleted
        dp[i].second = std::string (1, (char)('z' + 1));
        for(int32_t j = i - 1; j >= 1; j--) {
            if(deletable(str.substr(j - 1, i - j + 1), k, allow))
                dp[i].second = std::min(dp[i].second, dp[j].first);
        }
    }
    std::cout << std::min(dp[n].first, dp[n].second);
    return 0;
}
