#include <iostream>
#include <vector>
#include <set>

int32_t n;
bool* manager;
std::vector<int32_t>* children;
std::vector<int32_t>* offers;
bool* manager_selections;

void merge(std::vector<int32_t>& v1, std::vector<int32_t> v2) {
    for(int32_t i = 0 ; i < v2.size(); i++)
        v1.push_back(v2[i]);
}

std::vector<int32_t> gen_ans(int32_t vertex, int32_t* selections) {
    if(manager[vertex]) {
        if(children[vertex].size() == 1)
            return gen_ans(children[vertex][0], selections);

        std::vector<int32_t> res;
        if(manager_selections[vertex]) {
            res = gen_ans(children[vertex][0], selections);
            merge(res, gen_ans(children[vertex][1], selections));
        } else {
            res = gen_ans(children[vertex][1], selections);
            merge(res, gen_ans(children[vertex][0], selections));
        }
        return res;
    } else
        return {offers[vertex][selections[vertex]]};
}

void enumerate(int32_t step, int32_t target, std::vector<int32_t>& list,
               int32_t* selections) {
    if(step == target) {
        bool check = true;
        std::vector<int32_t> ans = gen_ans(0, selections);

        for(int32_t i = 0; i < ans.size() - 1; i++)
            if(ans[i] > ans[i + 1])
                check = false;

        if(!check)
            return;

        std::cout << "Yes" << "\n";
        for(int32_t i = 0; i < n; i++) {
            if (manager[i]) {
                if(children[i].size() == 1)
                    std::cout << children[i][0] + 1;
                else {
                    if(manager_selections[i])
                        std::cout << children[i][0] + 1 << " " << children[i][1] + 1;
                    else
                        std::cout << children[i][1] + 1 << " " << children[i][0] + 1;
                }
            } else {
                std::cout << offers[i][selections[i]] << " ";
            }
            std::cout << "\n";
        }
        exit(0);
    } else {
        for(int32_t i = 0; i < offers[list[step]].size(); i++) {
            selections[list[step]] = i;
            enumerate(step + 1, target, list, selections);
        }
    }
}

int main() {
    std::cin >> n;

    std::vector<int32_t> managers, leaves;
    children = new std::vector<int32_t>[n];
    offers = new std::vector<int32_t>[n];
    manager = new bool[n];
    for(int32_t i = 0; i < n; i++) {
        int32_t type_cur;
        std::cin >> type_cur;

        manager[i] = type_cur == 1;
        if(type_cur == 1)
            managers.push_back(i);
        else
            leaves.push_back(i);

        if(type_cur == 1) {
            int32_t k;
            std::cin >> k;

            if(k > 2) {
                std::cout << "Yes";
                return 0;
            }

            for(int32_t p = 0; p < k; p++) {
                int32_t child;
                std::cin >> child;
                child--;

                children[i].push_back(child);
            }
        } else {
            int32_t m;
            std::cin >> m;

            for(int32_t j = 0; j < m; j++) {
                int32_t x;
                std::cin >> x;

                offers[i].push_back(x);
            }
        }
    }

    int32_t* selection = new int32_t[n];
    manager_selections = new bool[n];
    for(int32_t i = 0 ; i < (1 << managers.size()); i++) {
        for(int32_t j = 0 ; j < managers.size(); j++)
            manager_selections[managers[j]] = (i & (1 << j)) > 0;
        enumerate(0, leaves.size(), leaves, selection);
    }

    std::cout << "No" << "\n";
    return 0;
}