#include <iostream>
#include <random>

using namespace std;

inline int move(int &x, int &y, int &n, vector <vector <int>> &a) {
    int c = 0;
    for (int i = x; i < n; i++)
        for (int j = y; j < n; j++)
            c += a[i][j], a[i][j] = 0;
    return c;
}

inline void partner(int &n, vector <vector <int>> &a) {
    int x, y;
    cin >> x >> y;
    x--, y--;
    move(x, y, n, a);
}

inline void solve1() {
    random_device rd;
    mt19937 gen(rd());

    int n, k, m, pos = 0;
    cin >> n >> k >> m;
    string s;
    cin >> s;
    for (int w = 0; w < 1e9; w++) {
        vector <vector <int>> a(n, vector <int> (n, 1));
        if (w & 1)
            partner(n, a);
        if (pos == m) {
            cout << 0 << endl;
            break;
        }
        else {
            while (true) {
                vector <vector <int>> cnt(n + 1, vector <int> (n + 1));
                for (int i = n - 1; i >= 0; i--)
                    for (int j = n - 1; j >= 0; j--)
                        cnt[i][j] = cnt[i + 1][j] + cnt[i][j + 1] - cnt[i + 1][j + 1] + a[i][j];
                int c;
                if (cnt[0][0] == 1 || pos == m)
                    c = 1;
                else
                    c = s[pos] - '0' + 1;
                vector <pair <int, int>> cand;
                for (int i = 0; i < n; i++)
                    for (int j = 0; j < n; j++)
                        if (cnt[i][j] == c)
                            cand.emplace_back(i, j);
                if (cand.empty()) {
                    c = 3;
                    for (int i = 0; i < n; i++)
                        for (int j = 0; j < n; j++)
                            if (cnt[i][j] == c)
                                cand.emplace_back(i, j);
                }
                int idx = gen();
                if (idx < 0)
                    idx = -idx;
                idx %= cand.size();
                auto &[x, y] = cand[idx];
                if (pos != m && (x != 0 || y != 0 || c != 1))
                    pos++;
                cout << x + 1 << " " << y + 1 << endl;
                move(x, y, n, a);
                if (a[0][0] == 0)
                    break;
                partner(n, a);
                if (a[0][0] == 0)
                    break;
            }
        }
    }
}

inline void solve2() {
    int n, k, m, c, pos = 0;
    cin >> n >> k >> m >> c;
    string s;
    for (int w = 0; w < c; w++) {
        int x, y;
        vector <vector <int>> a(n, vector <int> (n, 1));
        if (w & 1)
            partner(n, a);
        while (true) {
            cin >> x >> y;
            x--, y--;
            int cc = move(x, y, n, a);
            if (x == 0 && y == 0 && cc == 1)
                break;
            if (pos != m) {
                if (cc == 1)
                    s.push_back('0');
                else
                    s.push_back('1');
                pos++;
            }
            if (a[0][0] == 0)
                break;
            partner(n, a);
            if (a[0][0] == 0)
                break;
        }
    }
    cout << s << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    int k;
    cin >> k;
    if (k == 1)
        solve1();
    else
        solve2();

    return 0;
}
