#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

const int MAX_N = 1337;

vector<int> upgrades[MAX_N];
vector<int> childrens[MAX_N];
int ansLeaves[MAX_N];
bool orient[MAX_N];



const [[gnu::pure]] bool dfs(int v, int leftBound, int rightBound) {
    if (childrens[v].size() == 0) {
        auto x = lower_bound(upgrades[v].begin(), upgrades[v].end(), leftBound);
        if (x == upgrades[v].end()) {
            return false;
        }
        if (*x <= rightBound) {
            ansLeaves[v] = *x;
            return true;
        }
        return false;
    }
    if (childrens[v].size() == 1) {
        return dfs(childrens[v][0], leftBound, rightBound);
    }
    // for (int i = leftBound; i <= rightBound; i++) {
    //     if (dfs(childrens[v][0], leftBound, i) && dfs(childrens[v][1], i, rightBound)) {
    //         // cout << childrens[v][0] << ' ' << childrens[v][1] << endl;
    //         // cout << leftBound << ' ' << i << ' ' << rightBound << endl;
    //         return true;
    //     }
    // }
    int l = leftBound - 1, r = rightBound + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (dfs(childrens[v][0], m, rightBound)) {
            l = m;
        } else {
            r = m;
        }
    }
    if (dfs(childrens[v][1], leftBound, l)) {
        orient[v] = false;
        return true;
    }
    l = leftBound - 1, r = rightBound + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (dfs(childrens[v][1], m, rightBound)) {
            l = m;
        } else {
            r = m;
        }
    }
    if (dfs(childrens[v][0], leftBound, l)) {
        orient[v] = true;
        return true;
    }
    // for (int i = leftBound; i <= rightBound; i++) {
    //     if (dfs(childrens[v][1], leftBound, i) && dfs(childrens[v][0], i, rightBound)) {
    //         // cout << childrens[v][0] << ' ' << childrens[v][1] << endl;
    //         // cout << leftBound << ' ' << i << ' ' << rightBound << endl;
    //         return true;
    //     }
    // }
    return false;
}

int main() {
    int n; cin >> n;
    vector<int> allCoords;
    for (int i = 0; i < n; i++) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            for (int j = 0; j < k; j++) {
                int x; cin >> x; x--;
                childrens[i].push_back(x);
            }
        }
        if (t == 2) {
            int m; cin >> m;
            if (m == 0) {
                cout << "No" << endl;
                return 0;
            }
            for (int j = 0; j < m; j++) {
                int x; cin >> x;
                upgrades[i].push_back(x);
                allCoords.push_back(x);
            }
            sort(upgrades[i].begin(), upgrades[i].end());
        }
    }
    sort(allCoords.begin(), allCoords.end());
    allCoords.resize(unique(allCoords.begin(), allCoords.end()) - allCoords.begin());
    vector<int> invCoord(100228);
    for (int i = 0; i < allCoords.size(); i++) {
        invCoord[allCoords[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        vector<int> newUpgrades;
        for (int k : upgrades[i]) {
            newUpgrades.push_back(invCoord[k]);
        }
        upgrades[i] = newUpgrades;
    }
    if (dfs(0, 0, allCoords.size())) {
        cout << "Yes" << endl;
        for (int i = 0; i < n; i++) {
            if (childrens[i].size() == 2) {
                if (orient[i]) {
                    cout << childrens[i][0] + 1 << ' ' << childrens[i][1] + 1 << endl;
                } else {
                    cout << childrens[i][1] + 1 << ' ' << childrens[i][0] + 1 << endl;
                }
            } else if (childrens[i].size() == 1) {
                cout << childrens[i][0] + 1 << endl;
            } else {
                cout << allCoords[ansLeaves[i]] << endl;
            }
        }
    } else {
        cout << "No" << endl;
    }
}
