#include <bits/stdc++.h>

using namespace std;

void ask(int row, int col) {
  cout << col + 1 << ' ' << row + 1 << endl;
}

pair<int, int> get_move() {
  int col, row;
  cin >> col >> row;
  col--;
  row--;
  cerr << col << ' ' << row << endl;
  return {row, col};
}

void solve1() {
  int n, k, m;
  cin >> n >> k >> m;
  vector<int> msg(m);
  for (int i = 0; i < m; i++) {
    char c;
    cin >> c;
    msg[i] = c - '0';
  }
  int game_cnt = 0;

  vector<vector<int>> field(n, vector<int>(n));
  ask(n - 1, n - 1);
  field[n - 1][n - 1] = 1;

  auto apply = [&](int row, int col) {
    for (int i = row; i < n; i++) {
      for (int j = col; j < n; j++) {
        field[i][j] = 1;
      }
    }
  };

  auto get_and_apply = [&]() -> bool {
    auto [row, col] = get_move();
    if (col == 0 && row == 0)
      return false;
    apply(row, col);
    return true;
  };

  get_and_apply();

  for (int bit = 0; bit < m; bit++) {
    if (game_cnt % 2 == 1) {
      get_and_apply();
    }

    bool found = false;
    for (int row = n - 1; row >= 0; row--) {
      for (int col = n - 1; col >= 0; col--) {
        if (msg[bit] && row > col && field[row][col] == 0) {
          found = true;
          ask(row, col);
          apply(row, col);
          break;
        }

        if (!msg[bit] && col > row && field[row][col] == 0) {
          found = true;
          ask(row, col);
          apply(row, col);
          break;
        }
      }
      if (found)
        break;
    }

    if (!found) {
      ask(0, 0);
      for (int i = 0; i < n; i++)
        field[i].assign(n, 0);
      game_cnt++;
    } else if (game_cnt % 2 == 0) {
      if (!get_and_apply()) {
        for (int i = 0; i < n; i++)
          field[i].assign(n, 0);
        game_cnt++;
      }
    }
  }
  ask(0, 0);
  cout << 0 << endl;
}

void solve2() {
  int n, k, m;
  cin >> n >> k >> m;
  int gcnt;
  cin >> gcnt;
  vector<int> msg;
  for (int game = 0; game < gcnt; game++) {
    int cur = game % 2;
    pair<int, int> cur_move = {-1, -1};
    while (cur_move != make_pair(0, 0)) {
      cur_move = get_move();
      if (cur == 0) {
        if (cur_move.first < cur_move.second)
          msg.push_back(1);
        else if (cur_move.first > cur_move.second)
          msg.push_back(0);
      }
      cur = (cur + 1) % 2;
    }
  }
  for (auto e : msg)
    cout << e;
  cout << endl;
}

signed main() {
  freopen("/tmp/game.in", "r", stdin);
  freopen("/tmp/game.out", "w", stdout);
  int t;
  cin >> t;
  if (t == 1) {
    solve1();
  } else {
    solve2();
  }
  return 0;
}