#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <iomanip>
#include <random>
#include <queue>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define next next228
#define prev prev228
#define all(v) v.begin(), v.end();

const int N = 2002; // may be needed 10000

int k, n;
string s;
bool A[N][N];
bool can[N][N];

void find_can() {
	for (int l = n; l >= 1; --l) {
		for (int r = l; r <= n; ++r) {
			if (l == r) {
				can[l][r] = true;
			} else if (l + 1 == r) {
				if (A[s[l] - 'a'][s[r] - 'a']) {
					can[l][r] = true;
				}
			} else {
				vector< bool > dp(n + 2);
				dp[r + 1] = true;
				for (int i = r; i > l; --i) {
					if (A[s[l] - 'a'][s[i] - 'a']) {
						for (int to = i; to <= r; ++to) {
							if (can[i][to] && dp[to + 1]) {
								dp[i] = true;
								break;
							}
						}
					}
				}
				can[l][r] = dp[l + 1];
			}
		}
	}
}

string lexmin[N];

void solve() {
	find_can();
	for (int i = 0; i <= n; ++i) {
		lexmin[i] = "{";
	}
	lexmin[n + 1] = "";
	string ans = "{";
	for (int i = n; i >= 1; --i) {
		if (i == n) {
			lexmin[i] = "";
			lexmin[i] += s[i];
		} else {
			for (int to = i; to <= n; ++to) {
				if (!can[i][to]) {
					continue;
				}
				string cur = "";
				cur += s[i];
				cur += lexmin[to + 1];

				lexmin[i] = min(lexmin[i], cur);
			}
		}
	}
	cout << lexmin[1] << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> k >> n;

	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			A[i][j] = (c - '0');
		}
	}
	cin >> s;
	s = " " + s;
	solve();
	return 0;
}


/*

3 7
010
001
100
abacaba


3 5
010
001
100
bcacb

*/