#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <iomanip>
#include <random>
#include <queue>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define next next228
#define prev prev228
#define all(v) v.begin(), v.end();

const int N = 2002; // may be needed 10000

int k, n;
string s;
bool A[N][N];
bool can[N][N];
int right[N];

void find_right() {
	for (int l = n; l >= 1; --l) {
		for (int r = l; r <= n; ++r) {
			if (l == r) {
				can[l][r] = true;
			} else if (l + 1 == r) {
				if (A[s[l] - 'a'][s[r] - 'a']) {
					can[l][r] = true;
				}
			} else {
				vector< bool > dp(n + 2);
				dp[r + 1] = true;
				for (int i = r; i > l; --i) {
					if (A[s[l] - 'a'][s[i] - 'a']) {
						for (int to = i; to <= r; ++to) {
							if (can[i][to] && dp[to + 1]) {
								dp[i] = true;
								break;
							}
						}
					}
				}
				can[l][r] = dp[l + 1];
			}
		}
	}

	for (int i = 1; i <= n; ++i) {
		for (int j = i; j <= n; ++j) {
			if (can[i][j]) {
				right[i] = j;
			}
		}
	}
}

string lexmin[N];

void solve() {
	find_right();

	int pos = 1;

	string ans = "";
	while (pos <= n) {
		ans += s[pos];
		if (right[pos] >= n) {
			break;
		}
		char minc = '{';
		for (int i = pos + 1; i <= right[pos] + 1; ++i) {
			if (s[i] < minc) {
				minc = s[i];
			}
		}
		int opt = -1;
		for (int i = pos + 1; i <= right[pos] + 1; ++i) {
			if (s[i] == minc) {
				if (opt == -1 || right[i] > right[opt]) {
					opt = i;
				}
			}
		}
		pos = opt;
	}

	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> k >> n;

	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			A[i][j] = (c - '0');
		}
	}
	cin >> s;
	s = " " + s;
	solve();
	return 0;
}


/*

3 7
010
001
100
abacaba


3 5
010
001
100
bcacb

*/