#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
#include <cmath>

using namespace std;
typedef long long LL;

vector<vector<bool>> canDelete;

bool can_delete(char prev, char next) {
	int id1 = prev - 'a';
	int id2 = next - 'a';
	return canDelete[id1][id2];
}

//newId >= oldId
bool isSubstringLess(string& source, int oldId, int newId) {
	for (int i = 0; i < source.size() - newId; i++)
	{
		if (source[newId + i] < source[oldId + i]) {
			return true;
		}
		else if (source[newId + i] > source[oldId + i]) {
			return false;
		}
	}

	return true;
}

string minimize(string s, char first) {
	if (s.size() == 0) {
		string ans = "";
		ans += first;
		return ans;
	}
	if (can_delete(first, s[0])) {
		int minId = 0;
		int currentId = 0;
		while (can_delete(first, s[currentId])) {
			if (s.size() == currentId + 1) {
				minId = currentId + 1;
				break;
			}
			if (isSubstringLess(s, minId, currentId + 1)) {
				minId = currentId + 1;
			}
			currentId++;
		}

		string ans = "";
		ans += first;
		for (int i = minId; i < s.size(); i++)
		{
			ans += s[i];
		}

		return ans;
	}
	else {
		string ans = "";
		ans += first;
		ans += s;

		return ans;
	}
}

int main() {
	int k, n;
	cin >> k >> n;

	canDelete.resize(k, vector<bool>(k, 0));

	for (int i = 0; i < k; i++)
	{
		string can;
		cin >> can;
		for (int j = 0; j < k; j++)
		{
			canDelete[i][j] = (bool)(can[j] - '0');
		}
	}

	string s;
	cin >> s;

	string current = "";
	for (int i = s.size() - 1; i >= 0; i--)
	{
		current = minimize(current, s[i]);
	}

	cout << current << endl;

	return 0;
}