//#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <cmath>
#include <random>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <array>
#include <cstdio>
#include <climits>

std::vector<std::vector<int>> children;
std::vector<int> type;
std::vector<int> cur;
struct cert
{
	std::vector<int> perm;
	std::vector<cert*> ccerts;
	int min, max;
};
std::vector<cert*> try_cur(int at)
{
	if(type[at] == 2)
	{
		cert* c = new cert { {0}, {}, children[at][cur[at]], children[at][cur[at]] };
		return {c};
	}
	int ccnt = children[at].size();
	std::vector<int> perm(ccnt);
	for(int i = 0; i < ccnt; i++)
		perm[i] = i;
	std::vector<cert*> ans;
	do
	{
		//try all combinations of all outputs, and all permutations
		std::vector<std::vector<cert*>> c_out(ccnt);
		for(int i = 0; i < ccnt; i++)
			c_out[i] = try_cur(children[at][i]);
		std::vector<int> cur(ccnt);
		int64_t time = 1;
		for(auto& v : c_out) time *= v.size();
		for(int i = 0; i < time; i++)
		{
			//try this permutation and these certificates.
			int max = -1000;
			bool ok = true;
			for(int j = 0; j < ccnt; j++)
			{
				cert* cc = c_out[j][cur[j]];
				if(cc->min < max) ok = false;
				max = cc->max;
			}
			if(ok)
			{
				cert* nc = new cert { perm, {}, c_out[0][cur[0]]->min, max };
				nc->ccerts.resize(ccnt);
				for(int j = 0; j < ccnt; j++)
					nc->ccerts[j] = c_out[j][cur[j]];
				ans.push_back(nc);
			}
			for(int j = 0; j < ccnt; j++)
			{
				cur[j]++;
				if(cur[j] == c_out[j].size()) cur[j] = 0; else break;
			}
		}
	} while(std::next_permutation(perm.begin(), perm.end()));
	return ans;
}
int main()
{
	int n; std::cin >> n;
	children.resize(n);
	type.resize(n);
	for(int i = 0; i < n; i++)
	{
		int t, k; std::cin >> t >> k;
		type[i] = t;
		children[i].resize(k);
		for(int& c : children[i]) std::cin >> c, c--;
	}
	//iterate over consultants' actions
	int64_t time = 1;
	for(int i = 0; i < n; i++)
		if(type[i] == 2) time *= children[i].size();
	cur.resize(n);
	for(int i = 0; i < time; i++)
	{
		std::vector<cert*> cs = try_cur(0);
		//printf("%d\n", cs.size());
		if(cs.size() != 0)
		{
			printf("Yes\n");
			return 0;
		}
		for(int j = 0; j < n; j++)
		{
			cur[j]++;
			if(type[j] == 1 || cur[j] >= children[j].size())
				cur[j] = 0;
			else break;
		}
	}
	printf("No\n");
}
