#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int n, m;
string s;

int solve() {
    if (!(cin >> n >> m))
        return 1;
    cin >> s;
    vector<set<int>> cards_bad(n);
    vector<vector<int>> blocking(n);
    vector<vector<int>> cards_for_indices(m);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            blocking[i].emplace_back(p);
            if (s[p] != c) {
                cards_for_indices[p].emplace_back(i);
                cards_bad[i].insert(p);
            }
        }
    }

    priority_queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (cards_bad[i].empty()) {
            q.push(i);
        }
    }
    vector<bool> blocked(m, false);
    vector<int> answer;
    while (!q.empty()) {
        int ind = q.top();
        q.pop();
        answer.emplace_back(ind);
        vector<int> new_free;
        for (int e : blocking[ind]) {
            if (!blocked[e]) {
                new_free.emplace_back(e);
                blocked[e] = true;
            }
        }
        for (int e : new_free) {
            for (int card : cards_for_indices[e]) {
                cards_bad[card].erase(e);
                if (cards_bad[card].empty()) {
                    q.push(card);
                }
            }
        }
    }

    for (bool e : blocked) {
        if (!e) {
            cout << -1 << '\n';
            return 0;
        }
    }
    for (int e : answer) {
        cout << e + 1 << ' ';
    }
    cout << '\n';

    return 0;
}

int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
