#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

const int N = 5e5 + 7;
const int K = 26;

int k, n;
char g[K][K];
int a[N];

string solve() {
  vector<int> cur = {};
  for (int i = n - 1; i >= 0; --i) {
    vector<vector<int>> nxt = {cur};
    vector<int> stack = {a[i]};
    while (!cur.empty()) {
      while (!stack.empty() && !g[stack.back()][cur[0]]) {
        stack.pop_back();
      }
      if (stack.empty()) {
        break;
      }
      stack.push_back(cur[0]);
      cur.erase(cur.begin());
      nxt.push_back(cur);
    }
    sort(ALL(nxt));
    cur = nxt[0];
    cur.insert(cur.begin(), a[i]);
  }
  string res;
  for (int x : cur) {
    res.push_back(x + 'a');
  }
  return res;
}

void gen_test() {
  k = 4;
  n = 7;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      g[i][j] = rand() % 2;
    }
  }
  for (int i = 0; i < n; ++i) {
    a[i] = rand() % k;
  }
}

string stupid_solve(vector<int> arr) {
  string res = "";
  for (int x : arr) {
    res.push_back(x + 'a');
  }
  for (int i = 1; i < SZ(arr); ++i) {
    if (g[arr[i - 1]][arr[i]]) {
      int x = arr[i];
      arr.erase(arr.begin() + i);
      res = min(res, stupid_solve(arr));
      arr.insert(arr.begin() + i, x);
    }
  }
  return res;
}

void print_test() {
  cout << k << ' ' << n << '\n';
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      cout << (int)g[i][j];
    }
    cout << '\n';
  }
  for (int i = 0; i < n; ++i) {
    cout << (char)(a[i] + 'a');
  }
  cout << '\n';
}

void stresstest() {
  int test_n = 1;
  while (true) {
    cout << "TEST #" << test_n++ << '\n';
    gen_test();
    if (solve() != stupid_solve(vector<int>(a, a + n))) {
      cout << "FAIL\n";
      print_test();
      cout << "MY ANS: " << solve() << '\n';
      cout << "R8 ANS: " << stupid_solve(vector<int>(a, a + n)) << '\n';
      system("pause");
    } else {
      cout << "SUCCES\n";
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  // stresstest();
  cin >> k >> n;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      cin >> g[i][j];
      g[i][j] -= '0';
    }
  }
  for (int i = 0; i < n; ++i) {
    char c;
    cin >> c;
    a[i] = c - 'a';
  }
  cout << solve() << '\n';
  return 0;
}
