#include <algorithm>
#include <fstream>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()
#ifdef _DEBUG
#define DEB 1
#else
#define DEB 0
#endif

#if DEB
ifstream in("\\\\.\\pipe\\game.in");
ofstream out("\\\\.\\pipe\\game.out");
#else
#define in cin
#define out cout
#endif

const int M = 1e5 + 7;
const int N = 32;

int n, k, m;
string s;
int field[N][N];
int code[N][N];
int mi = 0;

void ff(int i, int j) {
  for (int x = i; x < N; ++x) {
    for (int y = j; y < N; ++y) {
      field[x][y] = 1;
    }
  }
}

void computer_move() {
  int i, j;
  in >> i >> j;
  --i, --j;
  ff(i, j);
}

int mx_code;

void build_code() {
  mx_code = 0;
  for (int x = N - 1; x >= 0; --x) {
    for (int y = N - 1; y >= 0; --y) {
      if (x == 1 && y == 1) {
        break;
      }
      if (!field[x][y]) {
        code[x][y] = mx_code++;
      } else {
        code[x][y] = -1;
      }
    }
  }
}

int get_h() {
  int res = 0;
  while (res < N && !field[res][0]) {
    ++res;
  }
  return res;
}

int get_w() {
  int res = 0;
  while (res < N && !field[0][res]) {
    ++res;
  }
  return res;
}

void try_win() {
  int h = get_h();
  int w = get_w();
  if (h == w) {
    out << "1 " << h << endl;
    ff(0, h - 1);
  } else if (h < w) {
    out << "1 " << h + 1 << endl;
    ff(0, h);
  } else {
    out << w + 1 << " 1" << endl;
    ff(w, 0);
  }
}

void go_code(int cur_code) {
  for (int x = N - 1; x >= 0; --x) {
    for (int y = N - 1; y >= 0; --y) {
      if (code[x][y] == cur_code) {
        out << x + 1 << ' ' << y + 1 << endl;
        return ff(x, y);
      }
    }
  }
}

void player_move() {
  if (field[1][1]) {
    return try_win();
  }
  build_code();
  if (mx_code <= 1 || mi >= SZ(s)) {
    out << "2 2" << endl;
    ff(1, 1);
    return;
  }
  int b = 0;
  while ((1 << b + 1) - 1 <= mx_code - 1) {
    ++b;
  }
  int cur_code = 0;
  for (int i = 0; i < b; ++i) {
    if (mi >= SZ(s) || s[mi] == '0') {
      ++mi;
    } else {
      cur_code ^= (1 << i);
      ++mi;
    }
  }
  go_code(cur_code);
}

bool is_end() { return field[0][0]; }

void run_game(int player) {
  if (player) {
    computer_move();
  }
  while (!is_end()) {
    player_move();
    computer_move();
  }
}

void clear_all() {
  for (int x = 0; x < N; ++x) {
    for (int y = 0; y < N; ++y) {
      field[x][y] = 0;
    }
  }
}

void solve1() {
  in >> n >> k >> m;
  s.resize(m);
  for (int i = 0; i < m; ++i) {
    in >> s[i];
  }
  int player = 0;
  while (mi < m) {
    run_game(player);
    player ^= 1;
    clear_all();
  }
  if (player) {
    computer_move();
  }
  out << "0" << endl;
}

void player_move2() {
  int i, j;
  cin >> i >> j;
  --i, --j;
  build_code();
  ff(i, j);
  if (!field[1][1]) {
    int b = 0;
    while ((1 << b + 1) - 1 <= mx_code - 1) {
      ++b;
    }
    int cur_code = code[i][j];
    for (int i = 0; i < b; ++i) {
      if (mi < SZ(s)) {
        s[mi] = (cur_code >> i & 1) + '0';
        ++mi;
      }
    }
  }
}

void computer_move2() {
  int i, j;
  cin >> i >> j;
  --i, --j;
  ff(i, j);
}

void run_game2(int player) {
  if (player) {
    computer_move2();
  }
  while (!is_end()) {
    player_move2();
    if (is_end()) {
      break;
    }
    computer_move2();
  }
}

void solve2() {
  cin >> n >> k >> m;
  s.resize(m);
  int cnt_g;
  cin >> cnt_g;
  int player = 0;
  while (cnt_g--) {
    run_game2(player);
    player ^= 1;
    clear_all();
  }
  for (int i = 0; i < m; ++i) {
    cout << s[i];
  }
  cout << endl;
}

int main() {
  /*ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);*/
  int t;
  cin >> t;
  if (t == 1) {
    solve1();
  } else {
    solve2();
  }
  return 0;
}
