#include <algorithm>
#include <cassert>
#include <fstream>
#include <iostream>
#include <numeric>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()
#ifdef _DEBUG
#define DEB 1
#else
#define DEB 0
#endif

const int N = 1e5 + 7;

int n;
vector<int> g[N];
vector<int> all_x;
vector<int> arr[N];
vector<int> dp[N];

void dfs(int v) {
  dp[v].resize(SZ(all_x));
  if (g[v].empty()) {
    sort(ALL(arr[v]));
    assert(!arr[v].empty());
    for (int i = 0; i < SZ(all_x); ++i) {
      int x = i;
      if (arr[v].back() >= x) {
        int y = *lower_bound(ALL(arr[v]), x);
        dp[v][x] = y;
      } else {
        dp[v][x] = -1;
      }
    }
  } else {
    for (int u : g[v]) {
      dfs(u);
    }
    for (int i = 0; i < SZ(all_x); ++i) {
      int x = i;
      dp[v][x] = N;
      vector<int> perm(SZ(g[v]));
      iota(ALL(perm), 0);
      do {
        int y = x;
        for (int j : perm) {
          if (dp[g[v][j]][y] == -1) {
            y = x - 1;
            break;
          } else {
            y = dp[g[v][j]][y];
          }
        }
        if (y != x - 1) {
          dp[v][x] = min(dp[v][x], y);
        }
      } while (next_permutation(ALL(perm)));
      if (dp[v][x] == N) {
        dp[v][x] = -1;
      }
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  cin >> n;
  for (int v = 0; v < n; ++v) {
    int t;
    cin >> t;
    if (t == 1) {
      int k;
      cin >> k;
      while (k--) {
        int u;
        cin >> u;
        --u;
        g[v].push_back(u);
      }
    } else {
      int k;
      cin >> k;
      while (k--) {
        int x;
        cin >> x;
        arr[v].push_back(x);
        all_x.push_back(x);
      }
    }
  }
  sort(ALL(all_x));
  for (int v = 0; v < n; ++v) {
    if (g[v].empty()) {
      for (int& x : arr[v]) {
        x = lower_bound(ALL(all_x), x) - all_x.begin();
      }
    }
  }
  dfs(0);
  if (dp[0][0] == -1) {
    cout << "No\n";
  } else {
    cout << "Yes\n";
  }
  return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/
