#include <bits/stdc++.h>

using namespace std;

void solve();
void stress_solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}

string solve(int n, int k, vector<vector<bool>> a, string s) {
    vector<string> dp(n + 1);
    dp[n] = "";
    for (int i = n - 1; i >= 0; --i) {
        string next = dp[i + 1];
        int mask = 1 << (s[i] - 'a');
        auto can_erase = [mask, k, &a](char c) {
            for (int bit = 0; bit < k; ++bit) if ((mask & (1 << bit)) && a[bit][c - 'a']) return true;
            return false;
        };
        string mn = next;
        for (int j = 0; j < next.size() && can_erase(next[j]); ++j) {
            mask |= 1 << (next[j] - 'a');
            mn = min(mn, next.substr(j + 1, next.size()));
        }
        dp[i] = s[i] + mn;
    }
    return dp[0];
}

string solve_slow(int n, int k, const vector<vector<bool>> &a, const string &s) {
    string ans = s;
    for (int mask = 0; mask < 1 << n; mask += 2) {
        vector<int> erase;
        for (int bit = 0; bit < n; ++bit) {
            if (mask & (1 << bit)) erase.push_back(bit);
        }
        do {
            string t = s;
            vector<int> ord = erase;
            for (int i = 0; i < ord.size(); ++i) {
                int idx = ord[i];
                if (!a[t[idx - 1] - 'a'][t[idx] - 'a']) goto NO;
                t.erase(t.begin() + ord[i]);
                for (int j = i + 1; j < ord.size(); ++j) if (ord[j] > ord[i]) --ord[j];
            }
            ans = min(ans, t);
            NO:;
        } while (next_permutation(erase.begin(), erase.end()));
    }
    return ans;
}

void solve() {
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> a(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c == '1';
        }
    }
    string s;
    cin >> s;
    cout << solve(n, k, a, s) << '\n';
}

void stress_solve() {
    int n = rand() % 6 + 1, k = rand() % 3 + 1;
    vector<vector<bool>> a(k, vector<bool>(k));
    for (auto &row : a) for (auto &&i : row) i = rand() % 2;
    string s;
    for (int i = 0; i < n; ++i) s = s + char('a' + rand() % k);
    if (solve(n, k, a, s) == solve_slow(n, k, a, s))
        solve();
    else {
        cout << k << ' ' << n  << '\n';
        for (auto &row : a) {
            for (auto &&i : row) cout << i;
            cout << '\n';
        }
        cout << s << '\n';
        cout << '\n' << solve(n, k, a, s) << '\n' << solve_slow(n, k, a, s);
    }
}
