#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
#define range(collection) collection.begin(), collection.end()

void solve();

void stress_solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}

struct max_tree {
    int n;
    vector<pair<int, int>> mx;

    explicit max_tree(int n) : n(n), mx(2 * n, {-1e9, -1}) {}

    void set(int i, int x) {
        mx[i + n] = {x, i};
        for (i = (i + n) / 2; i > 0; i /= 2) mx[i] = max(mx[2 * i], mx[2 * i + 1]);
    }

    pair<int, int> _get(int l, int r) {
        auto max = pair{0, -1};
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l & 1) max = ::max(max, mx[l++]);
            if (r & 1) max = ::max(max, mx[--r]);
        }
        return max;
    }

    int get(int l, int r) {
        return _get(l, r).first;
    }

    int get_rightest_index(int l, int r) {
        return _get(l, r).second;
    }

    int operator[](int i) { return mx[i + n].first; }
};

string solve(int n, int k, vector<vector<bool>> a, string s) {
    for (char &c : s) c -= 'a';
    vector<vector<int>> positions(k);
    for (int i = 0; i < s.size(); ++i) positions[s[i]].push_back(i);
    max_tree rightest(n);
    for (int i = 0; i < n; ++i) rightest.set(i, i + 1);
    for (int i = n - 2; i >= 0; --i) {
        int r;
        while ((r = rightest.get(i, rightest[i]), true)) {
            if (rightest[i] >= r + (r < n && a[s[i]][s[r]])) break;
            rightest.set(i, min(r + (r < n && a[s[i]][s[r]]), n));
        }
    }
    vector<bool> down(n);
    vector<max_tree> down_char(k, max_tree(n));
    for (int i = n - 1; i >= 0; --i) {
        if (rightest[i] == n)
            down[i] = true;
        else {
            for (char c = 0; c < s[i]; ++c) {
                if (auto it = upper_bound(range(positions[c]), i); it != positions[c].end()) {
                    if (*it <= rightest[i]) {
                        down[i] = true;
                        down_char[s[i]].set(i, true);
                        break;
                    }
                }
            }
            if (down_char[s[i]].get(i + 1, rightest[i] + 1)) {
                down[i] = true;
                down_char[s[i]].set(i, true);
                break;
            }
        }
        if (!down[i]) down_char[s[i]].set(i, false);
    }
    string r;
    int i = 0;
    while (i != n) {
        r += s[i];
        if (rightest[i] == n) break;
        for (char c = 0; c < k; ++c) {
            if (down_char[c].get(i + 1, rightest[i] + 1) == 1) {
                i = down_char[c].get_rightest_index(i + 1, rightest[i] + 1);
                goto NEXT;
            }
            if (auto it = upper_bound(range(positions[c]), rightest[i]); it != positions[c].begin()) {
                --it;
                if (*it > i) {
                    i = *it;
                    goto NEXT;
                }
            }
        }
        NEXT:;
    }
    for (auto &c : r) c += 'a';
    return r;
}

string solve_slow(int n, int k, const vector<vector<bool>> &a, const string &s) {
    string ans = s;
    for (int mask = 0; mask < 1 << n; mask += 2) {
        vector<int> erase;
        for (int bit = 0; bit < n; ++bit) {
            if (mask & (1 << bit)) erase.push_back(bit);
        }
        do {
            string t = s;
            vector<int> ord = erase;
            for (int i = 0; i < ord.size(); ++i) {
                int idx = ord[i];
                if (!a[t[idx - 1] - 'a'][t[idx] - 'a']) goto NO;
                t.erase(t.begin() + ord[i]);
                for (int j = i + 1; j < ord.size(); ++j) if (ord[j] > ord[i]) --ord[j];
            }
            ans = min(ans, t);
            NO:;
        } while (next_permutation(erase.begin(), erase.end()));
    }
    return ans;
}

void solve() {
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> a(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c == '1';
        }
    }
    string s;
    cin >> s;
    cout << solve(n, k, a, s) << '\n';
}

void stress_solve() {
    int n = rand() % 7 + 1, k = rand() % 4 + 1;
    vector<vector<bool>> a(k, vector<bool>(k));
    for (auto &row : a) for (auto &&i : row) i = rand() % 2;
    string s;
    for (int i = 0; i < n; ++i) s = s + char('a' + rand() % k);
    if (solve(n, k, a, s) == solve_slow(n, k, a, s))
        solve();
    else {
        cout << k << ' ' << n << '\n';
        for (auto &row : a) {
            for (auto &&i : row) cout << i;
            cout << '\n';
        }
        cout << s << '\n';
        cout << '\n' << solve(n, k, a, s) << '\n' << solve_slow(n, k, a, s);
    }
}
