#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef long double ld;

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto& e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    solve();
}

const int MAX_K = 30;
typedef bitset<MAX_K> bits;

int k, n;

pair<bool, ll> canBeCut(int l, int r,
                        vector<bits>& matrixHorizontally,
                        vector<bits>& matrixVertically,
                        vector<int>& d) {
    if (l == r)
        return {true, 1ll << d[r - 1]};

    auto [ok, val] = canBeCut(l, r - 1, matrixHorizontally, matrixVertically, d);
    if (matrixHorizontally[d[r - 2]][d[r - 1]]) {
        return {ok, val | (1ll << d[r - 1])};
    }
    ll o = val & matrixVertically[d[r - 1]].to_ullong();
    return {ok && o != 0, o | (1ll << d[r - 1])};
}

void solve() {
    cin >> k >> n;
    vector<bits> matrixHorizontally(k);
    vector<bits> matrixVertically(k);
    vector<string> ff(k);
    cin >> ff;

    for (int i = 0; i < k; i++)
        for (int j = 0; j < k; j++)
            matrixHorizontally[i][j] = ff[i][j] == '1';
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++)
            matrixVertically[j][i] = ff[i][j] == '1';
    }

    string s;
    cin >> s;
    vector<int> d(n);
    for (int i = 0; i < n; i++)
        d[i] = s[i] - 'a';
    string built = {s[0]};
    int idx = 1;
    while (idx < n) {
        char mi = s[idx];
        int mIndex = idx;
        for (int inPlace = idx + 1; inPlace <= n; inPlace++) {
            auto [ok, val] = canBeCut(idx, inPlace, matrixHorizontally, matrixVertically, d);
            assert(val >= 0);
            if (!ok) {
                break;
            }

            if (inPlace == n) {
                cout << built << '\n';
                return;
            }

            if (s[inPlace] <= mi) {
                mi = s[inPlace];
                mIndex = inPlace;
            }
        }
        built += mi;
        idx = mIndex + 1;
    }
    cout << built << '\n';
}