#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<int> g[100009];
bool leaf[100009];

pii choice[100009];
vector<int> leaves;

void dfs(int v) {
    if (leaf[v]) return;
    vector<pii> ao;
    for (auto u : g[v]) {
        dfs(u);
        ao.push_back(choice[u]);
    }

    sort(ao.begin(), ao.end());
    if (ao[0].x == -1000) {
        choice[v] = {-1000, 0};
        return;
    }

    int l = -1, r = -1;
    for (int i = 0; i < ao.size(); i++) {
        if (ao[i].x == -1) continue;
        if (i > 0 && ao[i].x <= ao[i - 1].y) {
            choice[v] = {-1000, 0};
            return;
        }

        if (l == -1) {
            l = ao[i].x;
        }

        r = max(r, ao[i].y);
    }

    choice[v] = {l, r};
}

vector<int> order[100009];
void dfs2(int v) {
    if (leaf[v]) return;
    vector<pair<pii, int>> ao;
    for (auto u : g[v]) {
        dfs2(u);
        ao.push_back({choice[u], u});
    }

    sort(ao.begin(), ao.end());
    if (ao[0].x.x == -1000) {
        choice[v] = {-1000, 0};
        return;
    }

    int l = -1, r = -1;
    for (int i = 0; i < ao.size(); i++) {
        order[v].push_back(ao[i].y);
        if (ao[i].x.x == -1) continue;
        if (i > 0 && ao[i].x.x <= ao[i - 1].x.y) {
            choice[v] = {-1000, 0};
            return;
        }

        if (l == -1) {
            l = ao[i].x.x;
        }

        r = max(r, ao[i].x.y);

    }

    choice[v] = {l, r};
}

    int n;
const ld timee = 2.9 * CLOCKS_PER_SEC;
void gen(int num) {
    if (clock() > timee) {
        cout << "No\n";
        exit(0);
    }

    if (num == leaves.size()) {
        cout << "Yes\n";
        dfs2(1);

        for (int i = 1; i <= n; i++) {
            if (leaf[i]) {
                cout << choice[i].x << "\n";
            }

            else {
                for (auto u : order[i]) {
                    cout << u << ' ';
                }
                cout << "\n";
            }
        }

        exit(0);
    }

    for (auto u : g[leaves[num]]) {
        choice[leaves[num]] = {u, u};
        dfs(1);
        if (choice[1].x != -1000) {
            gen(num + 1);
        }
    }

    choice[leaves[num]] = {-1, -1};
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    cin >> n;

    for (int i = 1; i <= n; i++) {
        int t;
        cin >> t;

        if (t == 2) {leaf[i] = 1; leaves.push_back(i);}

        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;

            g[i].push_back(x);
        }

        sort(g[i].begin(), g[i].end());
    }

    for (auto u : leaves) {
        choice[u] = {-1, -1};
    }

    gen(0);
    cout << "No\n";

    return 0;
}

