#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n), jobs(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int u;
                cin >> u;
                u--;
                g[i].pb(u);
            }
            sort(all(g[i]));
        } else {
            int m;
            cin >> m;
            while (m--) {
                int x;
                cin >> x;
                jobs[i].pb(x);
            }
            sort(all(jobs[i]));
        }
    }

    vector<vector<pii>> dp(n);
    int l0;

    function<void(int, int, int)> gen = [&](int i, int lst, int v) {
        if (i == g[v].size()) {
            dp[v].pb({l0, lst});
            return;
        }
        for (auto p : dp[g[v][i]]) {
            if (p.first < lst) {
                continue;
            }
            if (i == 0) {
                l0 = p.first;
            }
            gen(i + 1, p.second, v);
        }
    };

    function<void(int)> dfs = [&](int v) {
        if (g[v].empty()) {
            for (int x : jobs[v]) {
                dp[v].push_back({x, x});
            }
            return;
        }
        for (auto u : g[v]) {
            dfs(u);
        }
        do {
            gen(0, -1, v);
        } while (next_permutation(all(g[v])));
//        sort(all(dp[v]));
//        vector<pii> res;
//        for (auto p : dp[v]) {
//            while (!res.empty() and res.back().second > p.second) {
//                res.pop_back();
//            }
//            res.pb(p);
//        }
//        dp[v] = res;
    };

    dfs(0);
    if (dp[0].empty()) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
