#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <array>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <random>
#include <chrono>
#include <time.h>
#include <limits>
#include <cmath>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

template<typename T1, typename T2> ostream& operator<< (ostream& out, const pair<T1, T2>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 32;

int a[N][N];

int first = 1;
int turn = 1;
int nw = 1;

void color(int x, int y) {
	for (int i = x; i < N; i++) {
		for (int j = y; j < N; j++) {
			a[i][j] = 1;
		}
	}
}

void reset() {
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			a[i][j] = 0;
		}
	}
}

void read() {
	nw = 0;
	int x, y;
	cin >> x >> y;
	x--, y--;
	color(x, y);
	turn ^= 1;
	if (x == 0 && y == 0) {
		first ^= 1;
		turn = first;
		reset();
		nw = 1;
	}
}

void move(int x, int y) {
	nw = 0;
	dbg(x);
	dbg(y);
	assert(a[x][y] == 0);
	color(x, y);
	cout << x + 1 << " " << y + 1 << endl;
	turn ^= 1;
	if (x == 0 && y == 0) {
		first ^= 1;
		turn = first;
		reset();
		nw = 1;
	}
}

pair<int, int> find_move(int c) {
	pair<int, int> ans = {-1, -1};
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			if (i == 0 && j == 0) continue;
			if (a[i][j] == 0 && ((i + j) & 1) == c && (ans.first == -1 || i + j > ans.first + ans.second)) {
				ans = {i, j};
			}
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	int n, m, k;
	cin >> n >> k >> m;
	if (t == 1) {
		string s;
		cin >> s;
		for (int i = 0; i < m; i++) {
			dbg(i);
			while (!turn) {
				read();
			}
			pii have = find_move(s[i] - '0');
			while (have.first == -1) {
				move(0, 0);
				while (!turn) read();
				have = find_move(s[i] - '0');
			}
			move(have.first, have.second);
		}
		if (!nw) {
			while (!turn) {
				read();
			}
			move(0, 0);
		}
		cout << 0 << endl;
	} else {
		string ans;
		int w;
		cin >> w;
		for (int i = 0; i < w; i++) {
			pii have;
			cin >> have.first >> have.second;
			// dbg(ans);
			int turn = (i % 2) ^ 1;
			while (have.first != 1 || have.second != 1) {
				if (turn) {
					// dbg(ans);
					// dbg(have);
					ans.pb(char('0' + (have.first + have.second) % 2));
				}
				turn ^= 1;
				cin >> have.first >> have.second;
			}
		}
		cout << ans << "\n";
	}
}
/*

*/