#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

int main() {
	ll n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	v<v<pa<ll, char>>> a(n);
	for (ll i = 0; i < n; ++i) {
		ll k;
		cin >> k;
		a[i] = v<pa<ll, char>>(k);
		for (ll j = 0; j < k; ++j) {
			ll aij;
			char cij;
			cin >> aij >> cij;
			--aij;
			a[i][j] = { aij, cij };
		}
	}
	v<set<ll>> bad_perfo_poses(n);
	v<v<ll>> bad_perfo_columns(m);
	for (ll i = 0; i < n; ++i) {
		for (auto [pos, ch] : a[i]) {
			if (s[pos] != ch) {
				bad_perfo_poses[i].insert(pos);
				bad_perfo_columns[pos].push_back(i);
			}
		}
	}
	v<ll> perfos;
	ll cppos = 0;
	for (ll i = 0; i < n; ++i) {
		if (bad_perfo_poses[i].size() == 0) {
			perfos.push_back(i);
		}
	}
	v<bool> has_column(m);
	v<bool> has_perfo(n);
	while (cppos < perfos.size()) {
		ll x = perfos[cppos];
		for (auto [pos, ch] : a[x]) {
			if (!has_column[pos]) {
				has_column[pos] = true;
				for (ll b_p : bad_perfo_columns[pos]) {
					bad_perfo_poses[b_p].erase(pos);
					if (bad_perfo_poses[b_p].size() == 0 && !has_perfo[b_p]) {
						has_perfo[b_p] = true;
						perfos.push_back(b_p);
					}
				}
			}
		}
		++cppos;
	}
	if (count(has_column.begin(), has_column.end(), true) == m) {
		for (ll x : perfos) {
			cout << (x + 1) << ' ';
		} 
	}
	else {
		cout << -1;
	}
}