#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

using ll = int;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<ll> go[26];
v<ll> mi[26];
v<ll> imi;

ll create_trie() {
	ll ind = imi.size();
	for (ll i = 0; i < 26; ++i) {
		go[i].push_back(-1);
		mi[i].push_back(-1);
	}
	imi.push_back(-1);
	return ind;
}

ll add_string(ll trie, const string& s, ll index, ll pos = 0) {
	if (pos == s.size()) {
		if (imi[trie] == -1 || index < imi[trie]) {
			return imi[trie] = index;
		}
		else {
			return imi[trie];
		}
	}
	else {
		if (go[s[pos] - 'a'][trie] == -1) {
			go[s[pos] - 'a'][trie] = create_trie();
		}
		if (mi[s[pos] - 'a'][trie] == -1) {
			return mi[s[pos] - 'a'][trie] = add_string(go[s[pos] - 'a'][trie], s, index, pos + 1);
		}
		else {
			return mi[s[pos] - 'a'][trie] = min(mi[s[pos] - 'a'][trie], add_string(go[s[pos] - 'a'][trie], s, index, pos + 1));
		}
	}
}

ll get_mi_str(ll trie, ll mai) {
	if (imi[trie] != -1 && imi[trie] < mai) {
		return imi[trie];
	}
	else {
		for (ll i = 0; i < 26; ++i) {
			if (mi[i][trie] != -1 && mi[i][trie] < mai) {
				return get_mi_str(go[i][trie], mai);
			}
		}
		return -1;
	}
}

int main() {
	fill(go, go + 26, v<ll>());
	fill(mi, mi + 26, v<ll>());
	ll root = create_trie();
	/*while (true) {
		ll t;
		cin >> t;
		if (t == 0) {
			string s;
			ll i;
			cin >> s >> i;
			cout << add_string(root, s, i) << endl;
		}
		else {
			ll mai;
			cin >> mai;
			cout << get_mi_str(root, mai) << endl;
		}
	}*/
	ll k, n;
	cin >> k >> n;
	v<v<bool>> A(k, v<bool>(k));
	for (ll i = 0; i < k; ++i) {
		for (ll j = 0; j < k; ++j) {
			char Aij;
			cin >> Aij;
			A[i][j] = Aij == '1';
		}
	}
	string s;
	cin >> s;
	v<ll> macan(n);
	macan[n - 1] = 0;
	for (ll i = n - 2; i >= 0; --i) {
		ll csize = 0;
		while (i + csize + 1 < n && A[s[i] - 'a'][s[i + csize + 1] - 'a']) {
			csize += macan[i + csize + 1] + 1;
		}
		macan[i] = csize;
	}
	v<string> mi_str(n + 1);
	mi_str[n - 1] = string(1, s[n - 1]);
	add_string(root, mi_str[n - 1], n - 1);
	add_string(root, "", n);
	for (ll i = n - 2; i >= 0; --i) {
		mi_str[i] = string(1, s[i]) + mi_str[i + 1];
		ll msi = get_mi_str(root, macan[i] + i + 2);
		if (msi != -1) {
			mi_str[i] = min(mi_str[i], string(1, s[i]) + mi_str[msi]);
		}
		add_string(root, mi_str[i], i);
	}
	/*for (ll i = 0; i < n; ++i) {
		cout << mi_str[i] << '\n';
	}*/
	cout << mi_str[0];
}