#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

using ll = int;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

ll n, k, m;
v<v<bool>> table;

ll game = 0;

void paint(ll i, ll j) {
	for (ll x = 0; x <= i; ++x) {
		for (ll y = j; y < n; ++y) {
			table[x][y] = true;
		}
	}
}

bool played = false;

void print(ll i, ll j) {
	played = true;
	cout << (i + 1) << ' ' << (j + 1) << endl;
	paint(i, j);
	if (i == table.size() - 1 && j == 0) {
		played = false;
		++game;
		table = v<v<bool>>(n, v<bool>(n));
		if (game & 1) {
			ll x, y;
			cin >> x >> y;
			--x;
			--y;
			paint(x, y);
		}
	}
	else {
		ll x, y;
		cin >> x >> y;
		--x;
		--y;
		paint(x, y);
		if (x == table.size() - 1 && y == 0) {
			played = false;
			++game;
			table = v<v<bool>>(n, v<bool>(n));
			if (game & 1) {
				ll x, y;
				cin >> x >> y;
				--x;
				--y;
				paint(x, y);
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll type;
	cin >> type;
	cin >> n >> k >> m;
	if (type == 1) {
		string s;
		cin >> s;
		table = v<v<bool>>(n, v<bool>(n));
		ll pos = 0;
		while (pos < n) {
			bool done = false;
			for (ll i = n - 1; i >= 0; --i) {
				for (ll j = n - 1; j >= 0; --j) {
					if (((i + j) & 1) == (s[pos] - '0')) {
						if (i != n - 1 || j != 0) {
							if (!table[i][j]) {
								print(i, j);
								++pos;
								done = true;
								break;
							}
						}
					}
				}
			}
			if (!done) {
				print(n - 1, 0);
			}
		}
		if (played) {
			print(n - 1, 0);
		}
		cout << 0 << endl;
	}
	else {
		ll games;
		cin >> games;
		string res(m, ' ');
		ll pos = 0;
		for (ll game = 0; game < games; ++game) {
			v<pa<ll, ll>> actions;
			ll cx = -1, cy = -1;
			do {
				cin >> cx >> cy;
				--cx;
				--cy;
				actions.push_back({ cx, cy });
			} while (cx != n - 1 || cy != 0);
			for (ll i = 0; i < actions.size() - 1; ++i) {
				if ((i & 1) == (game & 1)) {
					auto [x, y] = actions[i];
					if (pos < res.size()) {
						res[pos] = ((x + y) & 1) + '0';
						++pos;
					}
				}
			}
		}
		cout << res << endl;
	}
}