#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <tuple>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

const ll SZ = 40, K = 30;

bool grid[SZ][SZ];
ll n, k, m;

void clr() {
	for (int i = 0; i < SZ; i++) {
		for (int j = 0; j < SZ; j++) grid[i][j] = 0;
	}
}

ll calc(int x, int y) {
	ll cnt = 0;

	for (int i = n; i >= x; i--) {
		for (int j = n; j >= y; j--) {
			if (grid[i][j] == 0) cnt++;
		}
	}

	return cnt;
}

void paint(int x, int y) {
	for (int i = n; i >= x; i--) {
		for (int j = n; j >= y; j--) {
			grid[i][j] = 1;
		}
	}
}

void sol1() {
	cin >> n >> k >> m;
	string s;
	cin >> s;

	ll it = 0, hd = 0;
	while (true) {
		clr();

		if (it == s.size()) {
			break;
		}
		if (hd) {
			pair<ll, ll> ans;
			cin >> ans.first >> ans.second;
			paint(ans.first, ans.second);
			if (ans == make_pair(1ll, 1ll)) continue;
		}

		hd = !hd;
		
		
		while (true) {
			if (it == s.size()) {
				cout << "1 1" << endl;
				break;
			}
			vector<tuple<int, int, int>> pnt;
			for (int i = n; i >= 1; i--) {
				for (int j = n; j >= 1; j--) {
					if (!grid[i][j] && ((i + j) % 2 == (s[it] - '0')) && ((i != 0 || j != 0))) pnt.push_back({ calc(i, j), i, j });
				}
			}

			if (pnt.size() == 0) {
				cout << "1 1" << endl;
				break;
			}

			it++;
			sort(pnt.begin(), pnt.end());

			ll val = rand() % min(int(pnt.size()), 5);

			pair<ll, ll> cur = { get<1>(pnt[val]), get<2>(pnt[val]) };

			paint(cur.first, cur.second);

			cout << cur.first << " " << cur.second << endl;

			pair<ll, ll> ans;
			cin >> ans.first >> ans.second;
			paint(ans.first, ans.second);
			if (ans == make_pair(1ll, 1ll)) {
				break;
			}
		}
	}

	cout << "0" << endl;
	exit(0);
}

/*
1
32 8 16
1111000011110000
*/
void sol2() {
	cin >> n >> k >> m;
	ll g;
	cin >> g;

	string ans;
	ll it = 0, hd = 0;
	while (g--) {
		if (hd) it = !it;
		hd = !hd;
		while (true) {
			pair<ll, ll> pos;
			cin >> pos.first >> pos.second;

			if (pos == make_pair(1ll, 1ll)) {
				it = 0;
				break;
			}

			if (it == 0) {
				ans.push_back((pos.first + pos.second) % 2 + '0');
			}

			it = !it;
		}
	}

	cout << ans << endl;
	exit(0);
}

int main() {
	//fastInp;
	/*freopen("\\\\.\\pipe\\game.in", "r", stdin);
	freopen("\\\\.\\pipe\\game.out", "w", stdout);*/

	ll t;
	cin >> t;

	if (t == 1) {
		return 1;
		sol1();
		
	}
	else {
		sol2();
	}

	return 0;
}