#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;
#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef int ll;
typedef long double ld;

const ll SZ = 110, INF = 1e9;

ll n;
vector<vector<ll>> tree;
int vals[SZ][SZ];
vector<ll> shr;
map<ll, ll> to;

void dfs(int v) {
	if (tree[v].size() == 0) return;
	for (auto to : tree[v]) {
		dfs(to);
	}

	vector<ll> perm;
	for (int i = 0; i < tree[v].size(); i++) {
		perm.push_back(i);
	}

	if (v == 0) {
		cout << "";
	}
	do {
		ll prev = -1, st;
		for (int c = 0; c < SZ; c++) {
			if (vals[tree[v][perm[0]]][c] != INF) {
				st = c;
				prev = vals[tree[v][perm[0]]][c];
				ll nxt = INF;
				for (int j = 1; j < perm.size(); j++) {
					nxt = INF;
					for (int c2 = prev + 1; c2 < SZ; c2++) {
						nxt = min(nxt, vals[tree[v][perm[j]]][c2]);
					}
					prev = nxt;
				}

				vals[v][c] = min(vals[v][c], prev);
				if (prev != INF) {
					cout << "";
				}
			}
		}
	} while (next_permutation(perm.begin(), perm.end()));
}

vector<ll> sv[SZ];
int main() {
	fastInp;

	cin >> n;

	tree.resize(n);

	for (int i = 0; i < SZ; i++) {
		for (int j = 0; j < SZ; j++) vals[i][j] = INF;
	}
	for (int i = 0; i < n; i++) {
		ll t;
		cin >> t;

		if (t == 1) {
			ll k;
			cin >> k;
			for (int j = 0; j < k; j++) {
				ll nm;
				cin >> nm;
				nm--;
				tree[i].push_back(nm);
			}
		}
		else {
			ll k;
			cin >> k;

			for (int j = 0; j < k; j++) {
				ll t;
				cin >> t;
				shr.push_back(t);
				sv[i].push_back(t);
			}
		}
	}

	sort(shr.begin(), shr.end());
	auto it = unique(shr.begin(), shr.end());

	shr.erase(it, shr.end());

	for (int i = 0; i < shr.size(); i++) to[shr[i]] = i + 1;

	for (int i = 0; i < SZ; i++) {
		for (auto k : sv[i]) {
			vals[i][to[k]] = to[k];
		}
	}
	dfs(0);

	bool fl = 0;

	for (int i = 0; i < SZ; i++) {
		if (vals[0][i] < INF) {
			fl = 1;
		}
	}
	if (fl) {
		cout << "Yes";
	}
	else {
		cout << "No";
	}

	return 0;
}

/*
6
1 3 2 3 4
2 1 5
2 1 3
1 2 5 6
2 1 4
2 1 7

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3

6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/