#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

using namespace std;

const int MAX_MEM = 6e8;
char mem[MAX_MEM];
int m_pos = 0;

void* operator new(size_t n) {
    assert((m_pos += n) <= MAX_MEM);
    return (void*) (mem + m_pos - n);
}

void operator delete(void*) noexcept { }

#define int long long
const int SZ = 1e5 + 4;

int k, n;
int a[26][26];
string s;

void read() {
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    cin >> s;
}

set<int> kek;
int d = 0;

void del(int cur, int l) {
    auto it = kek.lower_bound(cur);
    if (it == kek.begin()) {
        if (a[s[l] - 'a'][s[cur] - 'a']) {
            ++d;

            ++it;
            if (it == kek.end()) {
                kek.erase(cur);
                return;
            }
            int x = *it;

            kek.erase(cur);

            del(x, l);
        }
    } else {
        --it;
        int j = *it;
        ++it;
        if (a[s[j] - 'a'][s[cur] - 'a']) {
            ++d;

            ++it;
            if (it == kek.end()) {
                kek.erase(cur);
                return;
            }
            int x = *it;

            kek.erase(cur);

            del(x, l);
        }
    }
}

bool check(int l, int r) {
    assert(l > 0);
    kek.clear();
    d = 0;
    for (int i = l; i <= r; ++i) {
        kek.insert(i);
    }

    for (int i = r; i >= l; --i) {
        del(i, l - 1);
    }

    if (d == r - l + 1) {
        return true;
    }

    return false;
}

bool used[SZ];
map<char, vector<int>> g[SZ];
vector<int> t;

void dfs(int u) {
    used[u] = true;
    for (int v : g[u].begin()->second) {
        if (!used[v]) dfs(v);
    }
    t.push_back(u);
}

void solve() {
    for (int i = 0; i < n; ++i) {
        int lo = i, hi = n;
        while (hi - lo > 1) {
            int m = lo + ((hi - lo) >> 1);
            if (check(i + 1, m)) {
                lo = m;
            } else {
                hi = m;
            }
        }

        if (lo == n - 1) {
            continue;
        }

        for (int j = i + 1; j <= lo + 1; ++j) {
            g[i][s[j]].push_back(j);
        }
    }

    dfs(0);
    vector<string> ans(n, "$");
    for (int i : t) {
        if (g[i].empty()) {
            ans[i] = "";
            continue;
        }
        for (int v : g[i].begin()->second) {
            if (ans[i] == "$" || ans[i] > g[i].begin()->first + ans[v]) {
                ans[i] = g[i].begin()->first + ans[v];
            }
        }
    }

    cout << s[0] + ans[t.back()] << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
