#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

using namespace std;

const int MAX_MEM = 6e8;
char mem[MAX_MEM];
int m_pos = 0;

void* operator new(size_t n) {
    assert((m_pos += n) <= MAX_MEM);
    return (void*) (mem + m_pos - n);
}

void operator delete(void*) noexcept {}

#define int long long
const int SZ = 1e5 + 4;

int n;
vector<int> g[SZ];
int x[SZ];
map<pair<int, int>, vector<pair<int, int>>> ans[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
        if (x[i] == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int v;
                cin >> v;
                --v;
                g[i].push_back(v);
            }
        } else {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int y;
                cin >> y;
                ans[i][{y, y}] = {{-1, -1}};
            }
        }
    }
}

set<pair<int, int>> p;
vector<pair<int, int>> tmp;

void rec(int u, int i) {
    if (i == g[u].size()) {
        ans[u][{p.begin()->first, p.rbegin()->second}] = tmp;
        return;
    }

    for (auto [z, v] : ans[g[u][i]]) {
        bool zz = true;
        if (!p.empty()) {
            auto it = p.lower_bound(z);
            if (it != p.end()) {
                zz &= it->first > z.second;
            }
            if (it != p.begin()) {
                --it;
                zz &= it->second < z.first;
            }
        }

        if (zz) {
            p.insert(z);
            tmp.push_back(z);
            rec(u, i + 1);
            p.erase(z);
            tmp.pop_back();
        }
    }
}

void dfs(int u) {
    if (x[u] == 2) return;
    for (int v : g[u]) {
        dfs(v);
    }
    rec(u, 0);
}

vector<int> res[SZ];
void make_res(int u, pair<int, int> p) {
    if (x[u] == 2) {
        res[u].push_back(p.first);
        return;
    }
    set<pair<int, int>> s;
    for (int i = 0; i < g[u].size(); ++i) {
        int v = g[u][i];
        make_res(v, ans[u][p][i]);
        s.insert({ans[u][p][i].first, v});
    }

    for (auto v : s) {
        res[u].push_back(v.second);
    }
}

void solve() {
    dfs(0);
    if (!ans[0].empty()) {
        cout << "Yes\n";
        make_res(0, ans[0].begin()->first);
        for (int i = 0; i < n; ++i) {
            if (x[i] == 1) {
                for (int j : res[i]) {
                    cout << j + 1 << " ";
                }
            } else {
                cout << res[i][0];
            }
            cout << "\n";
        }
    } else {
        cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
