#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <ctime>
#include <queue>
#include <deque>
#include <fstream>
#include <iomanip>
#include <bitset>
// #pragma GCC optimize("O2,O3,Ofast")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
int n, k, m;


void print(const vector<int>& A) {
    for (int el : A) {
        cout << el;
    }
    cout << endl;
}


const int N = 32;
const int M = 1e5;
vector<vector<bool>> F;


void make_turn(int x, int y) {
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            int x_ = x + i;
            int y_ = y + j;
            if (x_ > n || y_ > n) {
                continue;
            }
            F[x_][y_ ] = true;
        }
    }
}


int i = 0;
string s;


void play_game(bool first) {
    F = vector<vector<bool>> (n + 1, vector<bool>(n + 1, false));
    if (!first) {
        int x, y;
        cin >> x >> y;
        make_turn(x, y);
    }
    int a = n, b = n, c = n, d = n;
    while (true) {
        if (i == m) {
            cout << "1 1" << endl;
            return;
        }
        while (F[a][b]) {
            if (a == 1) {
                a = n;
                --b;
            } else {
                --a;
            }
        }
        while (F[c][d]) {
            if (d == 1) {
                d = n;
                --c;
            } else {
                --d;
            }
        }
        //
        int x, y;
        if (s[i] == '0') {
            x = a;
            y = b;
        } else {
            x = c;
            y = d;
        }
        if (a != c || b != d) {
            ++i;
        }
        cout << x << " " << y << endl;
        make_turn(x, y);
        if (x == 1 && y == 1) {
            return;
        }
        cin >> x >> y;
        make_turn(x, y);
        if (x == 1 && y == 1) {
            return;
        }
    }
}


void solve1() {
    cin >> s;
    bool first = true;
    while (i != m) {
        play_game(first);
        first = !first;
    }
    cout << "0" << endl;
}


string res;


void play_game2(bool first) {
    F = vector<vector<bool>> (n + 1, vector<bool>(n + 1, false));
    if (!first) {
        int x, y;
        cin >> x >> y;
        make_turn(x, y);
    }
    int a = n, b = n, c = n, d = n;
    while (true) {
        if (res.size() == m) {
            int o, p;
            cin >> o >> p;
            return;
        }
        while (F[a][b]) {
            if (a == 1) {
                a = n;
                --b;
            } else {
                --a;
            }
        }
        while (F[c][d]) {
            if (d == 1) {
                d = n;
                --c;
            } else {
                --d;
            }
        }
        //
        int x, y;
        if (s[i] == '0') {
            x = a;
            y = b;
        } else {
            x = c;
            y = d;
        }
        cin >> x >> y;
        if (a != c || b != d) {
            if (x == a && y == b) {
                res.push_back('0');
            } else {
                res.push_back('1');
            }
        }
        make_turn(x, y);
        if (x == 1 && y == 1) {
            return;
        }
        cin >> x >> y;
        make_turn(x, y);
        if (x == 1 && y == 1) {
            return;
        }
    }
}


void solve2() {
    int z;
    cin >> z;
    bool first = true;
    for (int j = 0; j < z; ++j) {
        play_game2(first);
        first = !first;
    }
    cout << res << endl;
}


signed main() {
    int type;
    cin >> type;
    cin >> n >> k >> m;
    if (type == 1) {
        solve1();
    } else {
        solve2();
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}