#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <ctime>
#include <queue>
#include <deque>
#include <fstream>
#include <iomanip>
#include <bitset>
// #pragma GCC optimize("O2,O3,Ofast")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int MAXN = 100;
vector<int> G[MAXN];
vector<vector<int>> X[MAXN];


vector<int> operator +(vector<int> a, vector<int> b) {
    for (auto el : b) {
        a.push_back(el);
    }
    return a;
}


vector<vector<int>> f(vector<int> P) {
    if (P.size() == 1) {
        return X[P.front()];
    }
    vector<vector<int>> a = X[P.back()];
    P.pop_back();
    vector<vector<int>> b = f(P);
    vector<vector<int>> res;
    for (auto el1 : a) {
        for (auto el2 : b) {
            res.push_back(el1 + el2);
        }
    }
    return res;
}


void dfs(int v) {
    if (G[v].empty()) {
        return;
    }
    for (int u : G[v]) {
        dfs(u);
    }
    //
    do {
        for (auto el : f(G[v])) {
            X[v].push_back(el);
        }
    } while (next_permutation(G[v].begin(), G[v].end()));
}


bool check(vector<int> A) {
    for (int i = 0; i < (int)A.size() - 1; ++i) {
        if (A[i] > A[i + 1]) {
            return false;
        }
    }
    return true;
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int v;
                cin >> v;
                --v;
                G[i].push_back(v);
            }
        } else {
            int m;
            cin >> m;
            for (int j = 0; j < m; ++j) {
                int x;
                cin >> x;
                X[i].push_back({x});
            }
        }
    }
    //
    dfs(0);
    for (auto el : X[0]) {
        if (check(el)) {
            cout << "Yes\n";
            return 0;
        }
    }
    cout << "No\n";
    return 0;
}