#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  string s;
  cin >> s;
  vector<vector<int>> same(n);
  vector<vector<int>> anti(m);
  vector<int> bal(n);
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    while (k--) {
      int a;
      cin >> a;
      char c;
      cin >> c;
      --a;
      if (s[a] == c) {
        same[i].emplace_back(a);
      } else {
        anti[a].emplace_back(i);
        ++bal[i];
      }
    }
  }
  vector<int> ans;
  vector<bool> used(m, false);
  deque<int> Q;
  for (int i = 0; i < n; ++i) {
    if (bal[i] == 0)
      Q.emplace_back(i);
  }
  while (!Q.empty()) {
    int i = Q.front();
    Q.pop_front();
    ans.emplace_back(i);
    for (int j : same[i]) {
      if (used[j])
        continue;
      used[j] = true;
      for (int k : anti[j]) {
        --bal[k];
        if (bal[k] == 0)
          Q.emplace_back(k);
      }
    }
  }
  if (ans.size() < n) {
    cout << -1 << '\n';
    return 0;
  }
  for (int j = 0; j < m; ++j) {
    if (!used[j]) {
      cout << -1 << '\n';
      return 0;
    }
  }
  for (int x : ans)
    cout << x + 1 << ' ';
  cout << '\n';
  return 0;
}
