#include <map>
#include <set>
#include <deque>
#include <bitset>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 500001;
const int K = 19;
int lg[MAXN];

int table[26][MAXN][K];

int get(int t, int left, int right) {
  int ln = right - left + 1;
  int k = lg[ln];
  return max(table[t][left][k], table[t][right - (1 << k) + 1][k]);
}

int f[MAXN];
int A[26][26];
string dp2[MAXN];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  lg[0] = -1;
  for (int i = 1; i <= MAXN; ++i)
    lg[i] = lg[i / 2] + 1;

  int k, n;
  cin >> k >> n;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      char c;
      cin >> c;
      A[i][j] = c - '0';
    }
  }
  string s;
  cin >> s;
  for (int j = 0; j < k; ++j)
    table[j][n][0] = n - 1;
  for (int i = n - 1; i >= 0; --i) {
    f[i] = table[s[i] - 'a'][i + 1][0] - i;
    for (int j = 0; j < k; ++j) {
      table[j][i][0] = i - 1;
      if (A[j][s[i] - 'a'])
        table[j][i][0] = get(j, i + 1, i + f[i] + 1);
      for (int l = 1; i + (1 << l) <= n + 1; ++l)
        table[j][i][l] = max(table[j][i][l - 1], table[j][i + (1 << (l - 1))][l - 1]);
    }
  }
  for (int i = n - 1; i >= 0; --i) {
    string mn = dp2[i + 1];
    for (int j = i + 2; j <= i + f[i] + 1; ++j)
      mn = min(mn, dp2[j]);
    dp2[i] = s[i] + mn;
  }
  cout << dp2[0] << '\n';
  return 0;
}
