#include <map>
#include <set>
#include <deque>
#include <bitset>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const long long BASE = 547;
const long long MOD = 1e9 + 447;
const int MAXN = 500001;
long long BASEPOW[MAXN];
const int K = 19;
int lg[MAXN];

int table[26][MAXN][K];

int get(int t, int left, int right) {
  int ln = right - left + 1;
  int k = lg[ln];
  return max(table[t][left][k], table[t][right - (1 << k) + 1][k]);
}

int f[MAXN];
int A[26][26];
int link[MAXN][K];
long long hashs[MAXN][K];

bool cmp(int a, int b) {
  int k = K - 1;
  while (k >= 0) {
    if (link[a][k] != -1 && link[b][k] != -1) {
      if (hashs[a][k] == hashs[b][k]) {
        a = link[a][k];
        b = link[b][k];
      }
    }
    --k;
  }
  if (link[a][0] == -1 && link[b][0] == -1)
    return false;
  if (link[a][0] == -1)
    return true;
  if (link[b][0] == -1)
    return false;
  return hashs[a][0] < hashs[b][0];
}

int tree[(1 << 20) + 228];

void build(int v, int left, int right) {
  tree[v] = -1;
  if (left + 1 == right)
    return;
  int mid = (left + right) / 2;
  build(2 * v + 1, left, mid);
  build(2 * v + 2, mid, right);
}

int combine(int a, int b) {
  if (a == -1)
    return b;
  if (b == -1)
    return a;
  if (cmp(a, b))
    return a;
  return b;
}

void upd(int v, int left, int right, int i) {
  if (left + 1 == right) {
    tree[v] = i;
    return;
  }
  int mid = (left + right) / 2;
  if (i < mid)
    upd(2 * v + 1, left, mid, i);
  else
    upd(2 * v + 2, mid, right, i);
  tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int left, int right, int x, int y) {
  if (y <= left || right <= x)
    return -1;
  if (x <= left && right <= y)
    return tree[v];
  int mid = (left + right) / 2;
  return combine(get(2 * v + 1, left, mid, x, y), get(2 * v + 2, mid, right, x, y));
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  lg[0] = -1;
  for (int i = 1; i <= MAXN; ++i)
    lg[i] = lg[i / 2] + 1;
  BASEPOW[0] = 1;
  for (int i = 1; i <= MAXN; ++i)
    BASEPOW[i] = BASEPOW[i - 1] * BASE % MOD;

  int k, n;
  cin >> k >> n;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      char c;
      cin >> c;
      A[i][j] = c - '0';
    }
  }
  string s;
  cin >> s;
  for (int j = 0; j < k; ++j)
    table[j][n][0] = n - 1;
  for (int i = n - 1; i >= 0; --i) {
    f[i] = table[s[i] - 'a'][i + 1][0] - i;
    for (int j = 0; j < k; ++j) {
      table[j][i][0] = i - 1;
      if (A[j][s[i] - 'a'])
        table[j][i][0] = get(j, i + 1, i + f[i] + 1);
      for (int l = 1; i + (1 << l) <= n + 1; ++l)
        table[j][i][l] = max(table[j][i][l - 1], table[j][i + (1 << (l - 1))][l - 1]);
    }
  }
  fill(link[n], link[n] + K, -1);
  build(0, 0, n + 1);
  upd(0, 0, n + 1, n);
  for (int i = n - 1; i >= 0; --i) {
    int j = get(0, 0, n + 1, i + 1, i + f[i] + 2);
    link[i][0] = j;
    hashs[i][0] = s[i];
    for (int l = 1; l < K; ++l) {
      if (link[i][l - 1] == -1) {
        link[i][l] = -1;
      } else {
        link[i][l] = link[link[i][l - 1]][l - 1];
        hashs[i][l] = (hashs[i][l - 1] * BASEPOW[1 << (l - 1)] + hashs[link[i][l - 1]][l - 1]) % MOD;
      }
    }
    upd(0, 0, n + 1, i);
  }
  string ans;
  int cur = 0;
  while (cur != n) {
    ans += s[cur];
    cur = link[cur][0];
  }
  cout << ans << '\n';
  return 0;
}
