#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>

using itn = int;

using namespace std;

vector <vector <int>> graph;
vector <vector <pair <pair <int, int>, vector <pair <int, int>> >>> variants;

vector <vector <int>> docl;

vector <int> buffer;

vector <pair <int, int>> buffer2;

int n;

bool cmp (pair <int, int> a, pair <int, int> b) {
	return variants[a.second][a.first].first.first < variants[b.second][b.first].first.first;
}

bool gen_next(int v) {
	int ind = buffer.size() - 1;
	while (ind >= 0 && buffer[ind] == variants[graph[v][ind]].size() - 1) {
		buffer[ind] = 0;
		--ind;
	}
	if (ind == -1)
		return false;
	++buffer[ind];
	return true;
}

void dfs(int v) {
	if (graph[v].size() == 0) {
		for (int el : docl[v]) {
			vector <pair <int, int>> b = { make_pair(el, 0) };
			variants[v].push_back(make_pair(make_pair(el, el), b));
		}
		return;
	}
	for (int u : graph[v]) {
		dfs(u);
		if (variants[u].size() == 0)
			return;
	}
	buffer.clear();
	buffer.assign(graph[v].size(), 0);
	buffer2.resize(graph[v].size());
	do {
		for (int i = 0; i < graph[v].size(); ++i) {
			buffer2[i] = { buffer[i], graph[v][i] };
		}
		sort(buffer2.begin(), buffer2.end(), cmp);
		bool is_normal = true;
		for (int i = 0; i < graph[v].size() - 1; ++i) {
			if (variants[buffer2[i].second][buffer2[i].first].first.second > variants[buffer2[i + 1].second][buffer2[i + 1].first].first.first) {
				is_normal = false;
				break;
			}
		}
		if (is_normal) {
			variants[v].push_back({ {variants[buffer2[0].second][buffer2[0].first].first.first, variants[buffer2[graph[v].size() - 1].second][buffer2[graph[v].size() - 1].first].first.second}, {} });
			for (auto el : buffer2) {
				variants[v][variants[v].size() - 1].second.push_back(el);
			}
		}
	} while (gen_next(v));
}

vector <vector <int>> match;

void dfs2(int v, int var) {
	if (graph[v].size() == 0) {
		match[v].push_back(variants[v][var].second[0].first);
		return;
	}
	for (int i = 0; i < graph[v].size(); ++i) {
		match[v].push_back(variants[v][var].second[i].second + 1);
		dfs2(variants[v][var].second[i].second, variants[v][var].second[i].first);
	}
}

int main() {
	cin >> n;
	int mi, ki, t, podch, dc;
	graph.resize(n);
	docl.resize(n);
	match.resize(n);
	variants.resize(n);
	for (itn i = 0; i < n; ++i) {
		cin >> t;
		if (t == 1) {
			cin >> ki;
			for (int j = 0; j < ki; ++j) {
				cin >> podch;
				--podch;
				graph[i].push_back(podch);
			}
		} else {
			cin >> mi;
			for (int j = 0; j < mi; ++j) {
				cin >> dc;
				docl[i].push_back(dc);
			}
		}
	}
	dfs(0);
	if (variants[0].size() == 0) {
		cout << "NO";
		return 0;
	}
	cout << "YES\n";
	dfs2(0, 0);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < match[i].size(); ++j) {
			cout << match[i][j] << " ";
		}
		cout << "\n";
	}
}