//#pragma GCC target ("avx2")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")

#include <iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<cassert>

using namespace std;

vector<int> t;
vector<vector<int>> gr;

vector<vector<int>> merge(vector<vector<vector<int>>>& ok, vector<int>& ind) {
	if (ind.size() == ok.size()) {
		vector<vector<int>> heh;
		for (int i = 0; i < ok.size(); ++i)
			heh.push_back(ok[i][ind[i]]);
		sort(heh.begin(), heh.end(), [ok](vector<int> a, vector<int> b) {
			return a[0] < b[0];
			});
		vector<int> ans;
		for (auto& i : heh)
			for (int j : i)
				ans.push_back(j);
		for (int i = 1; i < ans.size(); ++i)
			if (ans[i] < ans[i - 1])
				return {};
		return { ans };
	}
	vector<vector<int>> ans;
	for (int i = 0; i < ok[ind.size()].size(); ++i) {
		ind.push_back(i);
		vector<vector<int>> heh = merge(ok, ind);
		ind.pop_back();
		for (vector<int> i : heh)
			ans.push_back(i);
	}
	return ans;
}

vector<vector<int>> bruteforce(int u) {
	if (t[u] == 2) {
		vector<vector<int>> ans;
		for (int i : gr[u])
			ans.push_back({ i });
		return ans;
	}
	vector<vector<vector<int>>> ok;
	for (int v : gr[u])
		ok.push_back(bruteforce(v));
	vector<int> ind;
	return merge(ok, ind);
}

int find_ans(vector<vector<int>>& cc, vector<int>& c, int u) {
	if (t[u] == 2)
		return c[u];
	vector<pair<int, int>> temp;
	for (int v : gr[u])
		temp.emplace_back(find_ans(cc, c, v), v);
	sort(temp.begin(), temp.end());
	for (auto [a, b] : temp)
		cc[u].push_back(b);
	return temp[0].second;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	t.resize(n);
	gr.resize(n);
	for (int i = 0; i < n; ++i) {
		int c, k;
		cin >> c >> k;
		t[i] = c;
		gr[i].resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> gr[i][j];
			--gr[i][j];
		}
	}
	vector<vector<int>> ans = bruteforce(0);
	if (ans.size() == 0) {
		cout << "No";
		return 0;
	}
	else
		cout << "Yes\n";
	vector<int> res = ans[0];
	vector<int> c(n);
	for (int i = 0; i < n; ++i) 
		if (t[i] == 2) {
			for (int j : gr[i]) {
				auto it = find(res.begin(), res.end(), j);
				if (it != res.end()) {
					c[i] = it - res.begin();
				}
			}
		}
	vector<vector<int>> cc(n);
	find_ans(cc, c, 0);
	for (int i = 0; i < n; ++i) {
		if (t[i] == 2) {
			cout << res[c[i]] + 1 << '\n';
			continue;
		}
		for (int j : cc[i])
			cout << j + 1 << ' ';
		cout << '\n';
	}
}