#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>

using namespace std;

const int N = 5001;

int n;
int x[N];
int l[N];

int used[N];
vector<int> ord;

void init() {
	while (true) {
		int any = 0;
		{
			int mx = x[0];
			for (int i = 0; i < n; i++) {
				if (!any && !used[i] && mx <= x[i] - l[i]) {
					ord.push_back(i);
					any = 1;
					used[i] = 1;
					break;
				}
				if (!used[i]) {
					mx = x[i];
				}
			}
		}
		{
			int mn = x[n - 1];
			for (int i = n - 1; i >= 0; i--) {
				if (!any && !used[i] && x[i] + l[i] <= mn) {
					ord.push_back(i);
					any = 1;
					used[i] = 1;
					break;
				}
				if (!used[i]) {
					mn = x[i];
				}
			}
		}
		if (!any) {
			break;
		}
	}
}

void solve(int f, int s) {
	set<int> S;
	if (f != 0) S.insert(f - 1);
	if (s + 1 != n) S.insert(s + 1);
	auto can_erase_l = [&](int i) {
		if (x[i] - l[i] < x[0]) return (bool)0;
		auto it = S.lower_bound(i);
		return it == S.begin() || x[*prev(it)] <= x[i] - l[i];
	};
	auto can_erase_r = [&](int i) {
		if (x[i] + l[i] > x[n - 1]) return (bool)0;
		auto it = S.lower_bound(i);
		return next(it) == S.end() || x[i] + l[i] <= x[*next(it)];
	};
	for (int i = f; i <= s; i++) {
		S.insert(i);
	}
	int ans = 0;
	// for (auto t : ord) {
	// 	if (f <= t && t <= s && (can_erase_l(t) || can_erase_r(t))) {
	// 		ans++;
	// 		S.erase(t);
	// 	}
	// }
	// cout << ans << '\n';
	for (int i = 0; i < s - f + 1; i++) {
		for (int j = f; j <= s; j++) {
			if (S.count(j) && (can_erase_l(j) || can_erase_r(j))) {
				S.erase(j);
				ans++;
			}
		} 
	}
	cout << ans << '\n';
}

signed main() {

	int q;
	cin >> n >> q;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> l[i];
	}
	init();
	while (q--) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		solve(l, r);
	}
}