#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <string>

using namespace std;
typedef long long ll;

struct q {
	int l, r, i;
	int otr;
};
struct tree {
	int x, h, l = 0, r = 0, i;
	bool operator< (tree b) const {
		pair<bool, pair<int, int>> a1 = { (max(l, r) >= h), {l + r, i} }, b1 = { (max(b.l, b.r) >= b.h), {b.l + b.r, b.i} };
		return a1 < b1;
	}
};

ll inf = -1e18;
int sq = 707;
deque<tree>d;
vector<tree>arr;
tree trash({ -1, -1, -1, -1, -1 });

bool comp(q a, q b) {
	return (a.otr < b.otr) || (a.otr == b.otr && a.r < b.r);
}

void r1(int&r, int pr) {
	while (r < pr) {
		r++;
		d.push_back(arr[r]);
	}
}
void r0(int& r, int pr) {
	while (r > pr) {
		d.pop_back();
		r--;
	}
}
void l1(int& l, int pl) {
	while (l + 1 < pl){
		d.pop_front();
		l++;
	}
}
void l0(int& l, int pl) {
	while (l + 1 > pl) {
		d.push_front(arr[l]);
		l--;
	}
}

int get_ans(int l, int r) {
	set<tree>s;
	for (int i = 0; i < d.size(); i++)
		s.insert(d[i]);
	while (s.size() != 0) {
		tree x = *(--s.end());
		if (max(x.l, x.r) < x.h)
			break;
		s.erase(x);
		tree left = trash, right = trash;
		auto it = s.begin();
		while (it != s.end()) {
			if ((*it).i < x.i && (left.i == -1 || (*it).i > left.i))
				left = *it;
			if ((*it).i > x.i && (right.i == -1 || (*it).i < right.i))
				right = *it;
			it++;
		}
		if (left.x != -1) {
			s.erase(left);
			left.r += x.r;
			s.insert(left);
		}
		if (right.x != -1) {
			s.erase(right);
			right.l += x.l;
			s.insert(right);
		}
	}
	return (r-l) + 1 - s.size();
}

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, Q; cin >> n >> Q;
	arr.resize(n);
	vector<q>z(Q);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].h;
		arr[i].i = i;
		if (i != 0) {
			arr[i].l = abs(arr[i].x - arr[i - 1].x);
			arr[i - 1].r = abs(arr[i].x - arr[i - 1].x);
		}
	}
	for (int i = 0; i < Q; i++) {
		cin >> z[i].l >> z[i].r;
		z[i].i = i;
		z[i].l--; z[i].r--;
	}
	sort(z.begin(), z.end(), comp);
	vector<int>ans(Q);
	int l = 0, r = 0;
	for (int nmb = 0; nmb < Q; nmb++) {
		r1(r, z[nmb].r);
		r0(r, z[nmb].r);
		l1(l, z[nmb].l);
		l0(l, z[nmb].l);
		ans[z[nmb].i] = get_ans(z[nmb].l, z[nmb].r);
	}
	for (auto i : ans)
		cout << i << '\n';
	return 0;
}