#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <string>

using namespace std;
typedef long long ll;
int inf = 1e9;

struct vertex {
	int v, mn, mx;
	bool operator<(vertex b) const {
		return (mn + mx) < (b.mn + b.mx);
	}
	bool operator>(vertex b) const {
		return (mn + mx) > (b.mn + b.mx);
	}
};

vector<vector<pair<int, int>>>g;
vector<vertex>ans;

void dfs(vertex p, int v) {
	ans[v] = p;
	for (auto i : g[v])
		if (i.first != p.v)
			dfs(vertex({ v, min(p.mn, i.second), max(p.mx, i.second)}), i.first);
}

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, m; cin >> n >> m;
	g.resize(n);
	ans.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c;
		u--; v--;
		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}
	dfs(vertex({ 0, inf, -inf }), 0);
	for (int i = 1; i < n; i++)
		cout << ans[i].mx+ans[i].mn << '\n';
	return 0;
}