#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>
#include <set>
#include <string>
#include <deque>
#include <cassert>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
#define int ll

const int INF = 2e9;

struct edge
{
	int to, cost, in;
	edge() {}
	edge(int to, int cost, int in) : to(to), cost(cost), in(in) {}
};

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	int n, m, a, b, c;
	cin >> n >> m;
	vector < vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		cin >> a >> b >> c;
		--a, --b;
		if (abs(a - b) != 1)
			assert(false);
		if (a > b)
			swap(a, b);
		if (!g[a].empty()) {
			if (g[a][0].second > c) {
				g[a].pop_back();
				g[a].emplace_back(b, c);
			}
		}
		else
			g[a].emplace_back(b, c);
	}
	int ma = 0, mi = INF;
	for (int i = 0; i < n - 1; ++i) {
		ma = max(ma, g[i][0].second);
		mi = min(mi, g[i][0].second);
		cout << ma + mi << '\n';
	}
	return 0;
}