#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>
#include <set>
#include <string>
#include <deque>
#include <cassert>
#include <ctime>
#include <random>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
//#define int ll

const int INF = 2e9;

struct edge
{
	int to, cost, in;
	edge() {}
	edge(int to, int cost, int in) : to(to), cost(cost), in(in) {}

	bool operator<(const edge& obj) const {
		return cost < obj.cost;
	}
};

vector<bool> used;

vector<vector<edge>> g;

vector<int> d;
vector<int> predmi, predma;

bool f = false;

bool is_tl() {
	static int cnt = 0;
	if (cnt == 1000) {
		if ((double)clock() / CLOCKS_PER_SEC >= 2.8) {
			f = true;
			return true;
		}
		cnt = 0;
	}
	++cnt;
	return false;
}

void solve(int v, int ma = 0, int mi = INF) {
	if (f || is_tl())
		return;
	if (d[v] > ma + mi) {
		d[v] = ma + mi;
		predma[v] = ma;
		predmi[v] = mi;
	}
	vector<int> ord(g[v].size());
	iota(all(ord), 0);
	random_shuffle(all(ord));
	for (int i = 0; i < g[v].size(); ++i) {
		auto u = g[v][ord[i]];
		if (!used[u.in]) {
			used[u.in] = true;
			solve(u.to, max(ma, u.cost), min(mi, u.cost));
			used[u.in] = false;
		}
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	int n, m, a, b, c;
	cin >> n >> m;
	g.resize(n);
	used.resize(m);
	d.resize(n, INF);
	predmi.resize(n, INF);
	predma.resize(n, INF);
	d[0] = 0;
	for (int i = 0; i < m; ++i) {
		cin >> a >> b >> c;
		--a, --b;
		g[a].emplace_back(b, c, i);
		g[b].emplace_back(a, c, i);
	}
	solve(0);
	for (int i = 1; i < n; ++i)
		cout << d[i] << '\n';
	return 0;
}