#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
 
struct Edge {
    int u, v, w;
    Edge(int u, int v, int w) : u(u), v(v), w(w) {}
    bool operator <(const Edge &other) const {
        return w < other.w;
    }
};

const ll Inf = 2e9;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int n, m;
    cin >> n >> m;
    vector <Edge> E;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        E.emplace_back(u, v, w);
    }
    sort(E.begin(), E.end());
    vector <int> par(n);
    for (int i = 0; i < n; ++i) par[i] = i;
    function <int(int)> get = [&] (int a) {
        return (a == par[a] ? a : par[a] = get(par[a]));
    };
    auto join = [&] (int a, int b) {
        a = get(a);
        b = get(b);
        par[a] = b;
    };
    vector <int> in_tr(m);
    vector <vector <pair <int, int>>> g(n);
    for (int i = 0; i < (int)E.size(); ++i) {
        if (get(E[i].u) != get(E[i].v)) {
            join(E[i].u, E[i].v);
            g[E[i].u].push_back({E[i].v, i});
            g[E[i].v].push_back({E[i].u, i});
            in_tr[i] = 1;
        }
    }
    const int K = 20;
    vector <vector <int>> go(K, vector <int> (n));
    vector <int> l(n), r(n);
    vector <int> e;
    vector <int> ed_id(n);
    vector <int> tr_par(n);
    function <void(int, int)> dfs = [&] (int u, int p) {
        e.push_back(u);
        l[u] = (int)e.size() - 1;
        go[0][u] = p;
        tr_par[u] = p;
        for (int i = 1; i < K; ++i) {
            go[i][u] = go[i - 1][go[i - 1][u]];
        }
        for (auto [v, id] : g[u]) {
            if (v != p) {
                ed_id[v] = id;
                dfs(v, u);
            }
        }
        r[u] = (int)e.size() - 1;
    };
    dfs(0, 0);
    auto anc = [&] (int a, int b) {
        return l[a] <= l[b] && r[b] <= r[a];
    };
    auto lca = [&] (int a, int b) {
        if (anc(a, b)) return a;
        for (int i = K - 1; i >= 0; --i) {
            if (!anc(go[i][a], b)) {
                a = go[i][a];
            }
        }
        return go[0][a];
    };
    vector <int> alive(m);
    vector <int> cur(n);
    vector <ll> ans(n, Inf);
    vector <int> root(n);
    vector <ll> best(n, Inf);
    vector <int> is_r(n);
    for (int i = 0; i < n; ++i) par[i] = i;
    for (int i = 0; i < m; ++i) {
        alive[i] = 1;
        if (!in_tr[i]) {
            int a = E[i].u, b = E[i].v;
            int ca = get(a);
            int ok = 0;
            while (!anc(ca, b)) {
                ++cur[ca];
                join(ca, tr_par[ca]);
                ca = get(ca);
                ok = 1;
            }
            int cb = get(b);
            while (!anc(cb, a)) {
                ++cur[cb];
                join(cb, tr_par[cb]);
                cb = get(cb);
                ok = 1;
            }
            if (!ok) continue;
        }
        for (int i : e) {
            if (i == 0) continue;
            if (cur[i] > 0) {
                root[i] = root[tr_par[i]];
            } else {
                root[i] = i;
            }
        }
        for (int i = 0; i < n; ++i) {
            best[i] = Inf;
            is_r[i] = 0;
        }
        is_r[0] = 1;
        for (int i = 1; i < n; ++i) {
            if (alive[ed_id[i]]) best[root[i]] = min(best[root[i]], (ll)E[ed_id[i]].w);
        }
        for (int i : e) {
            if (i == 0) continue;
            int a = root[i], b = root[tr_par[i]];
            if (a != b && alive[ed_id[i]]) {
                is_r[a] |= is_r[b];
                best[a] = min(best[a], best[b]);
            }
        }
        /*if (E[i].w == 3) {
            for (int i = 1; i < n; ++i) {
                cout << root[i] << ' ' << best[i] << endl;
            }
        }*/
        for (int j = 1; j < n; ++j) {
            if (!is_r[root[j]]) continue;
            ans[j] = min(ans[j], best[root[j]] + E[i].w);
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}