#include <iostream>
#include <vector>
#include <unordered_map>
#pragma GCC optimize("Ofast")
#pragma GCC optimization("avx,avx2,fma")

using namespace std;

#define v vector
#define int long long
#define pr pair<int, int>

int n, m;

v<pr> edges;
unordered_map<int, int> used;
v<int> c;

v<v<int>> basic_g;

void init() {
    cin >> n >> m;
    basic_g.resize(n);
    c.resize(n);
    for (int i = 0; i < m; i++) {
        int u, to; cin >> u >> to;
        u--; to--;
        used[u * n + to] = 1;
        edges.emplace_back(make_pair(u, to));
        if (!used[to * n + u]) {
            basic_g[u].push_back(to);
            basic_g[to].push_back(u);
        }
    }
}

v<int> USED;

void dfs(int i, int p, int color) {
    USED[i] = 1;
    c[i] = color;
    for (auto j : basic_g[i]) {
        if (j != p) {
            dfs(j, i, 1 - color);
        }
    }
}

v<v<int>> g;
int cnt0 = 0, cnt1 = 0;
v<int> mt, vis, mp0, mp1, num;

void build_g() {
    mp0.resize(m, 0);
    mp1.resize(m, 0);
    num.resize(m, 0);
    int i = 0;
    for (auto [u, to] : edges) {
        if (c[u] == 0) {
            mp0[cnt0] = i;
            num[i] = cnt0;
            cnt0++;
        } else {
            mp1[cnt1] = i;
            num[i] = cnt1;
            cnt1++;
        }
        i++;
    }

    g.resize(cnt0);
    vis.resize(cnt0, 0);
    mt.resize(cnt1, -1);

    for (int j = 0; j < m; j++) {
        for (int k = j + 1; k < m; k++) {
            auto [a, b] = edges[j];
            auto [e, f] = edges[k];
            if (a != f && b != e) continue;
            if (c[a] == c[e]) continue;
            if (c[a] == 0) {
                g[num[j]].push_back(num[k]);
            } else {
                g[num[k]].push_back(num[j]);
            }
        }
    }
}

int CNT = 1;

int try_kuhn(int i) {
    if (vis[i] == CNT) return 0;
    vis[i] = CNT;
    for (auto j : g[i]) {
        if (mt[j] == -1) {
            mt[j] = i;
            return 1;
        }
    }
    for (auto j : g[i]) {
        if (try_kuhn(mt[j])) {
            mt[j] = i;
            return 1;
        }
    }
    return 0;
}

void build_pairs() {
    int res = 0;
    for (int i = 0; i < cnt0; i++) {
        res += try_kuhn(i);
        CNT++;
    }
    if (2 * res != m) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for (int i = 0; i < cnt1; i++) {
            if (mt[i] != -1) {
                int id0 = mt[i], id1 = i;
                id0 = mp0[id0];
                id1 = mp1[id1];
                auto [a, b] = edges[id0];
                auto [e, f] = edges[id1];
                cout << a + 1 << " " << b + 1 << " " << e + 1 << " " << f + 1 << "\n";
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    init();

    USED.resize(n, 0);

    for (int i = 0; i < n; i++) {
        if (!USED[i]) {
            dfs(i, -1, 0);
        }
    }

    build_g();
    build_pairs();

    return 0;
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
 */

/*
4 4
1 2
2 1
3 4
4 3
 */

/*
4 4
2 1
2 3
2 4
4 2
 */
