#include <bits/stdc++.h> 
//#define int long long

#define pb push_back

#define pii pair<int, int>

#define ff first 
#define ss second 

#define all(x) (x).begin(), (x).end()    

using namespace std; 

typedef long long ll; 

const int maxn = 3e5 + 7; 
const ll inf = 2e9 + 7; 
int n, m;  

struct edge {
    int to, w, id; 
}; 

vector<edge> gr[maxn]; 
int used[maxn]; 
int res[maxn]; 
int tin[maxn]; 
int tout[maxn]; 
int fup[maxn]; 
int Timer = 0; 

map<pii, int> block; 

void dfs(int u, int PR, int pr) {
    fup[u] = tin[u] = Timer++; 
    used[u] = 1; 
    for (auto v : gr[u]) {
        if (!used[v.to]) {
            dfs(v.to, u, v.id); 
            fup[u] = min(fup[u], fup[v.to]); 
        } else if (v.id != pr) {
            fup[u] = min(fup[u], tin[v.to]); 
        }
    }
    if (u != PR && fup[u] >= tin[u]) {
//        cout << u << " " << PR << "\n"; 
        block[{PR, u}] = 1; 
        block[{u, PR}] = 1;
    }
}

int color[maxn]; 
int MIN[maxn]; 

void dfs(int u, int pt) {
    color[u] = pt;
    used[u] = 1;
    for (auto v : gr[u]) {
        if (block.find({u, v.to}) != block.end()) continue; 
        MIN[pt] = min(MIN[pt], v.w); 
        if (!used[v.to]) {
            dfs(v.to, pt); 
        }
    } 
}

int path[maxn]; 

void jfs(int u, int mn) {
    mn = min(mn, path[color[u]]); 
    path[color[u]] = min(path[color[u]], mn); 
    used[u] = 1; 
    for (auto v : gr[u]) {
        if (!used[v.to]) {
            jfs(v.to, min(mn, v.w)); 
        }
    }
}
void solve() {
    cin >> n >> m; 
    for (int i = 0; i < n; ++i) {
        path[i] = inf; 
        MIN[i] = inf; 
    }
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t, --u, --v; 
        gr[u].pb({v, t, i}); 
        gr[v].pb({u, t, i}); 
    }
    dfs(0, 0, -1);    
    int pt = 0; 
    for (int i = 0; i < n; ++i) {
        used[i] = 0; 
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, pt); 
            pt++; 
        }
    }
    for (int i = 0; i < n; ++i) {
        used[i] = 0; 
    }
    jfs(0, inf);     
    int T = 1e9; 
    for (int i = 1; i < n; ++i) {
        cout << T + min(MIN[color[i]], path[color[i]]) << '\n'; 
    }
}                                        

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false); 
    cin.tie(0);

    int t = 1; 
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}