#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> ans;
vector<pair<int, int>> best;
vector<int> way;
vector<int> help;

void dfs(int now, int p, int cost) {
    if (p != -1) {
        best[now].first = min(best[p].first, cost);
        best[now].second = max(best[p].second, cost);
    }
    ans[now] = best[now].first + best[now].second;
    for (auto i : g[now]) {
        if (i.first == p) continue;
        dfs(i.first, now, i.second);
    }
}

bool in(int x, int y) {
    for (int i = 0; i < way.size() - 1; i++) {
        if (x == way[i] && y == way[i + 1] || (x == way[i + 1] && y == way[i])) return true;
    }
    return false;
}

void solve(int now, int min1, int max1) {
    ans[now] = min(ans[now], min1 + max1);
    for (auto to : g[now]) {
        if (!in(now, to.first)) {
            way.push_back(to.first);
            solve(to.first, min(min1, to.second), max(max1, to.second));
            way.pop_back();
        }
    }
}

vector<int> bos;
vector<vector<int>> ran;

int dsu_get(int v) {
    if (v == bos[v]) return v;
    return bos[v] = dsu_get(bos[v]);
}

bool dsu_join(int x, int y) {
    x = dsu_get(x), y = dsu_get(y);
    if (x == y) return false;
    if (ran[x].size() > ran[y].size()) swap(x, y);
    bos[x] = y;
    for (auto i : ran[x]) ran[y].push_back(i);
    return true;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    ans.assign(n, 2e9);
    best.assign(n, {1e9, 0});
    bool was1 = true;
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        g[v - 1].push_back({u - 1, t});
        g[u - 1].push_back({v - 1, t});
        if ((v == 0 || u == 0) && t != 0) was1 = false;
    }
    if (m == n - 1) dfs(0, -1, 0);
    else if (was1){
        vector<vector<int>> edges;
        bos.resize(n);
        ran.resize(n);
        for (int i = 0; i < n; i++) {
            bos[i] = i;
            ran[i] = {i};
            for (auto j : g[i]) {
                if (i < j.first) edges.push_back({j.second, i, j.first});
            }
        }
        help.assign(n, -1);
        sort(edges.begin(), edges.end());
        for (auto i : edges) {
            if (dsu_get(0) == dsu_get(i[1]) && dsu_get(0) != dsu_get(i[2])) {
                for (auto j : ran[i[2]]) {
                    if (help[j] == -1)
                        help[j] = i[0];
                }
            } else if ((dsu_get(0) != dsu_get(i[1]) && dsu_get(0) == dsu_get(i[2]))) {
                for (auto j : ran[i[1]]) {
                    if (help[j] == -1)
                        help[j] = i[0];
                }
            }
            dsu_join(i[1], i[2]);
        }
        for (int i = 1; i < n; i++) ans[i] = help[i];
    } else {
        way = {0};
        solve(0, 1e9, 0);
    }
    for (int i = 1; i < n; i++) cout << ans[i] << '\n';
}