#include <bits/stdc++.h>
#define ll long long
#define ipair pair <int, int>
#define dpair pair <int, pair <int, int> >
using namespace std;

vector <ipair> seg;
vector <int> kth;
vector <ipair> trees;

ipair upd(ipair lhs, ipair rhs)
{
    if (lhs.first < rhs.first)
        return lhs;
    return rhs;
}

void build(int pos, int left, int right)
{
    if (left == right)
    {
        seg[pos] = {trees[left].second, left};
        kth[pos] = 1;
    } else
    {
        int mid = (left + right) / 2;
        build(pos * 2 + 1, left, mid);
        build(pos * 2 + 2, mid + 1, right);
        kth[pos] = max(kth[pos * 2 + 1], kth[pos * 2 + 2]);
        seg[pos] = upd(seg[pos * 2 + 1], seg[pos * 2 + 2]);
    }
}

void del(int pos, int left, int right, int aim)
{
    if (left == right)
    {
        seg[pos] = {INT_MAX, left};
        kth[pos] = 0;
    }  else
    {
        int mid = (left + right) / 2;
        if (aim <= mid)
            del(pos * 2 + 1, left, mid, aim);
        else
            del(pos * 2 + 2, mid + 1, right, aim);
        kth[pos] = max(kth[pos * 2 + 1], kth[pos * 2 + 2]);
        seg[pos] = upd(seg[pos * 2 + 1], seg[pos * 2 + 2]);
    }
}

ipair rmq(int pos, int left, int right, int bleft, int bright)
{
    if (bleft <= left && right <= bright)
        return seg[pos];
    if (bleft > right || left > bright)
        return {INT_MAX, -1};

    int mid = (left + right) / 2;
    return upd(rmq(pos * 2 + 1, left, mid, bleft, bright),
               rmq(pos * 2 + 2, mid + 1, right, bleft, bright));
}

int first(int pos, int left, int right, int bleft, int bright, bool lower)
{
    if (kth[pos] == 0)
        return -1;
    if (bleft > right || left > bright)
        return -1;
    if (left == right)
        return left;

    int mid = (left + right) / 2;
    if (lower)
    {
        int temp = first(pos * 2 + 1, left, mid, bleft, bright, lower);
        if (temp == -1)
            temp = first(pos * 2 + 2, mid + 1, right, bleft, bright, lower);
        return temp;
    }

    int temp = first(pos * 2 + 2, mid + 1, right, bleft, bright, lower);
    if (temp == -1)
        temp = first(pos * 2 + 1, left, mid, bleft, bright, lower);
    return temp;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;
    trees.resize(n);
    for (auto& v : trees)
        cin >> v.first >> v.second;

    while (q--)
    {
        seg.resize(n * 4);
        kth.resize(n * 4);
        build(0, 0, n - 1);
        int l, r;
        cin >> l >> r;
        l--; r--;

        int ans = 0;
        for (int k = 0; k < r - l + 1; k++)
        {
            int pos = rmq(0, 0, n - 1, l, r).second;

            int left = first(0, 0, n - 1, 0, pos - 1, false);
            int right = first(0, 0, n - 1, pos + 1, n - 1, true);

            if (!(left != -1 && trees[pos].first - trees[pos].second >= trees[left].first ||
                  right != -1 && trees[pos].first + trees[pos].second <= trees[right].first) &&
                !(left == -1 && trees[pos].first - trees[pos].second >= trees[0].first ||
                  right == -1 && trees[pos].first + trees[pos].second <= trees.back().first))
            {
                break;
            } else
            {
                ans++;
                del(0, 0, n - 1, pos);
            }
        }
        cout << ans << "\n";
    }
}

