#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, q = 0;
	cin >> n >> q;

	vector<int> x(n), h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];

	int l = 0, r = 0;
	for (int query = 0; query < q; ++query)
	{
		cin >> l >> r;
		--l;

		vector<int> active(n, 1);
		int ans = 0, prevAns = -1;
		while (ans != prevAns)
		{
			prevAns = ans;
			for (int i = l; i < r; ++i)
			{
				if (active[i])
				{
					bool toLeft = (x[i] - h[i] >= x[0]);
					for (int j = i - 1; j >= 0 && x[j] > x[i] - h[i]; --j)
					{
						if (active[j])
						{
							toLeft = false;
							break;
						}
					}

					if (toLeft)
					{
						++ans;
						active[i] = false;
						break;
					}

					bool toRight = (x[i] + h[i] <= x.back());
					for (int j = i + 1; j< n && x[j] < x[i] + h[i]; ++j)
					{
						if (active[j])
						{
							toRight = false;
							break;
						}
					}

					if (toRight)
					{
						++ans;
						active[i] = false;
						break;
					}
				}
			}
		}

		cout << ans << "\n";
	}

	return 0;
}