#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MAXN = 300000;
const int INF = (int)1e9 + 1;

int t[MAXN], ans[MAXN];
vector<pair<int, int>> g[MAXN];
int vis[MAXN];

void dfs(int u, unordered_set<int>& visited, int maxT, int minT) noexcept
{
	ans[u] = min(ans[u], maxT + minT);
	if (++vis[u] > 2)
	{
		--vis[u];
		return;
	}
	for (const auto& [v, e] : g[u])
	{
		if (!visited.count(e))
		{
			visited.insert(e);
			dfs(v, visited, max(maxT, t[e]), min(minT, t[e]));
			visited.erase(e);
		}
	}
	--vis[u];
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	cin >> n >> m;

	int u = 0, v = 0;
	for (int i = 0; i < m; ++i)
	{
		cin >> u >> v >> t[i];
		--u, --v;
		g[u].emplace_back(v, i);
		g[v].emplace_back(u, i);
	}

	unordered_set<int> visited;
	fill(ans, ans + n, 2 * INF);
	//fill(mem, mem + n, make_pair(INF, INF));
	dfs(0, visited, 0, INF);

	for (int i = 1; i < n; ++i)
		cout << ans[i] << "\n";

	return 0;
}