#include <algorithm>
#include <set>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

const int MAXN = 2001;
const int INF = (int)1e9 + 1;

vector<int> tArr[MAXN];
int ans[MAXN];
map<int, int> dpTo;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	cin >> n >> m;

	int u = 0, v = 0, t = 0;
	for (int i = 0; i < m; ++i)
	{
		cin >> u >> v >> t;
		tArr[min(u, v) - 1].push_back(t);
	}

	for (int i = 0; i < n; ++i)
		sort(tArr[i].begin(), tArr[i].end());

	int maxT = 0, minT = INF;
	for (int i = 0; i < n - 1; ++i)
	{
		maxT = max(maxT, tArr[i][0]);
		minT = min(minT, tArr[i][0]);

		ans[i] = minT + maxT;
		int nextMax = maxT, nextMin = minT;
		for (int j = i + 1; j < n - 1; ++j)
		{
			if (tArr[j].size() < 2)
				break;
			nextMax = max(nextMax, tArr[j][1]);
			nextMin = min(nextMin, tArr[j][0]);
			ans[i] = min(ans[i], nextMax + nextMin);
		}
	}

	for (int i = 0; i < n - 1; ++i)
		cout << ans[i] << "\n";

	return 0;
}