#include <iostream>
#include <vector>
#include <algorithm>
#include "numeric"
#include "set"
#include "map"
#include "queue"
using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;

vector<vector<pair<int, int>>> g;
vector<int> res;
vector<int> t;
vector<int> comp;
vector<int> depth;
vector<int> stk;
void dfsdep(int v, int dep) {
    if (depth[v] != -1)
        return;
    depth[v] = dep;
    for (auto u : g[v])
        dfsdep(u.first, dep + 1);
}
int kmpnum = 0;
vector<int> seen;
int dfs(int v, int p) {
    if (seen[v])
        return depth[v];
    seen[v] = 1;
    stk.push_back(v);
    int minupdep = depth[v];
    for (auto [i, ind] : g[v]) {
        if (ind == p)
            continue;
        if (depth[i] < depth[v]) {
            minupdep = min(minupdep, depth[i]);
        } else {
            minupdep = min(minupdep, dfs(i, ind));
        }
    }
    if (minupdep == depth[v]) {
        int k = kmpnum;
        kmpnum++;
        while (stk.back() != v) {
            comp[stk.back()] = k;
            stk.pop_back();
        }
        comp[stk.back()] = k;
        stk.pop_back();
    }
    return minupdep;
}
vector<pair<pair<int, int>, int>> ed;
vector<vector<pair<int, int>>> gg;
vector<int> compres;

void dfs(int v, int p, int val) {
    val = min(val, compres[v]);
    compres[v] = val;
    for (auto [i, c] : gg[v]) {
        if (i == p)
            continue;
        dfs(i, v, min(val, c));
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    seen.assign(n, 0);
    depth.assign(n, -1);
    comp.assign(n, -1);
    t.assign(m, 0);
    res.assign(n, -1);
    g.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        ed.push_back({{a, b}, c});
        t[i] = c;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    dfsdep(0, 0);
    dfs(0, -1);
    vector<int> compres(kmpnum, 1e9); // axax, i write comp, but kmp
    vector<vector<pair<int, int>>> gg(kmpnum);
    for (auto i : ed) {
        if (comp[i.first.first] == comp[i.first.second]) {
            compres[comp[i.first.first]] = min(i.second, compres[comp[i.first.first]]);
        } else {
            gg[comp[i.first.first]].push_back({comp[i.first.second], i.second});
            gg[comp[i.first.second]].push_back({comp[i.first.first], i.second});
        }
    }
    dfs(comp[0], -1, compres[comp[0]]);
    for (int i = 1; i < n; ++i) {
        cout << (int(1e9)) + compres[comp[i]] << '\n';
    }
}