#include <bits/stdc++.h>

const int inf = 0x3f3f3f3f;
using ll = long long;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
using pii = std::pair<int, int>;

const int MAXN = 4e5;
std::vector<pii> g[MAXN];

std::set<pii> bridges;

std::set<pii> notBridges;

int used[MAXN], h[MAXN], minH[MAXN];

void findBridges(int v, int p) {
    used[v] = true;
    for (auto &[to, cost] : g[v]) {
        if (to == p) continue;
        else if (used[to]) {
            minH[v] = std::min(minH[v], h[to]);
        } else {
            h[to] = h[v] + 1;
            findBridges(to, v);
            minH[v] = std::min(minH[v], minH[to]);
            if (minH[to] > h[v] && !notBridges.count(std::make_pair(v, to))) {
                bridges.insert(std::make_pair(v, to));
                bridges.insert(std::make_pair(to, v));
            }
        }
    }
}

int minInComp[MAXN];
int v2comp[MAXN];

void dfs(int v, int comp) {
    v2comp[v] = comp;
    used[v] = true;
    for (auto &[to, cost] : g[v]) {
        if (bridges.count(std::make_pair(v, to))) continue;
        minInComp[v2comp[v]] = std::min(minInComp[v2comp[v]], cost);
        if (used[to]) continue;
        dfs(to, comp);
    }
}

std::vector<pii> g1[MAXN];

int dp[MAXN];

void dfs2(int v, int p) {
    for(auto &[i, cost] : g1[v]) {
        if(i == p) continue;
        dp[i] = std::min(dp[i], cost);
        dp[i] = std::min(dp[i], dp[v]);
        dfs2(i, v);
    }
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::map<pii, int> cntEdges;
    for (int i = 0; i < m; i++) {
        int a, b, t;
        std::cin >> a >> b >> t;
        a--, b--;
        cntEdges[std::make_pair(a, b)]++;
        cntEdges[std::make_pair(b, a)]++;
        g[a].emplace_back(b, t);
        g[b].emplace_back(a, t);
    }

    for (auto &i : cntEdges) if (i.second > 1) notBridges.insert(i.first);

    memset(minH, inf, sizeof(minH));
    findBridges(0, 0);

    memset(used, 0, sizeof(used));
    memset(minInComp, inf, sizeof(minInComp));

    int nowComp = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, nowComp++);
        }
    }

    for(int i = 0; i < n; i++) {
        for(auto &[to, cost] : g[i]) {
            if(v2comp[i] != v2comp[to]) {
                g1[v2comp[i]].emplace_back(v2comp[to], cost);
                g1[v2comp[to]].emplace_back(v2comp[i], cost);

//                g1[v2comp[i]].insert(std::make_pair(v2comp[to], cost));
//                g1[v2comp[to]].insert(std::make_pair(v2comp[i], cost));
            }
        }
    }

    memcpy(dp, minInComp, sizeof dp);
    dfs2(0, 0);

    for(int i = 1; i < n; i++) {
        std::cout << 1'000'000'000 + dp[v2comp[i]] << ' ';
    }
}