#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>
#include <stack>
#include <list>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


struct tree {
	int x, h;
	bool to_dl = false;

	tree() : x(-1), h(-1), to_dl(false) {}
	tree(int x, int h) : x(x), h(h), to_dl(false) {}
};


int n, q;
vector<tree> trs;
vector<int> x;
vector<int> h;
vector<int> lx;
vector<int> rx;
vector<int> lcnt;
vector<int> rcnt;




void cnt_lrx() {
	lx.resize(n);
	rx.resize(n);
	for (int i = 0; i < n; ++i) {
		lx[i] = upper_bound(all(x), x[i] - h[i]) - x.begin();
		rx[i] = lower_bound(all(x), x[i] + h[i]) - x.begin() - 1;
	}
	
}


bool cn_dlt(list<tree>::iterator it) {
	auto it1 = it;
	it1--;
	auto it2 = it;
	it2++;
	if (it1->x <= it->x - it->h || it->x + it->h <= it2->x) {
		return true;
	}
	else {
		return false;
	}
}


int answer(int tl, int tr) {
	list<tree> t;
	if (tl == 0) {
		t.push_back(trs[0]);
	}
	else {
		t.push_back(trs[tl - 1]);
	}
	int b = 0;
	vector<list<tree>::iterator> d;
	for (int i = tl; i <= tr; ++i) {
		t.push_back(trs[i]);
	}
	if (tr == n - 1) {
		t.push_back(trs[n - 1]);
	}
	else {
		t.push_back(trs[tr + 1]);
	}
	auto frst = t.begin();
	auto lst = t.end();
	--lst;
	auto it = frst;
	++it;
	for (; it != lst; ++it) {
		if (cn_dlt(it)) {
			d.push_back(it);
			it->to_dl = true;
		}
	}
	int res = 0;
	while (b < d.size()) {
		++res;
		it = d[b++];
		auto it1 = it;
		it1--;
		auto it2 = it;
		it2++;
		t.erase(it);
		if (it1 != frst && !(it1->to_dl) && cn_dlt(it1)) {
			d.push_back(it1);
			it1->to_dl = true;
		}
		if (it2 != lst && !(it2->to_dl) && cn_dlt(it2)) {
			d.push_back(it2);
			it2->to_dl = true;
		}
	}
	return res;
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> q;
	x.resize(n);
	h.resize(n);
	trs.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
		trs[i] = tree(x[i], h[i]);
	}
	cnt_lrx();
	while (q--) {
		int tl, tr;
		cin >> tl >> tr;
		--tl;
		--tr;

		cout << answer(tl, tr) << "\n";
	}
	return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/