#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define pii pair<int, int>

using namespace std;

const int inf = 1e9 + 10;

struct reb {
	int to, w, i;
	reb() {}
	reb(int to_, int w_, int i_) {
		to = to_;
		w = w_;
		i = i_;
	}
};

int n, m;
vector<vector<reb>> g;
vector<int> d, used, tin, fup;
int timer = 0;

vector<int> dsu, mas, len, ans;
set<pii> all;
vector<int> u;

int get(int a) {
	if (dsu[a] == a) return a;
	return dsu[a] = get(dsu[a]);
}

void merge(int a, int b) {
	a = get(a);
	b = get(b);
	if (a == b) return;
	if (mas[a] > mas[b]) swap(a, b);
	dsu[a] = b;
	mas[b] += mas[a];
}

void dfs1(int v) {
	tin[v] = fup[v] = timer++;
	used[v] = 1;
	for (auto e : g[v]) {
		if (u[e.i]) continue;
		u[e.i] = 1;
		if (!used[e.to]) {
			dfs1(e.to);
			fup[v] = min(fup[v], fup[e.to]);

			if (fup[e.to] > tin[v]) {
				// reb
				all.insert({e.to, v});
				all.insert({v, e.to});
			}

		} else {
			fup[v] = min(fup[v], tin[e.to]);
		}
	}
}

void dfs2(int v, int dist) {
	used[v] = 1;
	dist = min(dist, len[get(v)]);
	ans[v] = dist;
	for (auto e : g[v]) {
		if (used[e.to]) continue;
		dfs2(e.to, min(dist, e.w));
	}
}

void solve() {
	// read
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b, x;
		cin >> a >> b >> x;
		a--; b--;
		g[a].pb(reb(b, x, i));
		g[b].pb(reb(a, x, i));
	}
	u.assign(m, 0);
	ans.assign(n, 3 * 1e9);
	
	// find componnents
	used.assign(n, 0);
	dsu.assign(n, 0);
	mas.assign(n, 1);
	len.assign(n, inf);
	for (int i = 0; i < n; i++) dsu[i] = i;
	tin.assign(n, 0);
	fup.assign(n, 0);

	dfs1(0);

	for (int i = 0; i < n; i++) {
		for (auto e : g[i]) {
			if (all.find({i, e.to}) == all.end()) {
				merge(i, e.to);
			}
		}
	}

	for (int i = 0; i < n; i++) {
		int www = get(i);
		// cout << dsu[i] << " " << len[dsu[i]] << endl;
	}
	
	for (int i = 0; i < n; i++) {
		for (auto e : g[i]) {
			if (all.find({i, e.to}) == all.end()) {
				if (get(i) == get(e.to)) {
					len[dsu[i]] = min(len[dsu[i]], e.w);
				}
			}
		}
	}


	used.assign(n, 0);
	dfs2(0, inf);


	for (int i = 1; i < n; i++) {
		cout << ans[i] + (int) (1e9)<< "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();

	return 0;
}
