#include <iostream>;
#include <map>;
#include <vector>;

using namespace std;

int max(int a, int b) {
	if (a > b) {
		return a;
	}
	return b;
}

long long calc(string s, map<char, long long>& val) {
	int n = s.size();
	vector <int> maxR;
	maxR.push_back(int(s[n - 1]));
	for (int i = 1; i < n; i++) {
		maxR.push_back(max(int(s[n - i - 1]), maxR[i - 1]));
	}

	long long res = 0;
	for (int i = 0; i < n; i++) {
		int m = 1;
		if (maxR[n - i - 1] > int(s[i])) {
			m = -1;
		}
		res += m * val[s[i]];
	}

	return res;
}


bool getNextStep(vector<int>& swap) {
	int i = 0;
	if (swap.size() == 0) {
		return false;
	}

	while (true) {
		if (swap[i] == 'Z') {
			swap[i] = 'A';
			i++;
			if (i >= swap.size()) {
				return false;
			}
		}
		else {
			swap[i] = char(int(swap[i]) + 1);
			return true;
		}
	}
}

void cycle(string &sbest, long long &maxcalc, string s, vector<int> &pos, map<char, long long> &val) {

	int m = pos.size();
	vector<int> swap;
	for (int i = 0; i < m; i++) {
		swap.push_back('A');
	}

	while (true) {
		string snew = "";
		int temp = s.size();
		int j = 0;
		for (int i = 0; i < temp; i++) {
			if (s[i] == '?') {
				snew += swap[j];
				j++;
			}
			else {
				snew += s[i];
			}
		}

		//cout << snew << endl;

		long long c = calc(snew, val);

		if (c > maxcalc) {
			maxcalc = c;
			sbest = snew;
		}


		if (!getNextStep(swap)) {
			return;
		}

	}

}


long long getValue(int c) {
	int d = c - int('A');
	int p1 = d / 2;
	int p2 = d % 2;
	long long valt = 1;
	for (int i = 0; i < p1; i++) {
		valt *= 10;
	}
	for (int i = 0; i < p2; i++) {
		valt *= 5;
	}
	return valt;
}

int main() {
	map<char, long long> val;

	int A = int('A');
	int Z = int('Z');


	for (int i = A; i <= Z; i++) {
		val[char(i)] = getValue(i);
	}

	//cout << val['Z'];

	int t;
	cin >> t;

	for (int _ = 0; _ < t; _++) {
		string s;
		cin >> s;
		int n = s.size();

		vector<int> pos;

		for (int i = 0; i < n; i++) {
			if (s[i] == '?') {
				pos.push_back(i);
			}
		}

		string sbest = "";
		long long maxcalc = -999999999999999999;

		cycle(sbest, maxcalc, s, pos, val);

		cout << maxcalc << endl << sbest << endl;
	}
}