#include <iostream>
#include <vector>
#include <cmath>
#include <unordered_set>

#define nei_set1(v) (is_parent ? nodes[v].children : nodes[v].parents)
#define nei_set2(v) (!is_parent ? nodes[v].children : nodes[v].parents)

using namespace std;

struct Node {
    int idx;

    unordered_set<int> children;
    unordered_set<int> parents;
};

struct Gadget {
    int v1, v2, v3;
};

bool is_leaf(const Node &node) {
    if (node.children.size() + node.parents.size() == 1) return true;

    if (node.children.size() == 1 && node.parents.size() == 1
        && *node.children.begin() == *node.parents.begin())
        return true;
    return false;
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<Node> nodes(n);
    unordered_set<int> leaves;
    for (int i = 0; i < n; ++i) nodes[i].idx = i;

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;

        a--;
        b--;

        nodes[a].children.insert(b);
        nodes[b].parents.insert(a);
    }

    for (auto &node : nodes) {
        if (is_leaf(node)) leaves.insert(node.idx);
    }

    vector<Gadget> res;

    while (!leaves.empty()) {
        int v1 = *leaves.begin();
        bool is_parent = nodes[v1].children.size() == 1;

        int v2 = *nei_set1(v1).begin();

        if (nei_set1(v2).empty()) {
            cout << "No" << endl;
            return 0;
        } else {
            int v3 = *nei_set1(v2).begin();

            nei_set2(v3).erase(v2);

            nei_set1(v2).erase(v3);
            nei_set2(v2).erase(v1);

            nei_set1(v1).erase(v2);

            if (is_parent) res.push_back({v1 + 1, v2 + 1, v3 + 1});
            else res.push_back({v3 + 1, v2 + 1, v1 + 1});

            if (is_leaf(nodes[v1])) leaves.insert(v2);
            else leaves.erase(v1);
            if (is_leaf(nodes[v2])) leaves.insert(v2);
            else leaves.erase(v2);
            if (is_leaf(nodes[v3])) leaves.insert(v3);
            else leaves.erase(v3);
        }
    }

    if (res.size() == m / 2) {
        cout << "Yes\n";

        for (auto gad : res) {
            cout << gad.v1 << " " << gad.v2 << " " << gad.v2 << " " << gad.v3 << "\n";
        }

        cout.flush();
    } else cout << "No" << endl;
}