#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;
vector<int> rmq;

void build(int v, int l, int r) {
	if (r == l + 1) {
		rmq[v] = 1;
		return;
	}
	int m = (l + r) / 2;
	build(v + v, l, m);
	build(v + v + 1, m, r);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

void upd(int v, int l, int r, int i) {
	if (r == l + 1) {
		rmq[v] = 0;
		return;
	}
	int m = (l + r) / 2;
	if (i < m) upd(v + v, l, m, i);
	else upd(v + v + 1, m, r, i);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int l, int r, int tl, int tr) {
	if (l == tl && r == tr) {
		return rmq[v];
	}
	int m = (l + r) / 2;
	if (tr <= m) return get(v + v, l, m, tl, tr);
	else if (tl >= m) return get(v + v + 1, m, r, tl, tr);
	return get(v + v, l, m, tl, m) + get(v + v + 1, m, r, m, tr);
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int n, q;
	cin >> n >> q;

	rmq.resize(4 * n);
	
	vector<pair<int, int>> a(n);
	for (int i{}; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}

	vector<int> lt(n), rt(n);

	for (int i{}; i < n; ++i) {
		int x = (int)(lower_bound(all(a), make_pair(a[i].x + a[i].y, -1ll)) - a.begin());
		rt[i] = x - 1;
		x = (int)(lower_bound(all(a), make_pair(a[i].x - a[i].y + 1, -1ll)) - a.begin());
		lt[i] = x;
	}

	int mn = a[0].x, mx = a[n - 1].x;

	while (q) {
		q--;
		int l, r;
		cin >> l >> r;

		build(1, 0, n);
		l--;
		r--;

		vector<int> used(n, false);

		int er = -1;
		int ans{};
		while (er != 0) {
			er = 0;
			for (int i{ l }; i <= r; ++i) {
				if (used[i]) continue;
				if (a[i].x - a[i].y >= mn) {
					if (lt[i] == i || get(1, 0, n, lt[i], i) == 0) {
						used[i] = true;
						upd(1, 0, n, i);
						++er;
						++ans;
					}
				}
				if (used[i]) continue;
				if (a[i].x + a[i].y <= mx) {
					if (rt[i] == i || get(1, 0, n, i + 1, rt[i] + 1) == 0) {
						used[i] = true;
						upd(1, 0, n, i);
						++er;
						++ans;
					}
				}

			}
		}

		cout << ans << '\n';

	}

	return 0;
}


/*
3 3
1 3
3 1
4 2
2 3
*/

/*
5 3
1 5
3 1
4 2
5 3
6 1
*/