#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <deque>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 200100;
int n;
int x[N], h[N];

vector<int> solve(int l, int r, int xl, int xr) {
	if (l > r) {
		return vector<int>();
	}
	if (l == r) {
		if (xl <= x[l] - h[l] || x[l] + h[l] <= xr) {
			return vector<int>();
		}
		else {
			return vector<int>(1, l);
		}
	}
	int m = (l + r) / 2;
	auto f = solve(l, m, xl, (m == r ? xr : x[m + 1]));
	auto s = solve(m + 1, r, x[m], xr);
	reverse(all(s));
	while (true) {
		int curl = (f.empty() ? xl : x[f.back()]);
		int curr = (s.empty() ? xr : x[s.back()]);
		if (f.size() && x[f.back()] + h[f.back()] <= curr) {
			f.pop_back();
		}
		else if (s.size() && x[s.back()] - h[s.back()] >= curl) {
			s.pop_back();
		}
		else break;
	}
	while (s.size()) {
		f.push_back(s.back());
		s.pop_back();
	}
	return f;
}

int main() {
	fastio;
	int q;
	cin >> n >> q;
	forn(i, n) {
		cin >> x[i] >> h[i];
	}

	vector<pair<int, int>> t(q);

	forn(i, q) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		t[i] = make_pair(l, r);
		cout << r - l + 1 - (int)solve(l, r, x[max(0, l - 1)], x[min(n - 1, r + 1)]).size() << '\n';
	}

	return 0;
}