#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T>& a)
{
    for (auto x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

const int INF32 = 1e9;
const int maxN = 300005;
int n, m;

namespace lnk
{
    const int maxV = 3e6;
    int V;
    int ptr[maxV];
    pii val[maxV];

    void init()
    {
        V = 1;
    }

    void add(int& v, pii x)
    {
        assert(V < maxV);
        ptr[V] = v;
        val[V] = x;
        v = V++;
    }
}

int G[maxN];

struct Edge
{
    int a, b, w;
    
    Edge() {}
    
    void read()
    {
        cin >> a >> b >> w;
    }
} edge[maxN];

bool used[maxN];
int tin[maxN], timer;
int fup[maxN];
bool bridge[maxN];

int C;
int comp[maxN];

int ans[maxN];

void dfsBridges(int v, int parEdge = -1)
{
//    debug(v);
    used[v] = 1;
    tin[v] = timer++;
    fup[v] = tin[v];
    for (int ii = G[v]; ii; ii = lnk::ptr[ii])
    {
        auto info = lnk::val[ii];
        int u = info.fi;
        int ei = info.se;
        if (ei == parEdge) continue;
        if (!used[u])
        {
            dfsBridges(u, ei);
            chkmin(fup[v], fup[u]);
            if (fup[u] > tin[v])
            {
                // (vu) is a bridge
//                cerr << "bridge " << v << ' ' << u << endl;
                bridge[ei] = true;
            }
        }
        else if (tin[u] < tin[v])
        {
            chkmin(fup[v], tin[u]);
        }
    }
//    debug(v, fup[v]);
}

void dfsComponent(int v)
{
//    debug(v);
    used[v] = true;
    comp[v] = C;
    for (int ii = G[v]; ii; ii = lnk::ptr[ii])
    {
        auto info = lnk::val[ii];
        int u = info.fi;
        int ei = info.se;
        if (comp[u] == -1 && !bridge[ei])
            dfsComponent(u);
    }
}

int H[maxN];
int mn[maxN];

void dfs3(int c, int pc = -1)
{
    for (int ii = H[c]; ii; ii = lnk::ptr[ii])
    {
        auto info = lnk::val[ii];
        int c1 = info.fi;
        int w = info.se;
        if (c1 != pc)
        {
            chkmin(mn[c1], mn[c]);
            chkmin(mn[c1], w);
            dfs3(c1, c);
        }
    }
}

int goodEdges[maxN], gesz;

void clr()
{
    lnk::init();
    timer = 0;
    for (int v = 1; v <= n; ++v)
    {
        G[v] = 0;
        //G[v].clear();
        used[v] = 0;
        comp[v] = -1;
    }
    for (int c = 0; c < C; ++c)
    {
        H[c] = 0;
        //H[c].clear();
        mn[c] = INF32;
    }
    C = 0;
    for (int ci = 0; ci < gesz; ++ci)
    {
        bridge[goodEdges[ci]] = false;
    }
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        auto& e = edge[i];
        e.read();
    }
    sort(edge, edge + m, [&](const Edge& e1, const Edge& e2) -> bool
    {
        return e1.w < e2.w;
    });

    fill(ans, ans + n + 1, 2e9 + 1);
    for (int r = 0; r < m; ++r)
    {
        {
            auto& e = edge[r];
            if (r > 0 && comp[e.a] == comp[e.b] && comp[e.a] != -1) continue;
            goodEdges[gesz++] = r;
        }
        clr();
        for (int ii = 0; ii < gesz; ++ii)
        {
            int i = goodEdges[ii];
            auto& e = edge[i];
            lnk::add(G[e.a], mp(e.b, i));
            lnk::add(G[e.b], mp(e.a, i));
        }
        dfsBridges(1);
        fill(comp, comp + n + 1, -1);
        for (int v = 1; v <= n; ++v)
            if (used[v] && comp[v] == -1)
            {
                dfsComponent(v);
                ++C;
            }
        fill(mn, mn + C, INF32);
        for (int ii = 0; ii < gesz; ++ii)
        {
            int i = goodEdges[ii];
            auto& e = edge[i];
            int ca = comp[e.a];
            int cb = comp[e.b];
            if (ca == -1 || cb == -1) continue;
            if (ca == cb)
            {
                chkmin(mn[ca], e.w);
            }
            else
            {
                lnk::add(H[ca], mp(cb, e.w));
                lnk::add(H[cb], mp(ca, e.w));
            }
        }
        /*debug(r);
        mdebug(comp + 1, n);*/
        dfs3(comp[1]);
        for (int v = 2; v <= n; ++v)
            if (used[v])
            {
//                debug(v, edge[r].w, mn[comp[v]]);
                chkmin(ans[v], edge[r].w + mn[comp[v]]);
            }
    }
    for (int v = 2; v <= n; ++v)
        cout << ans[v] << '\n';

    return 0;
}