#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <cstring>
#include <string>
#include <list>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

typedef long long ll;
typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back
#define all(a) (a).begin(), (a).end()

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

void solve();

int main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}

const int MAXN = 3e5 + 10;
vector<pii> graph[MAXN];
int mins[MAXN];
int maxs[MAXN];
int n, m;


void treeDfs(int v, int p, int mn, int mx) {
    mins[v] = mn;
    maxs[v] = mx;
    for (auto [u, t] : graph[v]) {
        if (u == p) continue;
        treeDfs(u, v, min(mn, t), max(mx, t));
    }
}

vector<pair<pii, int>> edges;
int clrs[MAXN];
bool used[MAXN];
vector<int> tin;
void fRDS(int v) {
    used[v] = true;
    tin.push_back(v);
    for (auto&[u, t] : graph[v]) {
        if (used[u]) continue;
        fRDS(u);
        u = -1;
    }
}
void sRDS(int v, int clr) {
    clrs[v] = clr;
    for (auto[u, t] : graph[v]) {
        if (u == -1) continue;
        if (clrs[u]) continue;
        sRDS(u, clr);
    }
}
vector<pii> graphRDS[MAXN];
int minRDS[MAXN];
void treeDfsRDS(int v, int p, int mn) {
    minRDS[v] = mn = min(minRDS[v], mn);
    for (auto [u, t] : graphRDS[v]) {
        if (u == p) continue;
        treeDfsRDS(u, v, min(mn, t));
    }
}
void solve() {
    cin >> n >> m;
    range(i, m) {
        int v, u, t; cin >> v >> u >> t; --v; --u;
        graph[v].pb({u, t});
        graph[u].pb({v, t});
        edges.push_back({{u, v}, t});
    }
    if (m == n - 1) {
        treeDfs(0, -1, 1e9, 0);
        prange(i, n - 1) {
            cout << mins[i] + maxs[i] << '\n';
        }
        return;
    }
    bool is2 = true;
    bool is3 = true;
    for (auto [u, t] : graph[0]) {
        if (t != 0) {
            is2 = false;
        }
        if (t != 1e9) {
            is3 = false;
        }
    }
    if (is2) {
        set<pair<int, int>> q; // maxt, v
        vector<bool> used(n, false);
        range(i, n) {maxs[i] = 1e9;}
        maxs[0] = 0;
        q.insert({0, 0});
        while (!q.empty()) {
            int v = q.begin()->second;
            q.erase(q.begin());
            used[v] = true;
            for (auto[u, t] : graph[v]) {
                if (used[u]) continue;
                int tt = max(t, maxs[v]);
                if (tt < maxs[u]) {
                    q.erase({maxs[u], u});
                    maxs[u] = tt;
                    q.insert({maxs[u], u});
                }
            }
        }
        prange(i, n - 1) {
            cout << maxs[i] << '\n';
        }
        return;
    } else if (is3) {
        fRDS(0);
        int clr = 0;
        range(i, n) {
            if (clrs[i]) continue;
            sRDS(i, ++clr);
        }
        fill(minRDS, minRDS + clr + 1, 1e9);
        for (auto [p, t] : edges) {
            auto [v, u] = p;
            int c1 = clrs[v], c2 = clrs[u];
            if (c1 == c2) {
                minRDS[c1] = min(minRDS[c1], t);
            } else {
                graphRDS[c1].pb({c2, t});
                graphRDS[c2].pb({c1, t});
            }
        }
        auto cc = clrs[0];
        treeDfsRDS(1, -1, minRDS[cc]);
        prange(i, n - 1) {
            cout << (ll)(minRDS[clrs[i]] + (ll)1e9) << '\n';
        }
    }
}



