#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int MAXN = 2e5;

int n, m, timer = 1;
set<int> g[MAXN], nfg[MAXN];
vector<int> tin(MAXN), tout(MAXN);

void dfs(int v, int prev = -1) {
    tin[v] = timer++;

    for (int u : g[v]) {
        if (u == prev) {
            continue;
        }

        dfs(u, v);
    }

    tout[v] = timer++;
}

// v -> u
inline bool is_child(int u, int v) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

struct Three {
    int a, b, c;

    Three(int a, int b, int c) : a(a), b(b), c(c) {}
};

vector<Three> ans;
vector<char> used(MAXN);

void mark2_dfs(int v, int prev = -1) {
    used[v] = true;
    if (prev != -1) {
        ans.emplace_back(prev, v, prev);
    }

    for (int u : g[v]) {
        if (u == prev) {
            continue;
        }

        mark2_dfs(u, v);
    }
}

void mark_dfs(int v, int mark, int child, int prev = -1) {
    used[v] == true;

    for (int u : g[v]) {
        if (u == prev || !is_child(child, u)) {
            if (u != prev) {
                mark2_dfs(u, v);
            }

            continue;
        }

        if (prev != -1) {
            if (mark) {
                ans.emplace_back(prev, v, u);
            } else {
                ans.emplace_back(u, v, prev);
            }
        }

        mark_dfs(u, mark ^ 1, child, v);
    }
}


int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;

        u--;
        v--;

        g[u].insert(v);
        g[v].insert(u);
        nfg[u].insert(v);
    }

    vector<pair<int, int>> empty;
    for (int i = 0; i < n; i++) {
        if (nfg[i].size() != g[i].size()) {
            for (int j : g[i]) {
                if (nfg[i].count(j) == 0) {
                    empty.emplace_back(i, j);
                }
            }
        }
    }

    if (empty.size() == 0) {
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                mark2_dfs(i);
            }
        }
    } else {

        dfs(empty.front().first);
        pair<int, int> a = empty[0];
        pair<int, int> b = empty[1];

        if (!is_child(b.first, b.second)) {
            cout << "No\n";
            exit(0);
        }

        mark_dfs(a.first, 1, b.first);

        for (auto& i : ans) {
            if ((i.a == a.first && i.b == a.second) || (i.a == b.first && i.b == b.second)) {
                cout << "No\n";
                exit(0);
            }
        }

        cerr << a.first << " " << a.second << "\n";
        cerr << b.first << " " << b.second << "\n";
    }

    cout << "Yes\n";
    for (auto& i : ans) {
        cout << (i.a + 1) << " " << (i.b + 1) << " " << (i.b + 1) << " " << (i.c + 1) << "\n";
    }

    return 0;
}
