#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 200;
const ll INF = 1e18;

int n, m;
vector<pair<ll, ll>> g[MAXN];
int used[MAXN][MAXN];

pair<ll, ll> dfs(int v, int to) {
    pair<ll, ll> ans = {INF, INF};
    for (auto [u, w] : g[v]) {
        if (u == to) {
            ans.first = min(ans.first, w);
            ans.second = min(ans.second, w);
        }

        if (used[v][u]) {
            continue;
        }

        used[v][u] = true;
        pair<ll, ll> x = dfs(u, to);
        ans.first = min(ans.first, min(x.first, w));
        ans.second = min(ans.second, max(x.second, w));

        used[v][u] = false;
    }

    return ans;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        ll u, v, w;
        cin >> u >> v >> w;

        u--;
        v--;

        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }

    for (int i = 1; i < n; i++) {
        pair<ll, ll> a = dfs(0, i);
        cout << (a.first + a.second) << "\n";
    }

    return 0;
}