#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> v2p;
typedef pair<pair<int, int>, int> Edge;

struct DSU {
    vi size, prev;
    DSU(int n) : size(n, 1), prev(n) {
        iota(prev.begin(), prev.end(), 0);
    }
    int get_prev(int v) {
        if (prev[v] == v)
            return v;
        return prev[v] = get_prev(prev[v]);
    }
    bool one(int v, int u) {
        v = get_prev(v);
        u = get_prev(u);
        return v == u;
    }
    void unite(int v, int u) {
        v = get_prev(v);
        u = get_prev(u);
        if (v == u)
            return;
        if (size[v] < size[u])
            swap(v, u);
        size[v] += size[u];
        prev[u] = v;
    }
};

void dfs(int v, int p, v2p& g, vi& ans, int way) {
    ans[v] = way;
    for (auto[to, t] : g[v])
        if (to != p)
            dfs(to, v, g, ans, max(way, t));
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<Edge> edge(m);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        edge[i] = make_pair(make_pair(v, u), t);
    }
    sort(edge.begin(), edge.end(), [&] (const Edge& a, const Edge& b) {
        return a.second < b.second;
    });
    DSU dsu(n);
    v2p g(n);
    for (int i = 0; i < m; ++i) {
        int v = edge[i].first.first, u = edge[i].first.second, t = edge[i].second;
        if (!dsu.one(v, u)) {
            dsu.unite(v, u);
            g[v].emplace_back(u, t);
            g[u].emplace_back(v, t);
        }
    }
    vi ans(n);
    dfs(0, -1, g, ans, 0);
    for (int i = 1; i < n; ++i)
        cout << ans[i] << '\n';
}
