﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const int INF = 1e9;

struct tr {
	int l, r, num;

	tr() = default;
	tr(int num) : l(0), r(0), num(num) {}
	bool operator< (const tr& other) const {
		return min(l, r) < min(other.l, other.r);
	}
};

int sol(int l, int r, vector<tr> a, vector<vector<int>> ndl, vector<vector<int>>& ndr) {
	vector<int> del(r + 1, 0);
	multiset<tr> s;
	for (int i = l; i <= r; ++i) {
		s.insert(a[i]);
	}
	int ans = 0;
	while (!s.empty()) {
		while (!s.empty() && del[s.begin()->num]) {
			s.erase(s.begin());
		}
		if (s.empty()) {
			return ans;
		}
		auto it = s.begin();
		if (min(it->l, it->r)) {
			return ans;
		}
		int ind = it->num;
		for (int i : ndl[ind]) {
			if (i < l || i > r) {
				continue;
			}
			--a[i].l;
			s.insert(a[i]);
		}
		for (int i : ndr[ind]) {
			if (i < l || i > r) {
				continue;
			}
			--a[i].r;
			s.insert(a[i]);
		}
		del[ind] = 1;
		++ans;
	}
	return ans;
}

int main() {
	int n, q;
	cin >> n >> q;
	vector<int> x(n), h(n);
	vector<tr> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
		a[i].num = i;
	}
	vector<vector<int>> ndl(n), ndr(n);
	int j;
	for (int i = 0; i < n; ++i) {
		if (x[i] - h[i] >= x[0]) {
			j = upper_bound(x.begin(), x.end(), x[i] - h[i]) - x.begin();
			for (; j < i; ++j) {
				ndl[j].push_back(i);
				++a[i].l;
			}
		}
		else {
			a[i].l = INF;
		}
		if (x[i] + h[i] <= x.back()) {
			j = lower_bound(x.begin(), x.end(), x[i] + h[i]) - x.begin();
			for (j = j - 1; j > i; --j) {
				ndr[j].push_back(i);
				++a[i].r;
			}
		}
		else {
			a[i].r = INF;
		}
	}

	int l, r;
	for (; q; --q) {
		cin >> l >> r;
		--l;
		--r;
		cout << sol(l, r, a, ndl, ndr) << '\n';
	}
	return 0;
}
