#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("tune=native")

#define ios ios_base::sync_with_stdio(true);cin.tie(0);cout.tie(0);
#define ll long long
#define len(x) (int)(x.size())

const ll INF = 2e18;

struct nd {
    int prior, node;

    bool operator<(const nd &a) const {
        return this->prior < a.prior || this->prior == a.prior && this->node > a.node;
    }
};

vector<set<int>> g;
vector<set<int>> gT;
priority_queue<nd> leaves;
stack<pair<pair<int, int>, pair<int, int>>> ans;
bool error = false;

int checkLeave(int v) {
    if (gT[v].empty() && len(g[v]) == 1)
        return 2;
    if (g[v].empty() && len(gT[v]) == 1)
        return 1;
    if (len(g[v]) == 1 && len(gT[v]) == 1 && *g[v].begin() == *gT[v].begin())
        return 3;
    return 0;
}

void popLeave() {
    int v = leaves.top().node, type = leaves.top().prior;
    leaves.pop();
    if(g[v].empty() && gT[v].empty())
        return;
    int u, k, t;
    switch (type) {
        case 1:
            u = *g[v].begin();
            if(g[u].empty()) {
                error = true;
                return;
            }
            k = *g[u].begin();
            ans.push({{v, u},
                      {u, k}});
            g[v].erase(u);
            gT[u].erase(v);
            g[u].erase(k);
            gT[k].erase(u);
            t = checkLeave(u);
            if (t) {
                leaves.push({t, u});
            }
            t = checkLeave(k);
            if (t) {
                leaves.push({t, k});
            }
            break;
        case 2:
            u = *gT[v].begin();
            if(gT[u].empty()) {
                error = true;
                return;
            }
            k = *gT[u].begin();
            ans.push({{k, u},
                      {u, v}});
            g[k].erase(u);
            gT[u].erase(k);
            g[u].erase(v);
            gT[v].erase(u);
            t = checkLeave(u);
            if (t) {
                leaves.push({t, u});
            }
            t = checkLeave(k);
            if (t) {
                leaves.push({t, k});
            }
            break;
        case 3:
            u = *g[v].begin();
            ans.push({{v, u},
                      {u, v}});
            g[u].erase(v);
            gT[v].erase(u);
            g[v].erase(u);
            gT[u].erase(v);
            t = checkLeave(u);
            if (t) {
                leaves.push({t, u});
            }
            break;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    gT.resize(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;--u;
        g[v].insert(u);
        gT[u].insert(v);
    }
    for (int i = 0; i < n; ++i) {
        int t = checkLeave(i);
        if (t) {
            leaves.push({t, i});
        }
    }
    while(!leaves.empty()){
        popLeave();
        if(error){
            cout << "No" << endl;
            return;
        }
    }
    if(len(ans) != m/2){
        cout << "No" << endl;
        return;
    }
    cout << "Yes" << "\n";
    while(!ans.empty()){
        cout << ans.top().first.first+1 << " " << ans.top().first.second+1 << " " <<
        ans.top().second.first+1 << " " << ans.top().second.second+1 << "\n";
        ans.pop();
    }
}

int main() {
    //freopen("input.txt", stdin, "r")
    //freopen("output.txt", stdout, "w")
    ios;
    solve();
    return 0;
}