#include <iostream>
#include <vector>
#include <set>
#define int long long

using namespace std;


struct dp_struct
{
    int up, down, up_down;
};


struct g_struct
{
    int to;
    bool exist;
};


struct to_p_struct
{
    int in, out;
};


vector<vector<g_struct>> g;
vector<to_p_struct> to_p;
vector<dp_struct> dp;
vector<bool> used;
vector<pair<int, int>> result;


void dfs_set(int u)
{
    used[u] = true;
    for (g_struct v: g[u])
    {
        if (v.exist)
        {
            if (!used[v.to]) to_p[v.to].in = true;
            if (used[v.to]) to_p[u].out = true;
        }
        if (!used[v.to]) dfs_set(v.to);
    }
}


void dp_dfs(int u)
{
    used[u] = true;
    int p = -1;
    for (g_struct v: g[u])
    {
        if (!used[v.to]) dp_dfs(v.to);
        else p = v.to;
    }
    int up = 0;
    int down = 0;
    int dual = 0;
    vector<int> up_v, down_v;
    for (g_struct v: g[u])
    {
        if (v.to != p)
        {
            if (dp[v.to].down)
            {
                if (!to_p[v.to].in)
                {
                    cout << "No" << endl;
                    exit(0);
                }
                if (!to_p[v.to].out) dual++;
                else
                {
                    up++;
                    up_v.push_back(v.to);
                }
            }
            if (dp[v.to].up)
            {
                if (!to_p[v.to].out)
                {
                    cout << "No" << endl;
                    exit(0);
                }
                if (!to_p[v.to].in) dual++;
                else
                {
                    down++;
                    down_v.push_back(v.to);
                }
            }
            if (dp[v.to].up_down)
            {
                if (!to_p[v.to].out)
                {
                    down++;
                    down_v.push_back(v.to);
                }
                else if (!to_p[v.to].in)
                {
                    up++;
                    up_v.push_back(v.to);
                }
                else
                {
                    dual++;
                    result.push_back({v.to, u});
                    result.push_back({u, v.to});
                }
            }
        }
    }
    if (up == down)
    {
        dp[u].up_down = true;
        for (int i(0); i < (int) up_v.size(); ++i)
        {
            result.push_back({up_v[i], u});
            result.push_back({u, down_v[i]});
        }
    }
    if (up == down + 1)
    {
        dp[u].up = true;
        if (p == -1)
        {
            cout << "No" << endl;
            exit(0);
        }
        for (int i(0); i < (int) down_v.size(); ++i)
        {
            result.push_back({up_v[i], u});
            result.push_back({u, down_v[i]});
        }
        result.push_back({up_v.back(), u});
        result.push_back({u, p});
    }
    if (up == down - 1)
    {
        dp[u].down = true;
        if (p == -1)
        {
            cout << "No" << endl;
            exit(0);
        }
        for (int i(0); i < (int) up_v.size(); ++i)
        {
            result.push_back({up_v[i], u});
            result.push_back({u, down_v[i]});
        }
        result.push_back({p, u});
        result.push_back({u, down_v.back()});
    }
    if (!dp[u].up && !dp[u].down && !dp[u].up_down)
    {
        cout << "No" << endl;
        exit(0);
    }
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    to_p.resize(n);
    dp.resize(n);
    used.resize(n);
    set<pair<int, int>> s;
    for (int i(0); i < m; ++i)
    {
        int f, t;
        cin >> f >> t;
        f--;
        t--;
        g[f].push_back({t, true});
        s.insert({f, t});
    }
    for (pair<int, int> i: s)
    {
        if (s.find({i.second, i.first}) == s.end()) g[i.second].push_back({i.first, false});
    }
    for (int i(0); i < n; ++i)
    {
        if (!used[i]) dfs_set(i);
    }
    used.assign(n, false);
    for (int i(0); i < n; ++i)
    {
        if (!used[i]) dp_dfs(i);
    }
    cout << "Yes" << endl;
    for (int i(0); i < (int) result.size(); i += 2) cout << result[i].first + 1 << ' ' << result[i].second + 1 << ' ' << result[i + 1].first + 1 << ' ' << result[i + 1].second + 1 << endl;
    return 0;
}
