#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
#include <set>
#include <cassert>

using namespace std;

const int MAXN = 300020;
const int INF = 1e9;
vector<pair<int, int> > g[MAXN];

int mmax[MAXN];
int mmin[MAXN];
bool used[MAXN];

int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, u, t;
		cin >> v >> u >> t;
		--v; --u;
		g[v].push_back(make_pair(u, t));
		g[u].push_back(make_pair(v, t));
	}
	for (int i = 1; i < n; ++i) {
		mmax[i] = INF;
		mmin[i] = 0;
	}
	mmin[0] = 0;
	mmax[0] = 0;
	set<pair<int, int>> st;
	st.insert(make_pair(0, 0));
	for (int i = 0; i < n - 1; ++i) {
		pair<int, int> p = *st.begin();
		st.erase(st.begin());
		int v = p.second;
		for (pair<int, int> e : g[v]) {
			int newMin = min(mmin[v], e.second);
			int newMax = max(mmax[v], e.second);
			if (newMin + newMax < mmin[e.first] + mmax[e.first]) {
				//mmin[e.first] = newMin;
				st.erase(st.find(make_pair(mmax[e.first], e.first)));
				mmax[e.first] = newMax;
				st.insert(make_pair(mmax[e.first], e.first));
			}
		}
		used[v] = true;
	}
	for (int i = 1; i < n; ++i) {
		assert(mmin[i] == 0);
		cout << mmin[i] + mmax[i] << "\n";
	}
}

/*
3 3
1 2 2
1 3 1
2 3 1
*/

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/

/*
5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1
*/