#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>
#include <set>
#include <array>

using namespace std;

typedef long long ll;

const int N = 500010;

struct edge {
	int v, to;
	int num;
};

int vh[N], vih[N];

vector < array < int, 4 > > ans;

set < pair < int, int > > s;

set < int > g[N], ish_g[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int n, m;

	cin >> n >> m;

	for (int i = 1; i <= m; ++i) {
		int v, to;
		cin >> v >> to;
		vh[to]++;
		vih[v]++;
		s.insert({ v, to });
		g[to].insert(v);
		ish_g[v].insert(to);
	}

	bool ok = true;

	bool rev = false;

	while (m > 0) {
		if (!ok)
			break;
		bool done = false;
		for (int i = 1; i <= n; ++i) {
			if (vh[i] == 1 && vih[i] == 0) {
				int to = *g[i].begin();
				if (g[to].size() == 0) {
					ok = false;
					break;
				}
				ans.push_back({ *g[to].begin(), to, to, i });
				if (rev)
					reverse(ans.back().begin(), ans.back().end());
				m -= 2;
				ish_g[*g[to].begin()].erase(to);
				--vih[*g[to].begin()];
				ish_g[to].erase(i);
				--vih[to];
				g[to].erase(*g[to].begin());
				vh[to]--;
				g[i].erase(to);
				vh[i]--;
				done = true;
			}
		}
		if (done)
			continue;
		for (int i = 1; i <= n; ++i) {
			if (vh[i] == 1) {
				m -= 2;
				int to = *g[i].begin();
				int sto = *ish_g[i].begin();
				ans.push_back({ to, i, i, sto });
				if (rev)
					reverse(ans.back().begin(), ans.back().end());
				ish_g[to].erase(i);
				--vih[to];
				ish_g[i].erase(sto);
				--vih[i];
				g[sto].erase(i);
				--vh[sto];
				g[i].erase(to);
				--vh[i];
				done = true;
				break;
			}
		}
		if (done)
			continue;
		for (int i = 1; i <= n; ++i) {
			if (vh[i] >= 1 && vih[i] >= 1) {
				m -= 2;
				int to = *g[i].begin();
				int sto = *ish_g[i].begin();
				ans.push_back({ to, i, i, sto });
				if (rev)
					reverse(ans.back().begin(), ans.back().end());
				ish_g[to].erase(i);
				--vih[to];
				ish_g[i].erase(sto);
				--vih[i];
				g[sto].erase(i);
				--vh[sto];
				g[i].erase(to);
				--vh[i];
				done = true;
				break;
			}
		}

		for (int i = 1; i <= n; ++i) {
			if (vh[i] >= 1) {
				int to = *g[i].begin();
				if (g[to].size() == 0) {
					ok = false;
					break;
				}
				ans.push_back({ *g[to].begin(), to, to, i });
				if (rev)
					reverse(ans.back().begin(), ans.back().end());
				m -= 2;
				ish_g[*g[to].begin()].erase(to);
				--vih[*g[to].begin()];
				ish_g[to].erase(i);
				--vih[to];
				g[to].erase(*g[to].begin());
				vh[to]--;
				g[i].erase(to);
				vh[i]--;
				done = true;
			}
		}
		if (done)
			continue;
		
	}

	if (!ok) {
		cout << "No";
		return 0;
	}

	cout << "Yes\n";

	for (auto t : ans) {
		cout << t[0] << ' ' << t[1] << ' ' << t[2] << ' ' << t[3] << '\n';
	}

}