#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <stack>

using namespace std;

#define endl '\n'

struct Cur
{
	vector<long long> plus = vector<long long>(26, 0);
	vector<long long> minus = vector<long long>(26, 0);

	string fill;
};

long long count(Cur c)
{
	long long ret = 0;

	for (long long i = 0; i < 26; i++)
	{
		if (i % 2 == 1)
		{
			ret += c.plus[i] * 5 * pow(10, i / 2);
			ret -= c.minus[i] * 5 * pow(10, i / 2);
		}
		else
		{
			ret += c.plus[i] * pow(10, i / 2);
			ret -= c.minus[i] * pow(10, i / 2);
		}
	}

	return ret;
}

void task()
{
	long long n;
	cin >> n;

	for (long long t = 0; t < n; t++)
	{
		string str;
		cin >> str;

		vector<pair<Cur, long long>> dp(26, { {}, 0 });

		Cur here;

		for (long long i = 0; i < str.size(); i++)
		{
			if (str[i] != '?')
			{
				here.plus[str[i] - 'A']++;

				for (long long j = 0; j < str[i] - 'A'; j++)
				{
					here.minus[j] += here.plus[j];
					here.plus[j] = 0;
				}
			}
			else
			{
				vector<pair<Cur, long long>> newdp(26, { {}, LLONG_MIN });

				for (long long j = 0; j < 26; j++)
				{
					Cur newcur = here;
					newcur.plus[j]++;

					for (long long k = 0; k < j; k++)
					{
						newcur.minus[k] += newcur.plus[k];
						newcur.plus[k] = 0;
					}

					long long max = -1;

					for (long long k = 0; k < 26; k++)
					{
						if (newcur.plus[k] > 0)
						{
							max = k;
						}
					}

					for (long long k = 0; k < 26; k++)
					{
						Cur dpcount = dp[k].first;

						for (long long f = 0; f < max; f++)
						{
							dpcount.minus[k] += dpcount.plus[k];
							dpcount.plus[k] = 0;
						}

						long long allcount = count(dpcount) + count(newcur);

						if (allcount > newdp[j].second)
						{
							Cur ins;
							ins.fill = dpcount.fill;
							ins.fill.push_back('A' + k);

							for (long long f = 0; f < 26; f++)
							{
								ins.plus[f] = dpcount.plus[f] + newcur.plus[f];
								ins.minus[f] = dpcount.minus[f] + newcur.minus[f];
							}

							newdp[j] = { ins, count(ins) };
						}
					}
				}

				dp = newdp;
			}
		}

		long long max = 0;

		for (long long j = 0; j < 26; j++)
		{
			dp[j].second = count(dp[j].first) + count(here);
			if (dp[j].second > dp[max].second)
			{
				max = j;
			}
		}

		cout << dp[max].second << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}
