#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define pii pair<int, int>
#define vi vector<int>
#define vpii vector<pii>
#define vvi vector<vi>

const int N = 2e5 + 5;
const ll INF = 1e18;

set<int> f[N];
vi vis(N, 0);
vi a[N];
vector<pair<pii, pii>> ans;
void dfs(int v, int p = -1) {
	vis[v] = 1;
	vi from, to;
	for (auto u : a[v]) {
		if (vis[u]) continue;
		dfs(u, v);
		if (f[v].count(u)) from.push_back(u);
		if (f[u].count(v)) to.push_back(u);
	}
	if (from.size() == to.size()) {
		for (int i = 0; i < to.size(); ++i) {
			ans.push_back({ {to[i], i}, {i, from[i]} });
		}
	}
	else if (from.size() + 1 == to.size() && p != -1 && f[v].count(p)) {
		for (int i = 0; i < from.size(); ++i) {
			ans.push_back({ {to[i], i}, {i, from[i]} });
		}
		f[v].erase(p);
		ans.push_back({ { to.back(), v }, { v, p } });
	}
	else if (from.size() == to.size() + 1 && p != -1 && f[p].count(v)) {
		for (int i = 0; i < to.size(); ++i) {
			ans.push_back({ {to[i], i}, {i, from[i]} });
		}
		f[p].erase(v);
		ans.push_back({ { p, v }, { v, from.back() } });
	}
	else {
		cout << "No\n";
		exit(0);
	}
}
void solve() {
	int n, m; cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int x, y; cin >> x >> y;
		--x, --y;
		a[x].push_back(y);
		a[y].push_back(x);
		f[x].insert(y);
	}
	for (int i = 0; i < n; ++i) {
		if (!vis[i]) {
			dfs(i);
		}
	}
	cout << "Yes\n";
	for (auto u : ans) {
		cout << u.first.first + 1 << ' ' << u.first.second + 1 << ' '
			<< u.second.first + 1 << ' ' << u.second.second + 1 << '\n';
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
/*

3 3
1 3
3 1
4 2
1 1
2 3
1 3


*/