#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define pii pair<int, int>
#define vi vector<int>
#define vpii vector<pii>
#define vvi vector<vi>

const int N = 5005;
const ll INF = 1e18;

vi x(N), h(N), a[N], lf(N), rf(N);
vi vis(N, 0);

void solve() {
	
	int n, t; cin >> n >> t;
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
	}
	for (int i = 0; i < n; ++i) {
		if (x[i] + h[i] > x[n - 1]) rf[i] = INF;
		for (int j = i + 1; j < n; ++j) {
			if (x[i] + h[i] > x[j]) {
				++rf[i];
				a[j].push_back(i);
			}
		}
		if (x[i] - h[i] < x[0]) lf[i] = INF;
		for (int j = 0; j < i; ++j) {
			if (x[i] - h[i] < x[j]) {
				++lf[i];
				a[j].push_back(i);
			}
		}
	}
	
	while (t--) {
		vis = vi(n, 0);
		int l, r; cin >> l >> r;
		--l, --r;
		queue<int> q;
		int ans = 0;
		for (int i = l; i <= r; ++i) {
			if (!lf[i] || !rf[i]) {
				q.push(i);
				vis[i] = 1;
			}
		}
		auto ln = lf, rn = rf;
		while (q.size()) {
			auto v = q.front();
			++ans;
			q.pop();
			for (auto u : a[v]) {
				if (vis[u] || u > r || u < l) continue;
				if (v > u) {
					--rn[u];
					if (!rn[u]) {
						vis[u] = 1;
						q.push(u);
					}
				}
				else {
					--ln[u];
					if (!ln[u]) {
						vis[u] = 1;
						q.push(u);
					}
				}
			}
		}
		cout << ans << '\n';
	}

}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}

/*

C

3 3
1 3
3 1
4 2
1 1 
2 3
1 3

D
3 3
1 2 2
1 3 1
2 3 1

4 4
1 2 2
3 2 0
2 4 3
4 3 1


*/