#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

const long long INF = 3e18;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    vector<long long> vals(26);
    vals[0] = 1;
    for (int i = 1; i < 26; ++i) {
        if (i % 2 == 1) {
            vals[i] = vals[i - 1] * 5ll;
        }
        else {
            vals[i] = vals[i - 1] * 2ll;
        }
    }
    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<long long>> dp(n, vector<long long>(26, -INF));
        vector<vector<pair<char, int>>> p(n, vector<pair<char, int>>(26, {'?', -1}));
        if (s[n - 1] == '?') {
            for (int i = 0; i < 26; ++i) {
                dp[n - 1][i] = vals[i];
                p[n - 1][i] = {'A' + i, -1};
            }
        }
        else {
            dp[n - 1][s[n - 1] - 'A'] = vals[s[n - 1] - 'A'];
            p[n - 1][s[n - 1] - 'A'] = {s[n - 1], -1};
        }
        for (int i = n - 2; i >= 0; --i) {
            if (s[i] == '?') {
                for (int q = 0; q < 26; ++q) {
                    for (int j = 0; j <= q; ++j) {
                        if (dp[i + 1][j] + vals[q] > dp[i][q]) {
                            dp[i][q] = dp[i + 1][j] + vals[q];
                            p[i][q] = {q + 'A', j};
                        }
                    }
                    for (int j = q + 1; j < 26; ++j) {
                        if (dp[i + 1][j] - vals[q] > dp[i][j]) {
                            dp[i][j] = dp[i + 1][j] - vals[q];
                            p[i][j] = {q + 'A', j};
                        }
                    }
                }
            }
            else {
                for (int j = 0; j <= s[i] - 'A'; ++j) {
                    if (dp[i + 1][j] + vals[s[i] - 'A'] > dp[i][s[i] - 'A']) {
                        dp[i][s[i] - 'A'] = dp[i + 1][j] + vals[s[i] - 'A'];
                        p[i][s[i] - 'A'] = {s[i], j};
                    }
                }
                for (int j = s[i] - 'A' + 1; j < 26; ++j) {
                    if (dp[i + 1][j] - vals[s[i] - 'A'] > dp[i][j]) {
                        dp[i][j] = dp[i + 1][j] - vals[s[i] - 'A'];
                        p[i][j] = {s[i], j};
                    }
                }
            }
        }
        auto it = max_element(dp[0].begin(), dp[0].end());
        long long ans = *it;
        string sans;
        int ind = it - dp[0].begin();
        for (int i = 0; i < n; ++i) {
            sans += p[i][ind].first;
            ind = p[i][ind].second;
        }
        cout << sans << "\n" << ans << "\n";
    }

    return 0;
}
