#include <iostream>
#include <vector>
#include <algorithm>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 3e5 + 228;
const int INF = 1e9 + 228;

int ans[N];

struct dsu {
	vector<int> p;
	vector<vector<int>> comp;
	dsu(int n) {
		p.resize(n);
		comp.resize(n);
		for (int i = 0; i < n; ++i)
			p[i] = i, comp[i] = vector<int> (1, i);
	}

	int get(int a) {
		if (a == p[a])
			return a;
		return get(p[a]);
	}

	void merge(int a, int b) {
		a = get(a), b = get(b);
		if (a == b)
			return;
		if (comp[a].size() < comp[b].size()) {
			p[a] = b;
			while (comp[a].size()) {
				comp[b].push_back(comp[a].back());
				comp[a].pop_back();
			}
		} else {
			p[b] = a;
			while (comp[b].size()) {
				comp[a].push_back(comp[b].back());
				comp[b].pop_back();
			}
		}
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<array<int, 3>> e;
	for (int i = 0; i < m; ++i) {
		int a, b, t;
		cin >> a >> b >> t;
		e.push_back({t, a - 1, b - 1});
	}
	sort(rall(e));
	dsu d(n);
	vector<int> ans(n, 1e9);
	for (auto i : e) {
		i[1] = d.get(i[1]), i[2] = d.get(i[2]);
		if (i[1] != i[2]) {
			if (i[2] == d.get(0)) {
				for (auto j : d.comp[i[1]])
					ans[j] = i[0];
			} else if (d.get(i[1]) == d.get(0)) {
				for (auto j : d.comp[i[2]])
					ans[j] = i[0];
			}
			d.merge(i[1], i[2]);
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << '\n';
	}
}