#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

int POW[18];

int sum(char x) {
    int g = x;
    int j = POW[g/2];
    if (g&1) j *= 5;
    return j;
}

const int mxn = 3e5 + 100;
int dp[mxn]['Z'-'A'+1];

void solut() {
    string s;
    cin >> s;
    int n = s.size();
    for (char &i : s) {
        i -= 'A';
    }
    memset(dp, -10000000, sizeof(int) * n * ('Z' - 'A' + 1));
    //cout << dp[0][0] << endl;


    vector<vector<vector<int32_t>>> pred(n, vector<vector<int32_t>>('Z'-'A'+1, vector<int32_t>(3)));

    if (s[n-1] == '?'-'A') {
        for (int32_t i = 0; i <= 'Z'-'A'; ++i) {
            dp[n-1][i] = sum(i);
            pred[n-1][i] = {-1, -1, i};
        }
    } else {
        dp[n-1][s[n-1]] = sum(s[n-1]);
        pred[n-1][s[n-1]] = {-1, -1, s[n-1]};
    }

    for (int32_t i = n-2; i >= 0; --i) {
        if (s[i] == '?'-'A') {
            for (int32_t c = 0; c <= 'Z'-'A'; ++c) {
                for (int32_t j = 0; j <= c; ++j) {
                    if (dp[i][c] <  dp[i+1][j] + sum(c)) {
                        dp[i][c] =  dp[i+1][j] + sum(c);
                        pred[i][c] = {i+1, j, c};
                    }
                }
                for (int j = c+1; j <= 'Z'-'A'; ++j) {
                    if (dp[i][j] < dp[i+1][j] - sum(c)) {
                        dp[i][j] = dp[i+1][j] - sum(c);
                        pred[i][j] = {i+1, j, c};
                    }
                }
            }
        } else {
            for (int j = 0; j <= s[i]; ++j) {
                if (dp[i][s[i]] < dp[i+1][j] + sum(s[i])) {
                    dp[i][s[i]] = dp[i+1][j] + sum(s[i]);
                    pred[i][s[i]] = {i+1, j, s[i]};
                }
            }
            for (int j = s[i]+1; j <= 'Z'-'A'; ++j) {
                if (dp[i][j] < dp[i+1][j] - sum(s[i])) {
                    dp[i][j] = dp[i+1][j] - sum(s[i]);
                    pred[i][j] = {i+1, j, s[i]};
                }
            }
        }
    }

    int C = 0;
    for (int i = 0; i <= 'Z'-'A'; ++i) {
        if (dp[0][C] < dp[0][i]) {
            C = i;
        }
    }
    cout << dp[0][C] << "\n";
    string ans;
    vector<int32_t> cur = pred[0][C];
    for (int i = 0; i < n; ++i) {
        ans += char(cur[2] + 'A');
        if (i == n-1) break;
        cur = pred[cur[0]][cur[1]];
    }


    cout << ans << "\n";
}

int32_t main() {
    POW[0] = 1;
    for (int i = 1; i < 18; ++i) {
        POW[i] = POW[i-1] * 10;
    }
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solut();
}
