#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

map<pair<int,int>, int> E;
vector<vector<int>> G, gr;
vector<int> used;
vector<int> dp;
vector<vector<int>> ans;
vector<pair<int,int>> ost;

void dfs1(int v) {
    used[v] = 1;
    for (int i : G[v]) {
        if (!used[i]) {
            dfs1(i);
            gr[v].push_back(i);
        }
    }
}

void dfs(int v) {
    if (gr[v].empty()) {
        dp[v] = 0;
        return;
    }

    for (int i : gr[v]) {
        dfs(i);
        if (dp[i] == 1e9) {
            dp[v] = 1e9;
            return;
        }
    }

    set<pair<int,int>> e1, e2;
    for (int i : gr[v]) {
        if (E[{v, i}]) e1.insert({v, i});
        if (E[{i, v}]) e2.insert({i, v});
    }

    for (int i : gr[v]) {
        if (dp[i] == 1) {
            if (E[{v, i}]) {
                ans.push_back({ost[i].fi, ost[i].se, v, i});
                e1.erase({v, i});
            } else {
                dp[v] = 1e9;
                return;
            }
        } else if (dp[i] == -1) {
            if (E[{i, v}]) {
                ans.push_back({ost[i].fi, ost[i].se, i, v});
                e2.erase({i, v});
            } else {
                dp[v] = 1e9;
                return;
            }
        } else if (dp[i] == 0) {
            continue;
        } else {
            assert(0);
        }
    }
    int a = e1.size(), b = e2.size();

    if (abs(a-b) > 1) {
        dp[v] = 1e9;
        return;
    } else {
        auto i1 = e1.begin();
        auto i2 = e2.begin();
        while (i1 != e1.end() && i2 != e2.end()) {
            ans.push_back({i1->fi, i1->se, i2->fi, i2->se});
            i1++;
            i2++;
        }
        if (i1 != e1.end()) {
            dp[v] = 1;
            ost[v] = *i1;
        }
        if (i2 != e2.end()) {
            dp[v] = -1;
            ost[v] = *i2;
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    used.resize(n);
    G.resize(n);
    gr.resize(n);
    dp.resize(n);
    ost.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        G[u].push_back(v);
        G[v].push_back(u);
        E[{u, v}] = 1;
    }

    vector<int> roots;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            roots.push_back(i);
            dfs1(i);
        }
    }


    for (int r : roots) {
        dfs(r);
        if (dp[r] != 0) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (auto i : ans) {
        cout << i[0]+1 << ' ' << i[1]+1 << ' ' << i[2]+1 << ' ' << i[3]+1 << "\n";
    }
}

/*
 * 5 6
1 2
2 1
1 5
2 3
2 4
4 2
 */