#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

vector<vector<pair<int,int>>> gr, G;
vector<int> ans, dsu, deep, dp, used, comp, MN;
set<pair<int,int>> brid;
vector<vector<int>> vert;

void dfs(int v, int p=-1, int d=0) {
    used[v] = 1;
    deep[v] = d;
    dp[v] = deep[v];
    for (auto [i, c] : gr[v]) {
        if (!used[i]) {
            dfs(i, v, d+1);
            dp[v] = min(dp[v], dp[i]);
        }
    }
    if (dp[v] < deep[v]) {
        brid.insert({min(v, p), max(v, p)});
    }
}

void dfs2(int v, int col) {
    used[v] = col;
    comp[v] = col;
    for (auto[i, c] : gr[v]) {
        if (!used[i] && !brid.count({min(i, v), max(i, v)})) {
            dfs2(i, col);
        }
    }
}

void dfs3(int v, int mn = 1e15, int p=-1) {
    mn = min(mn, MN[v]);
    for (int i : vert[v]) {
        ans[i] = mn;
    }
    for (auto [i, c] : G[v]) {
        if (i != p) {
            dfs3(i, min(mn, c), v);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    ans.resize(n);
    dsu.resize(n);
    deep.resize(n);
    used.resize(n);
    dp.resize(n);
    comp.resize(n);
    for (int i = 0; i < n; ++i) {
        dsu[i] = i;
    }
    vector<vector<int>> E;
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        gr[u].push_back({v, c});
        gr[v].push_back({u, c});
        E.push_back({u, v, c});
    }
    dfs(0);

    used.assign(n, 0);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            cnt++;
            dfs2(i, cnt);
        }
    }
    cnt++;
    MN.resize(cnt, 1e15);
    G.resize(cnt);
    used.assign(cnt, 0);
    vert.resize(cnt+1);
    for (int i = 0; i < n; ++i) {
        vert[comp[i]].push_back(i);
    }

    for (auto i : E) {
        if (comp[i[0]] != comp[i[1]]) {
            G[comp[i[0]]].push_back({comp[i[1]], i[2]});
            G[comp[i[1]]].push_back({comp[i[0]], i[2]});
        } else {
            MN[comp[i[0]]] = min(MN[comp[i[0]]], i[2]);
        }
    }

    dfs3(comp[0]);

    for (int i = 1; i < n; ++i) cout << ans[i] + (int)(1e9) << "\n";
}