#include <bits/stdc++.h>
using namespace std;

#define right right1
#define left left1

typedef long long ll;
typedef long double ldb;

int n;
vector<pair<int, int>> arr;

vector<int> left, right;

mt19937 rd(228);

struct node {
    node *l, *r;
    int sz;
    int x;
    int y;
    int mn;

    node(int x) :x(x) {
        l = r = NULL;
        sz = 1;
        y =rd();
        mn = x;
    }
};

int get_sz(node *n) {
    return (n == NULL) ? 0 : n->sz;
}

int get_mn(node *n) {
    return (n == NULL) ? 1e9 : n->mn;
}

void pull(node *a) {
    a->sz = 1 + get_sz(a->l) + get_sz(a->r);
    a->mn = min(a->mn, min(get_mn(a->l), get_mn(a->r)));
}

node *merge(node *a, node *b) {
    if (a == NULL)
        return b;
    if (b == NULL)
        return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        pull(a);
        return a;
    }
    b->l = merge(a, b->l);
    pull(b);
    return b;
}

pair<node *, node *> split(node *n, int x) { // [<= x, >x]
    if (n == NULL) {
        return {n, n};
    }
    if (n->x <= x) {
        auto pp = split(n->r, x);
        n->r = pp.first;
        pull(n);
        return {n, pp.second};
    }
    auto pp = split(n->l, x);
    n->l = pp.second;
    pull(n);
    return {pp.first, n};
}

pair<node *, node *> split_sz(node *n, int k) {
    if (n == NULL) {
        return {n, n};
    }
    if (get_sz(n->l) >= k) {
        auto pp = split_sz(n->l, k);
        n->l = pp.second;
        pull(n);
        return {pp.first, n};
    }
    auto pp = split_sz(n->r, k - 1 - get_sz(n->l));
    n->r = pp.first;
    pull(n);
    return {n, pp.second};
}

namespace Tree1 {
    
    const int MAXN = 5e5;
    const int NEUTRAL = 1e9;

    struct data {
        node *xs, *ys;
        data() {
            xs = NULL;
            ys = NULL;
        }

        void insert(int x, int y) {
            auto pp1 = split(xs, x);
            auto pp2 = split_sz(ys, get_sz(pp1.first));
            xs = merge(pp1.first, merge(new node(x), pp1.second));
            ys = merge(pp2.first, merge(new node(y), pp2.second));
        }

        int get(int x) {
            auto pp1 = split(xs, x);
            auto pp2 = split_sz(ys, get_sz(pp1.first));
            int ans = get_mn(pp2.second);
            xs = merge(pp1.first, pp1.second);
            ys = merge(pp2.first, pp2.second);
            return ans;
        }
    };

    data tree1[4 * MAXN];

    void set(int v, int l, int r, int i, int x, int y) {
        if (i < l || i >= r) {
            return;
        }
        tree1[v].insert(x, y);
        if (l + 1 != r) {
            int m = (l + r) / 2;
            set(2 * v + 1, l, m, i, x, y);
            set(2 * v + 2, m, r, i, x, y);
        }
    }

    void set(int i, int x, int y) {
        set(0, 0, MAXN, i, x, y);
    }


    int get(int v, int l, int r, int ql, int qr, int x) {
        if (l >= qr || r <= ql) {
            return  NEUTRAL;
        }
        if (ql <= l && r <= qr) {
            return tree1[v].get(x);
        }
        int m = (l + r) / 2;
        return min(
                get(2 * v + 1, l, m, ql, qr, x),
                get(2 * v + 2, m, r, ql, qr, x)
                );
    }

    int get(int l, int r, int x) {
        return get(0, 0, MAXN, l, r, x);
    }
};


void calcLeft() {
    left.resize(n, -1);
    Tree1::set(n - 1, arr[n - 1].first + arr[n - 1].second, -1);
    for (int i = 1; i < n; i++) {
        if (arr[i].first - arr[i].second < arr[0].first) {
        } else {
            int x = arr[i].first - arr[i].second;
            int l = 0;
            int r = i;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (arr[m].first <= x) {
                    l = m;
                } else {
                    r = m;
                }
            }
            left[i] = min(r, Tree1::get(r, i, arr[i].first));
        }
        Tree1::set(i, arr[i].first + arr[i].second, left[i]);
    }
}

void calcRight() {
    right.resize(n, n);
    for (int i = n - 2; i >= 0; i--) {
        if (arr[i].first + arr[i].second > arr[n - 1].first) {
            continue;
        } else {
            int x = arr[i].first + arr[i].second;
            int l = i;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (arr[m].first >= x) {
                    r = m;
                } else {
                    l = m;
                }
            }
            right[i] = l;
            for (int j = l; j > i; j--) {
                if (arr[j].first - arr[j].second < arr[i].first) {
                    right[i] = max(right[i], right[j]);
                }
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    calcLeft();
    calcRight();

    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        int ans = 0;
        for (int i = l; i < r; i++) {
            if (left[i] >= l || right[i] < r) {
                ans++;
            }
        }
        cout << ans << endl;
    }
}
