#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

int n;

vector<vector<pair<int, int>>> g;
vector<int> ans;

void dfs(int v, int mn, int mx, int p = -1) {
    ans[v] = mn + mx;
    for (auto pp : g[v]) {
        if (pp.first != p) {
            dfs(pp.first, min(mn, pp.second), max(mx, pp.second), v);
        }
    }
}

const int MAXN = 300000 + 228;
int pa[MAXN];
int ra[MAXN];

void init() {
    iota(pa, pa + MAXN, 0);
    fill(ra, ra + MAXN, 0);
}

int get(int a) {
    if (pa[a] == a)
        return a;
    return pa[a] = get(pa[a]);
}

void merge(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b)
        return;
    if (ra[b] > ra[a])
        swap(a, b);
    pa[b] = a;
    if (ra[a] == ra[b])
        ra[a]++;
}

vector<vector<int>> edges;

vector<int> tin, up;
int cur_time;

vector<vector<vector<int>>> g2;

int isBridge[300000 + 228];

vector<int> ord;

void dfsbr(int v, int p_ind) {
    ord.push_back(v);
    tin[v] = cur_time++;
    up[v] = tin[v];
    for (auto e : g2[v]) {
        int u = e[0];
        if (e[2] == p_ind)
            continue;
        if (tin[u] != -1) {
            if (tin[u] < tin[v]) {
                up[v] = min(up[v], tin[u]);
            } else {
                up[v] = min(up[v], up[u]);
            }
        } else {
            dfsbr(u, e[2]);
            up[v] = min(up[v], up[u]);
        }
    }
    if (up[v] == tin[v] && p_ind != -1) {
        isBridge[p_ind] = 1;
    }
}


vector<int> color;

void dfsColor(int v, int col) {
    color[v] = col;
    for (auto e : g2[v]) {
        int u = e[0];
        if (color[u] == 0 && !isBridge[e[2]]) {
            dfsColor(u, col);
        }
    }
}

vector<int> mn;

void solveKnowMax(int mx) {
    g2.clear();
    g2.resize(n);
    int cur_ind = 0;
    for (auto e : edges) {
        if (e[0] > mx)
            break;
        int a = e[1];
        int b = e[2];
        int c = e[0];
        g2[b].push_back({a, c, cur_ind});
        g2[a].push_back({b, c, cur_ind});
        isBridge[cur_ind] = 0;
        cur_ind++;
    }
    tin.assign(n, -1);
    ord.clear();
    up.resize(n);
    dfsbr(0, -1);
    int cur_color = 1;
    color.assign(n, 0);
    for (int v : ord) {
        if (color[v] == 0)
            dfsColor(v, cur_color++);
    }
    mn.assign(cur_color, 1e9);
    for (int v : ord) {
        for (auto e : g2[v]) {
            if (color[v] == color[e[0]]) {
                mn[color[v]] = min(mn[color[v]], e[1]);
            }
        }
    }
    for (int v : ord) {
        for (auto e : g2[v]) {
            if (color[v] != color[e[0]] && tin[v] < tin[e[0]]) {
                mn[color[e[0]]] = min(mn[color[v]], mn[color[e[0]]]);
                mn[color[e[0]]] = min(e[1], mn[color[e[0]]]);
            }
        }
    }
    for (int v : ord) {
        ans[v] = min(ans[v], mx + mn[color[v]]);
    }
}

signed main() {
    init();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    g.resize(n);
    int mn0 = 1e9, mx0 = 0;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >>  b >> c;
        a--;
        b--;
        edges.push_back({c, a, b});
        if (a == 0 || b == 0) {
            mn0 = min(mn0, c);
            mx0 = max(mx0, c);
        }
    }
    sort(edges.begin(), edges.end());
    if (mx0 == 0 || m == n - 1) {
        for (auto e : edges) {
            if (get(e[1]) != get(e[2])) {
                merge(e[1], e[2]);
                int a = e[1];
                int b = e[2];
                int c = e[0];
                g[b].push_back({a, c});
                g[a].push_back({b, c});
            }
        }
        ans.resize(n);
        dfs(0, 1e9, 0);
    } else if (mn0 == 1000000000) {
        ans.resize(n, 2e9);
        solveKnowMax(mn0);
    } else {
        ans.resize(n, 2e9);
        for (auto e : edges) {
            int mx = e[0];
            solveKnowMax(mx);
        }
    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
}
