#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef __int128 int128_t;

int128_t pow10(int n) {
    int128_t ans = 1;
    for (int i = 0; i < n; i++) {
        ans = ans * 10;
    }
    return ans;
}

int128_t getByCharCode(int code) {
    if (code % 2 == 0) {
        return pow10(code / 2);   
    } else {
        return pow10(code / 2) * 5;
    }
}

const inline int128_t inf() {
    return pow10(25);
}

void print(int128_t x) {
    string ans;
    if (x == 0) {
        cout << 0 << endl;
        return;
    }
    bool sign = false;
    if (x < 0) {
        sign = true;
        x *= -1;
    }
    while (x > 0) {
        ans += (x % 10) + '0';
        x /= 10;
    }
    if (sign) {
        ans += "-";
    }
    reverse(ans.begin(), ans.end());
    cout << ans << endl;
}

void solve() {
    string s; cin >> s;
    int n = s.length();
    vector<vector<int128_t>> cans(n, vector<int128_t>(26, -inf()));
    vector<vector<int>> prev(n, vector<int>(26, -1));
    if (s[n - 1] == '?') {
        for (int c = 0; c < 26; c++) {
            cans[n - 1][c] = getByCharCode(c);
        }
    } else {
        int c = s[n - 1] - 'A';
        cans[n - 1][c] = getByCharCode(c);
    }
    for (int i = n - 2; i >= 0; i--) {
        if (s[i] == '?') {
            int128_t cmax = cans[i + 1][0];
            int cmaxInd = 0;
            for (int c = 0; c < 26; c++) {
                if (cans[i + 1][c] > cmax) {
                    cmax = cans[i + 1][c];
                    cmaxInd = c;
                }
                cans[i][c] = getByCharCode(c) + cmax;
                prev[i][c] = cmaxInd;
            }
        } else {
            int c = s[i] - 'A';
            int128_t cmax = cans[i + 1][0];
            int cmaxInd = 0;
            for (int x = 0; x <= c; x++) {
                if (cans[i + 1][x] > cmax) {
                    cmax = cans[i + 1][x];
                    cmaxInd = x;
                }
            } 
            cans[i][c] = getByCharCode(c) + cmax;
            prev[i][c] = cmaxInd;
            for (int x = c + 1; x < 26; x++) {
                cans[i][x] = cans[i + 1][x] - getByCharCode(c);
                prev[i][x] = x;
            }
        }
    }
    int128_t mx = cans[0][0];
    int ind = 0;
    for (int i = 1; i < 26; i++) {
        if (cans[0][i] > mx) {
            mx = cans[0][i];
            ind = i;
        }
    }
    print(mx);
    for (int i = 0; i < n; i++) {
        int jmp = prev[i][ind];
        if (s[i] == '?') {
            s[i] = ind + 'A';
        }
        ind = jmp;
    }
    cout << s << endl;
}
    

int main() {
    //int128_t x = pow10(19);
    //print(x);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
