#include <iostream>
#include <vector>
#include <unordered_set>
#include <numeric>

using namespace std;

struct Tree {
    explicit Tree() {
    }
    int x, h;
    Tree(int x_, int h_) : x(x_), h(h_) {

    }
};

int answer(const vector<Tree> &trees) {
    int n = trees.size();
    vector<bool> used(n, false);
    used[0] = used[n - 1] = true;
    unordered_set<int> extractable;
    vector<int> next(n);
    iota(next.begin(), next.end(), 1);
    vector<int> prev(n);
    iota(prev.begin(), prev.end(), -1);
    for (int i = 1; i < n - 1; i++) {
        if (trees[i].x + trees[i].h <= trees[next[i]].x ||
            trees[i].x - trees[i].h >= trees[prev[i]].x) {
            extractable.insert(i);
        }
    }
    int ans = 0;
    while (!extractable.empty()) {
        //Extract

        int i = *extractable.begin();
        extractable.erase(i);
        ans += 1;
        used[i] = true;

        // Determine trees to update
        int prv = prev[i];
        int nxt = next[i];
        
        // Update links
        next[prv] = nxt;
        prev[nxt] = prv;

        //Do stuff
        
        if (!used[prv]) {
            if (trees[prv].x + trees[prv].h <= trees[nxt].x) {
                extractable.insert(prv);
            }
        }
        if (!used[nxt]) {
            if (trees[nxt].x - trees[nxt].h >= trees[prv].x) {
                extractable.insert(nxt);
            }
        }
    }
    return ans;
}

int main() {
    int n, q; cin >> n >> q;
    vector<Tree> trees;
    int x1, h1; cin >> x1 >> h1;
    trees.emplace_back(x1, h1);
    trees.emplace_back(x1, h1);
    for (int i = 1; i < n; i++) {
        int x, h; cin >> x >> h;
        trees.emplace_back(x, h);
    }
    Tree last = trees.back();
    trees.emplace_back(last);
    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r;
        vector<Tree> query;
        for (int i = l - 1; i <= r + 1; i++) {
            query.emplace_back(trees[i]);
        }
        cout << answer(query) << endl;
    }
}
