#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}

template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

const int64_t INF = 1e9;

std::vector<std::vector<int>> g;
std::vector<std::pair<std::pair<int, int>, int64_t>> e;
std::vector<int64_t> min, max;
void dfs(int v, int p = -1) {
    for (auto &ind : g[v]) {
        int to = e[ind].first.first ^ e[ind].first.second ^ v;
        if (to == p)
            continue;
        min[to] = std::min(min[v], e[ind].second);
        max[to] = std::max(max[v], e[ind].second);
        dfs(to, v);
    }
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    int n, m;
    std::cin >> n >> m;
    g.resize(n);
    min.assign(n, INF);
    max.assign(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        std::cin >> u >> v >> t, --u, --v;
        g[u].emplace_back(e.size());
        g[v].emplace_back((e.size()));
        e.emplace_back(std::pair{u, v}, t);
    }
    dfs(0);
    for (int i = 1; i < n; ++i)
        std::cout << min[i] + max[i] << "\n";
    return 0;
}
