#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9 + 1329;
const int maxn = 2e5 + 1329;

struct edge {
    int from, to;
    int t;
    edge() {}
    edge(int from, int ro, int t): from(from), to(to), t(t) {}
    bool operator< (const edge& other) const {
        return t < other.t;
    }
};

vector<edge> g [maxn];

int d [maxn];
edge pred [maxn];

bool bfs(int s, int f, int l, int r) {
    fill(d, d + maxn, inf);
    d[s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int u = q.front(); q.pop();
        for (edge e : g[u]) {
            if (e.t < l || r < e.t) continue;
            if (d[e.to] > d[e.from] + 1) {
                d[e.to] = d[e.from] + 1;
                pred[e.to] = e;
                q.push(e.to);
            }
        }
    }
    return d[f] < inf;
}

signed main() {
    int n, m; cin >> n >> m;
    if (n <= 10 && m <= 10) {
        vector<vector<int>> len (n + 1, vector<int> (n + 1, -1));
        for (int i = 0; i < m; ++i) {
            int u, v, t; cin >> u >> v >> t;
            len[u][v] = t;
            len[v][u] = t;
        }
    }
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t;
        g[u].emplace_back(u, v, t);
        g[v].emplace_back(v, u, t);
    }
    for (int i = 1; i <= n; ++i) {
        sort(g[i].begin(), g[i].end());
    }
    if (m == n - 1) {
        bfs(1, n, 0, inf);
        set<pair<int, int>> q;
        for (int i = 1; i <= n; ++i) {
            q.emplace(d[i], i);
        }
        vector<int> mi (n + 1, inf), ma (n + 1, 0);
        while (!q.empty()) {
            int u = (*q.begin()).second;
            q.erase(q.begin());
            mi[u] = min(mi[pred[u].from], pred[u].t);
            ma[u] = max(ma[pred[u].from], pred[u].t);
        }
        for (int i = 2; i <= n; ++i) {
            cout << mi[i] + ma[i] << '\n';
        }
    }
}