#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cstring>
#include <iomanip>
#include <random>
#include <cassert>
#include <bitset>
#include <queue>
#include <deque>

//#pragma GCC target("avx2")

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
int LeftBorder, RightBorder;
vector<pair<int, int> > v;

int query(int l, int r) {
    set<int> active;
    set<int> left;
    for (int i = l; i <= r; ++i) {
        left.insert(i);
    }
    auto nxt = [&] (int x) {
        auto it = left.upper_bound(x);
        if (it == left.end()) {
            return -1;
        } else {
            return (*it);
        }
    };

    auto prv = [&] (int x) {
        auto it = left.lower_bound(x);
        if (it == left.begin()) return -1;
        --it;
        return *it;
    };

    int totalLeft = LeftBorder;
    if (l - 1 >= 0) {
        totalLeft = v[l - 1].first;
    }
    int totalRight = RightBorder;
    if (r + 1 < n) {
        totalRight = v[r + 1].first;
    }
    for (int i = l; i <= r; ++i) {
        int Left = totalLeft, Right = totalRight;
        int nex = nxt(i);
        if (nex != -1) Right = min(Right, v[nex].first);
        int pre = prv(i);
        if (pre != -1) Left = max(Left, v[pre].first);
        if (v[i].first - v[i].second >= Left || v[i].first + v[i].second <= Right) {
            active.insert(i);
        }
    }
    auto check = [&] (int x) {
        if (x == -1) return -1;
        int l = prv(x), r = nxt(x);
        int Left = totalLeft;
        if (l != -1) Left = v[l].first;
        int Right = totalRight;
        if (r != -1) Right = v[r].first;
        if (v[x].first - v[x].second >= Left || v[x].first + v[x].second <= Right) {
            active.insert(x);
        }
        return 1;
    };
    int ans = 0;
    while (!active.empty()) {
        int now = (*active.begin());
        active.erase(active.begin());
        ans++;
        left.erase(now);
        check(prv(now));
        check(nxt(now));
    }
    return ans;
}

void solve() {
    cin >> n >> q;
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    LeftBorder = v[0].first;
    RightBorder = v[n - 1].first;
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        cout << query(l, r) << '\n';
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
