#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <utility>
#include <queue>
#include <climits>
using namespace std;
using vi  = vector<int>;
using pii  = pair<int, int>;


constexpr int N{500000};
int x[N], h[N];
int pre[N], nxt[N];
int n;
int used[N];


inline void er(int i)
{
    int cl = pre[i], cr = nxt[i];
    if (cl != -1)
        nxt[cl] = cr;
    if (cr != n)
        pre[cr] = cl;
}


inline bool isok(int i)
{
    //cout << "isok " << i+1 << '\n';
    int cl = pre[i];
    int cr = nxt[i];

    //cout << cl+1 << ' ' << cr+1 << '\n';
    return cl >= 0 && x[i]-x[cl] >= h[i] ||
           cl == -1 && x[i]-x[0] >= h[i] ||
           cr < n && x[cr]-x[i] >= h[i] ||
           cr == n && x[n-1]-x[i] >= h[i];
}


signed main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    setvbuf(stdout, nullptr, _IOFBF, 8192);
    setvbuf(stdin , nullptr, _IOFBF, 8192);

    int q;
    scanf("%d %d", &n, &q);

    for (int i = 0; i < n; i++)
        scanf("%d %d", x+i, h+i);

    while (q--)
    {
        for (int i = 0; i < n; i++)
        {
            pre[i] = i-1;
            nxt[i] = i+1;
        }
        fill_n(used, n, 0);

        int l, r;
        scanf("%d %d", &l, &r);
        l--; r--;

        queue<int> sus;
        for (int i = l; i <= r; i++)
            if (isok(i))
            {
                used[i] = true;
                sus.push(i);
                //cout << "st " << i+1 << '\n';
            }

        int res = 0;
        while (!sus.empty())
        {
            int v = sus.front();
            sus.pop();
            //cout << "v " << v+1 << '\n';

            er(v);
            res++;

            int cl = pre[v];
            int cr = nxt[v];
            //cout << cl+1 << ' ' << cr+1 << '\n';

            int u = cl;
            if (l <= u && u <= r && !used[u] && isok(u))
            {
                used[u] = true;
                sus.push(u);
            }
            u = cr;
            if (l <= u && u <= r && !used[u] && isok(u))
            {
                used[u] = true;
                sus.push(u);
            }
        }

        printf("%d\n", res);
    }

    return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1
*/
