#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <deque>
#include <cassert>
#include <set>
#include <functional>
#include <queue>
#include <unordered_set>
#include <bitset>

using namespace std;

map<pair<int, int>, int> dp;
vector<vector<int>> g;
map<pair<int, int>, int> e;
vector<bool> used;
const int maxn = 7000;
bitset<maxn> bs;
bitset<maxn> bs1;
vector<vector<int>> can;
void dfs(int v, int p) {
    used[v] = true;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u, v);
        }
    }
    const int n = g.size();
    for (int u : g[v]) {
        if (u != p) {
            int type = 0;
            if (e.count({v, u})) {
                type += 2;
            }
            if (e.count({u, v})) {
                ++type;
            }
            if (type == 1) {
                if (dp[{ u, 0 }]) {
                    can[u].push_back(-1);
                }
                if (dp[{ u, -1 }]) {
                    can[u].push_back(0);
                }
            }
            if (type == 2) {
                if (dp[{u, 0}]) {
                    can[u].push_back(1);
                }
                if (dp[{u, 1}]) {
                    can[u].push_back(0);
                }
            }
            if (type == 3) {
                if (dp[{u, 0}]) {
                    can[u].push_back(0);
                }
                if (dp[{u, 1}]) {
                    can[u].push_back(-1);
                }
                if (dp[{u, -1}]) {
                    can[u].push_back(1);
                }
            }
            if (can[u].empty()) {
                cout << "No";
                exit(0);
            }
        }
    }
    bs.reset();
    bs[3500] = 1;
    for (int i : g[v]){
        if (i == p) {
            continue;
        }
        if (can[i].size()) {
            bs1.reset();
            for (int j : can[i]) {
                if (j < 0) {
                    bs1 |= (bs >> 1);
                } else if (j > 0) {
                    bs1 |= (bs << 1);
                } else {
                    bs1 |= bs;
                }
            }
            bs = bs1;
        }
    }
    if (bs[3500]) {
        dp[{v, 0}] = 1;
    }
    if (bs[3499]) {
        dp[{v, -1}] = 1;
    }
    if (bs[3501]) {
        dp[{v, 1}] = 1;
    }
}

vector<pair<pair<int, int>, pair<int, int>>> ans;

pair<int, int> getAns(int v, int state, int p) {
    vector<vector<int>> dpp(g[v].size() + 1, vector<int> (g[v].size() * 2 + 1, 0));
    vector<vector<int>> pr(g[v].size() + 1, vector<int> (g[v].size() * 2 + 1, -2));
    for (int i = 1; i < g[v].size(); ++i) {
        if (g[v][i] == p) {
            swap(g[v][i], g[v][0]);
        }
    }
    dpp[0][g[v].size()] = 1;
    int s = 1;
    if (p == -1) {
        s = 0;
    } else {
        dpp[1][g[v].size()] = 1;
    }
    for (int i = s + 1; i <= g[v].size(); ++i) {
        for (int j = 0; j < g[v].size() * 2 + 1; ++j) {
            for (int curr : can[g[v][i - 1]]) {
                if (j - curr >= 0 && j - curr < ((int)g[v].size()) * 2 + 1) {
                    if (dpp[i - 1][j - curr]) {
                        dpp[i][j] = true;
                        pr[i][j] = curr;
                    }
                }
            }
        }
    }
    int id = ((int)g[v].size()) + state;
    vector<int> res;
    int ptr = g[v].size();
    while (ptr != s - 1) {
        res.push_back(pr[ptr][id]);
        --ptr;
        id -= res.back();
    }
    res.pop_back();
    reverse(res.begin(), res.end());
    pair<int, int> ee;
    int t = (p != -1);
    for (int i = s; i < g[v].size(); ++i) {
        int type = 0;
        int u = g[v][i];
        if (e.count({v, u})) {
            type += 2;
        }
        if (e.count({u, v})) {
            ++type;
        }
        if (type == 1) {
            if (res[i - t] == 0) {
                getAns(u, 0, v);
                ee = { u, v };
            }
            if (res[i - t] == -1) {
                ans.push_back({{u, v}, getAns(u, -1, v)});
            }
        }
        if (type == 2) {
            if (res[i - t] == 0) {
                ee = {v, u};
            }
            if (res[i - t] == 1) {
                pair<int, int> e1 = { v, u };
                ans.push_back({ e1, getAns(u, 1, v)});
            }
        }
        if (type == 3) {
            if (res[i - t] == 0) {
                ans.push_back({{ v, u }, { u, v }});
                getAns(u, 0, v);
            }
            if (res[i - t] == 1) {
                ans.push_back({{ v, u }, getAns(u, 1, v)});
                ee = {u, v};
            }
            if (res[i - t] == -1) {
                ans.push_back({ {u, v}, getAns(u, -1, v)});
                ee = {v, u};
            }
        }
    }
    return ee;
}

 int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.assign(n, false);
    can.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        ++e[{ u, v }];
        if (!e.count( {v, u})) {
            g[u].push_back(v);
            g[v].push_back(u);
        }
    }
    vector<int> roots;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            roots.push_back(i);
            dfs(i, -1);
        }
    }
    for (int i : roots) {
        if (!dp[{i, 0}]) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (int i : roots) {
        if (g[i].size()) {
            getAns(i, 0, -1);
        }
    }
    for (auto [p1, p2] : ans) {
        cout << p1.first + 1 << ' ' << p1.second + 1 << ' ' << p2.first + 1 << ' ' << p2.second + 1 << '\n';
    }
}
/*
 5 6
 1 2
 2 1
 1 5
 2 3
 2 4
 4 2


 4 4
 2 1
 2 3
 2 4
 4 2


 4 4
 1 2
 2 1
 3 4
 4 3
 */