#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <deque>
#include <cassert>
#include <set>
#include <functional>

using namespace std;

#define int long long

map<pair<int, int>, int> d;

void solve(int n, int m) {
    vector<set<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        ++d[{ u, v }];
        if (!d.count({ v, u })) {
            g[u].insert(v);
            g[v].insert(u);
        }
    }
    deque<int> q;
    for (int i = 0; i < n; ++i) {
        if (g[i].size() == 1) {
            int u = *g[i].begin();
            if (d[{i, u}] && d[{u, i}]) {
                q.push_back(i);
            }
        }
    }
    vector<bool> used(n, false);
    vector<bool> deleted(n, false);
    for (int i : q) {
        used[i] = true;
    }
    vector<pair<pair<int, int>, pair<int, int>>> ans;
    while (!q.empty()) {
        deque<int> nq;
        vector<int> to_check;
        for (int i : q) {
            deleted[i] = true;
            ans.push_back({ { i, *g[i].begin() }, { *g[i].begin(), i } });
            for (int v : g[i]) {
                g[v].erase(i);
                if (g[v].size() == 1) {
                    if (!used[v]) {
                        to_check.push_back(v);
                    }
                    used[v] = true;
                }
            }
        }
        for (int i : to_check) {
            if (g[i].size() == 1) {
                int u = *g[i].begin();
                if (d[{i, u}] && d[{u, i}]) {
                    nq.push_back(i);
                }
            }
        }
        q = nq;
    }
    vector<int> leaves;
    for (int i = 0; i < n; ++i) {
        if (!deleted[i] && g[i].size() == 1) {
            leaves.push_back(i);
        }
    }
    int u1 = *g[leaves[0]].begin();
    int u2 = *g[leaves[1]].begin();
    vector<int> p(n, -1);

    function<void(int)> dfs = [&] (int v) {
        deleted[v] = true;
        for (int u : g[v]) {
            if (!deleted[u]) {
                p[u] = v;
                dfs(u);
            }
        }
    };

    if (!d.count({leaves[0], u1})) {
        swap(leaves[0], leaves[1]);
        swap(u1, u2);
    }
    vector<bool> mem = deleted;
    dfs(leaves[0]);
    deleted = mem;
    int ptr = leaves[1];
    vector<int> path;
    while (ptr != -1) {
        path.push_back(ptr);
        ptr = p[ptr];
    }
    reverse(path.begin(), path.end());
    if (d[{leaves[0], u1 }] && d[{ leaves[1], u2 }]) {

        vector<pair<int, int>> ed;
        for (int i = 0; i + 2 < path.size(); ++i) {
            ed.push_back({path[i], path[i + 1]});
        }
        if (ed.size() % 2 == 1) {
            cout << "No";
            return;
        }
        for (int i = path.size() - 1; i >= 2; --i) {
            ed.push_back({path[i], path[i - 1]});
        }
        for (int i = 0; i + 1 < ed.size(); ++i) {
            ans.push_back({ed[i], ed[i + 1]});
        }
        cout << "Yes\n";
        for (auto[p1, p2] : ans) {
            cout << p1.first + 1 << ' ' << p1.second + 1 << ' ' << p2.first + 1 << ' ' << p2.second + 1 << '\n';
        }
    } else if (!d[{leaves[0], u1}] && !d[{leaves[1], u2}]) {
        p.assign(n, -1);
        dfs(u1);
        deleted = mem;
        int ptr = leaves[1];
        vector<int> path;
        while (ptr != -1) {
            path.push_back(ptr);
            ptr = p[ptr];
        }
        reverse(path.begin(), path.end());
        vector<pair<int, int>> ed;
        for (int i = 0; i + 1 < path.size(); ++i) {
            ed.push_back({ path[i], path[i + 1] });
        }
        if (ed.size() % 2 == 1) {
            cout << "No";
            return;
        }
        p.assign(n, -1);
        dfs(u2);
        deleted = mem;
        ptr = leaves[0];
        path.clear();
        while (ptr != -1) {
            path.push_back(ptr);
            ptr = p[ptr];
        }
        reverse(path.begin(), path.end());
        for (int i = 0; i + 1 < path.size(); ++i) {
            ed.push_back({ path[i], path[i + 1] });
        }
        for (int i = 0; i + 1 < ed.size(); i += 2) {
            ans.push_back({ ed[i], ed[i + 1] });
        }
        cout << "Yes\n";
        for (auto[p1, p2] : ans) {
            cout << p1.first + 1 << ' ' << p1.second + 1 << ' ' << p2.first + 1 << ' ' << p2.second + 1 << '\n';
        }
    } else {
        assert(0);
        if (!d[{ leaves[0], u1 }]) {
            swap(leaves[0], leaves[1]);
            swap(u1, u2);
        }
        p.assign(n, -1);
        dfs(leaves[0]);
        deleted = mem;
        vector<int> path;
        int ptr = leaves[1];
        while (ptr != -1) {
            path.push_back(ptr);
            ptr = p[ptr];
        }
        reverse(path.begin(), path.end());
        vector<pair<int, int>> ed;
        for (int i = 0; i + 1 < path.size(); ++i) {
            ed.push_back({ path[i], path[i + 1] });
        }
        if (ed.size() % 2) {
            cout << "No";
            return;
        }
        path.pop_back();
        reverse(path.begin(), path.end());
        path.pop_back();
        for (int i = 0; i + 1 < path.size(); ++i) {
            ed.push_back({ path[i], path[i + 1] });
        }
        for (int i = 0; i + 1 < ed.size(); i += 2) {
            ans.push_back({ ed[i], ed[i + 1] });
        }
        cout << "Yes\n";
        for (auto[p1, p2] : ans) {
            cout << p1.first + 1 << ' ' << p1.second + 1 << ' ' << p2.first + 1 << ' ' << p2.second + 1 << '\n';
        }
    }
}

 int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    if (m == n * 2 - 4) {
        solve(n, m);
        return 0;
    }
    vector<vector<int>> g(n);
    for(int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        ++d[{ u, v }];
        if (!d.count({v, u})) {
            g[u].push_back(v);
            g[v].push_back(u);
        }
    }

}
/*
 5 6
 1 2
 2 1
 1 5
 2 3
 2 4
 4 2


 4 4
 2 1
 2 3
 2 4
 4 2


 4 4
 1 2
 2 1
 3 4
 4 3
 */