#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>


constexpr int MAXN = 3e5 + 5;
constexpr int INF = 1.1e9;

struct Edge {
	int t, w;
	int id;
};
struct Edge2 {
	int u, v, w;
};
int n, m;
std::vector<Edge> gr[MAXN];
int ans[MAXN];
bool dp[20][1 << 20];
bool used[MAXN];

int ub;

void dfs(int v) {
	used[v] = true;
	if (ans[v] == -1) {
		ans[v] = ub;
	}
	while (!gr[v].empty()) {
		auto [t, w, id] = gr[v].back();
		if (w <= ub) {
			gr[v].pop_back();
			dfs(t);
		} else {
			break;
		}
	}
}



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);


	std::cin >> n >> m;
	std::vector<std::vector<int>> vec(n - 1);
	for (int i = 0; i < m; i++) {
		int u, v, t;
		std::cin >> u >> v >> t;
		u--; v--;
		vec[std::min(u, v)].push_back(t);
	}

	for (int i = 0; i < n - 1; i++) {
		std::sort(vec[i].begin(), vec[i].end());
	}

	int min = INF, max = 0;
	std::fill(ans, ans + n, 2.1e9);

	for (int i = 0; i < n - 1; i++) {
		min = std::min(min, vec[i][0]);
		max = std::max(max, vec[i][0]);

		ans[i + 1] = std::min(ans[i + 1], min + max);

		int mn = min, mx = max;
		for (int j = i + 1; j < n - 1; j++) {
			if (vec[j].size() < 2) {
				break;
			}
			mn = std::min(mn, vec[i][0]);
			mx = std::max(mx, vec[i][1]);

			ans[i + 1] = std::min(ans[i + 1], mn + mx);
		}
	}

	for (int i = 1; i < n; i++) {
		std::cout << ans[i] << " \n"[i == n - 1];
	}
	return 0;


	//if (n == m + 1) {
	//	std::function<void(int, int, int, int)> dfs = [&](int v, int f, int min, int max) {
	//		ans[v] = min + max;
	//		for (auto [t, w, id] : gr[v]) {
	//			if (id != f) {
	//				dfs(t, id, std::min(min, w), std::max(max, w));
	//			}
	//		}
	//	};
	//	dfs(0, -1, INF, 0);
	//	for (int i = 1; i < n; i++) {
	//		std::cout << ans[i] << " \n"[i == n - 1];
	//	}
	//	return 0;
	//} else if (std::all_of(gr[0].begin(), gr[0].end(), [](Edge e) {return e.w == 0; })) {
	//	std::fill(ans, ans + n, -1);
	//	ub = 0;
	//	dfs(0);
	//	for (auto [u, v, w] : ed) {
	//		ub = w;
	//		if (used[v]) {
	//			dfs(v);
	//		}
	//		if (used[u]) {
	//			dfs(u);
	//		}  
	//	}	
	//	for (int i = 1; i < n; i++) {
	//		std::cout << ans[i] << " \n"[i == n - 1];
	//	}
	//	return 0;

	exit(324);

	return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1

*/