#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el : a) out << el << " ";
    return out;
}
int INF = 1e18;

struct PRS {
    vector <int> mt, used;
    int now_used = 1, n, m;
    vector <vector <int> > gr;
    PRS(int n, vector <vector <int> > gr) : gr(gr), n(n) {
        mt.resize(n, -1);
        used.resize(n);
    }

    int dfs(int v) {
        if (used[v] == now_used) return 0;
        used[v] = now_used;
        for (auto u : gr[v]) {
            if (mt[u] == -1 || dfs(mt[u])) {
                mt[v] = u;
                mt[u] = v;
                return 1;
            }
        }
        return 0;
    }

    set <pair<int, int> > get_mp() {
        for (int run = 1; run; ) {
            run = 0;
            for (int i = 0; i < n; i++) if (mt[i] == -1) run = max(run, dfs(i));
            now_used++;
        }
        set <pair <int, int> > ans;
        for (int i = 0; i < n; i++) if (mt[i] != -1) ans.insert({min(i, mt[i]), max(i, mt[i])});
        return ans;
    }
};

int stupid() {
    int n, m;
    cin >> n >> m;
    vector <vector <int> > in(n), out(n);
    vector <pair <int, int> > edj;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        edj.push_back({a, b});
        in[b].push_back(i);
        out[a].push_back(i);
    }

    vector <vector <int> > gr(m);
    for (int i = 0; i < n; i++) {
        for (auto a : in[i]) {
            for (auto b : out[i]) {
                gr[a].push_back(b);
                gr[b].push_back(a);
            }
        }
    }
    PRS par(m, gr);
    auto ans = par.get_mp();
    if (ans.size() != m / 2) {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    for (auto p : ans) {
        cout << edj[p.first].first + 1 << " " << edj[p.first].second + 1 << " ";
        cout << edj[p.second].first + 1 << " " << edj[p.second].second + 1 << endl;
    }
    return 1;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    stupid();
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
