#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 500 * 1000 + 7;

int n, q;

int x[N], h[N];
int left[N], right[N];
bool fall[N];

int l, r;

bool can_left(int i) {
	if (x[i] - h[i] < x[1]) {
		return false;
	}
	int le = left[i];
	if (x[le] > x[i] - h[i]) {
		return false;
	}
	return true;
}


bool can_right(int i) {
	if (x[i] + h[i] > x[n]) {
		return false;
	}
	int re = right[i];
	if (x[re] < x[i] + h[i]) {
		return false;
	}
	return true;
}
bool can_fall(int v) {
	if (l <= v && v <= r) {
		return can_right(v) || can_left(v);
	}
	return false;
}

void solve() {
	cin >> l >> r;
	for (int i = max(1, l - 1); i <= min(r + 1, n); ++i) {
		right[i] = i + 1;
	}
	for (int i = l; i <= r + 1; ++i) {
		left[i] = i - 1;
	}

	queue<int> Q;

	for (int i = l; i <= r; ++i) {
		fall[i] = false;
	}

	for (int i = l; i <= r; ++i) {
		if (can_fall(i)) {
			fall[i] = true;
			Q.push(i);
		}
	}

	int ans = 0;
	while (!Q.empty()) {
		int v = Q.front();
		Q.pop();
		++ans;

		int le = left[v];
		int re = right[v];

		right[le] = re;
		left[re] = le;

		if (l <= le && le <= r && !fall[le] && can_fall(le)) {
			fall[le] = true;
			Q.push(le);
		}
		if (l <= re && re <= r && !fall[re] && can_fall(re)) {
			fall[re] = true;
			Q.push(re);
		}
	}

	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> x[i] >> h[i];
	}
	x[n + 1] = x[n];
	x[0] = x[1];

	while(q--) {
		solve();
	}
	return 0;
}


/*

3 3
1 3
3 1
4 2
1 1
2 3
1 3


5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1


1 1
100 100
1 1

*/