#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define list list228
#define all(v) v.begin(), v.end()

const int N = 300 * 1000 + 7;
const int INF = 1e18 + 228;

int n, m;
vector< pair<int, int> > g[N];


struct edge
{
	int u, v, t;
	edge() {}
	edge(int _u, int _v, int _t) {
		u = _u;
		v = _v;
		t = _t;
	}
};

int p[N], sz[N];
vector<int> sub[N];

void init() {
	for (int i = 1; i <= n; ++i) {
		p[i] = i;
		sz[i] = 1;
		sub[i] = {i};
	}
}

int getp(int v) {
	if (v == p[v]) {
		return v;
	}
	p[v] = getp(p[v]);
	return p[v];
}

vector<int> just_added;
int MAXIM = 0;

void join(int u, int v) {
	u = getp(u);
	v = getp(v);
	if (u != v) {
		if (sz[u] > sz[v]) {
			swap(u, v);
		}
		{
			if (getp(1) == u) {
				for (int x : sub[v]) {
					just_added.push_back(x);
					MAXIM = max(MAXIM, x);
				}
			} else if (getp(1) == v) {
				for (int x : sub[u]) {
					just_added.push_back(x);
					MAXIM = max(MAXIM, x);
				}
			}
		}
		p[u] = v;
		sz[v] += sz[u];
		for (int x : sub[u]) {
			sub[v].push_back(x);
		}
	}
}

vector< edge > edges;

vector<int> gr[N];
int ans[N];
int cnt[N];
int a[N], b[N];
int pref_min[N], pref_max[N];

void solve() {
	for (int i = 1; i <= n; ++i) {
		ans[i] = INF;
		a[i] = b[i] = INF;
	}
	sort(all(edges), [&] (edge a, edge b) {
		return a.t < b.t;
	});

	vector< edge > dop;

	init();

	for (auto e : edges) {
		if (abs(e.u - e.v) > 1) {
			dop.push_back(e);
		}
	}

	for (int v = 1; v < n; ++v) {
		vector<int> list;
		for (auto P : g[v]) {
			int to = P.first;
			int t = P.second;
			if (to == v + 1) {
				++cnt[v];
				list.push_back(t);
			}
		}
		sort(all(list));
		a[v] = list[0];
		if (cnt[v] > 1) {
			b[v] = list[1];
		}
	}
	pref_min[0] = INF;
	for (int v = 1; v <= n; ++v) {
		pref_min[v] = min(pref_min[v - 1], a[v]);
		pref_max[v] = max(pref_max[v - 1], a[v]);
	}

	for (int v = 1; v < n; ++v) {
		if (cnt[v] > 1) {
			join(v, v + 1);
		}
	}

	// sort(all(dop));

	for (int it = 0; it < (int)dop.size(); ++it) {
		edge e = dop[it];
		join(e.u, e.v);

		int cur_max = e.t;

		int cur_min = pref_min[MAXIM - 1];

		int cur_ans = cur_max + cur_min;
		ans[MAXIM] = min(ans[MAXIM], cur_ans);
	}

	for (int i = n - 1; i > 1; --i) {
		uin(ans[i], ans[i + 1]);
	}

	for (int i = 2; i <= n; ++i) {
        int mn = pref_min[i - 1];
        int mx = pref_max[i - 1];
        ans[i] = min(ans[i], pref_max[i - 1] + pref_min[i - 1]);
 
        for (int j = i; j < n; ++j) {
            if (cnt[j] == 1) break;
            uin(mn, a[j]);
            uax(mx, b[j]);
 
            ans[i] = min(ans[i], mn + mx);
        }
    }

	for (int i = 2; i <= n; ++i) {
		cout << ans[i] << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;

	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u].emplace_back(v, t);
		g[v].emplace_back(u, t);
		edges.emplace_back(u, v, t);
	}

	solve();
	return 0;
}


/*

4 4
1 2 2
3 2 0
2 4 3
4 3 1

*/