#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <cassert>

#define IO
#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

const int inf = 1e18;

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
#ifdef IO
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int a, b, w;
		cin >> a >> b >> w;
		--a;
		--b;
		g[a].emplace_back(b, w);
		g[b].emplace_back(a, w);
	}
	vector<int> dp(n, inf);
	set<pair<int, int>> q;
	q.insert(make_pair(dp[0] = -inf, 0));
	while (!q.empty()) {
		int i = q.begin()->second;
		q.erase(q.begin());
		for (const pair<int, int> &e : g[i]) {
			if (max(dp[i], e.second) < dp[e.first]) {
				q.erase(make_pair(dp[e.first], e.first));
				dp[e.first] = max(dp[i], e.second);
				q.insert(make_pair(dp[e.first], e.first));
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << dp[i] << endl;
	}
	return 0;
}