#include <iostream>
#include <set>
#include <vector>

using namespace std;

struct tree {
    unsigned int d_l;
    unsigned int d_r;
    unsigned int h;
    unsigned int x;
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector <tree> trees;
    for (int i = 0; i < n; ++i) {
        unsigned int x, h;
        cin >> x >> h;
        unsigned int d_l = 0;
        if (i != 0) {
            d_l = x - trees[i - 1].x;
            trees[i - 1].d_r = d_l;
        }
        trees.push_back({d_l, 0, h, x});
    }
    set <int> glob_cut;
    vector <int> glob_left(n), glob_right(n);
    for (int i = 0; i < n; ++i) {
        if (max(trees[i].d_l, trees[i].d_r) >= trees[i].h) {
            glob_cut.insert(i);
        }
        glob_left[i] = i - 1;
        glob_right[i] = i + 1;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        set <int> cut(glob_cut.lower_bound(l - 1), glob_cut.upper_bound(r - 1));
        auto l1 = cut.begin();
        int res = 0;
        vector <int> left = glob_left, right = glob_right;
        while (l1 != cut.end() && *l1 < r) {
            int i = *l1;
            bool found = false;
            ++res;
            int i1 = right[i], i2 = left[i];
            if (i1 < n) {
                left[i1] = i2;
                trees[i1].d_l += trees[i].d_l;
                if (max(trees[i1].d_r, trees[i1].d_l) >= trees[i1].h && i1 < r) {
                    cut.insert(i1);
                }
            }
            if (i2 >= 0) {
                right[i2] = i1;
                trees[i2].d_r += trees[i].d_r;
                if (max(trees[i2].d_l, trees[i2].d_r) >= trees[i2].h && i2 >= l - 1) {
                    cut.erase(l1);
                    l1 = cut.insert(i2).first;
                    found = true;
                }
            }
            if (!found) {
                l1 = cut.erase(l1);
            }
        }
        cout << res << '\n';
    }
}
