#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef vector <int> lnum;
const int base = 1000000000;

lnum add (lnum a, lnum b);
lnum sub (lnum a, lnum b);

lnum read(string s) {
    lnum a;
    if (s[0] == '-') {
        a.push_back(-1);
        s = s.substr(1, s.length()-1);
    } else {
        a.push_back(1);
    }
    for (int i = s.length(); i >= 1; i -= 9) {
        if (i >= 9) {
            a.push_back(stoi(s.substr(i-9, 9)));
        } else {
            a.push_back(stoi(s.substr(0, i)));
        }
    }
    return a;
}

vector <lnum> a(26);

int ord(char c) {
    return (int) c - (int) 'A';
}

lnum mos_to_dec(string s) {
    lnum ans = read("0");
    vector <char> st = {};
    for (int i = 0; i < s.length(); i++) {
        while (st.size() && st.back() < s[i]) {
            ans = sub(ans, a[ord(st.back())]);
            st.pop_back();
        }
        st.push_back(s[i]);
    }
    for (int i = 0; i < st.size(); i++) {
        ans = add(ans, a[ord(st[i])]);
    }
    return ans;
}

void print(lnum a) {
    if (a[0] == -1 && a[1] != 0) {
        cout << '-';
    }
    cout << a.back();
    for (int i = (int) a.size() - 2; i >= 1; i--) {
        for (int j = 0; j < 9 - to_string(a[i]).length(); j++) {
            cout << '0';
        }
        cout << a[i];
    }
}

lnum add(lnum a, lnum b) {
    if (a[0] == b[0]) {
        int carry = 0;
        for (int i = 1; i < max(a.size(), b.size()) || carry; i++) {
            if (i >= a.size()) {
                a.push_back(0);
            }
            if (i >= b.size()) {
                a[i] += carry;
            } else {
                a[i] += carry + b[i];
            }
            carry = a[i] >= base;
            if (carry) {
                a[i] -= base;
            }
        }
        return a;
    } else if (a[0] == -1) {
        a[0] = 1;
        return sub(b, a);
    } else {
        b[0] = 1;
        return sub(a, b);
    }
}

lnum sub(lnum a, lnum b) {
    if (a[0] == b[0]) {
        bool isA = true;
        if (b.size() > a.size()) {
            isA = false;
        } else if (b.size() == a.size()) {
            for (int i = 1; i < b.size(); i++) {
                if (b[i] > a[i]) {
                    isA = false;
                    break;
                } else if (a[i] > b[i]) {
                    break;
                }
            }
        }
        if (!isA) {
            lnum c = a;
            a = b;
            b = c;
            if (a[0] == -1) {
                a[0] = 1;
            } else {
                a[0] = -1;
            }
        }
        int carry = 0;
        for (int i = 1; i < a.size() || carry; i++) {
            if (i >= b.size()) {
                a[i] -= carry;
            } else {
                a[i] -= carry + b[i];
            }
            carry = a[i] < 0;
            if (carry) {
                a[i] += base;
            }
        }
        return a;
    } else if (b[0] == -1) {
        b[0] = 1;
        return add(a, b);
    } else {
        b[0] = -1;
        return add(a, b);
    }
}

int main() {
    string q = "1";
    for (int i = 0; i < 26; i++) {
        a[i] = read(q);
        if (q[0] == '1') {
            q[0] = '5';
        } else {
            q[0] = '1';
            q += "0";
        }
    }

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        string s;
        cin >> s;
        print(mos_to_dec(s));
        cout << '\n' << s << '\n';
    }
    return 0;
}
