#include <bits/stdc++.h>

using namespace std;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()
#define int long long

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MAXN = signed(1e5) + 100;

vector<int> cost('Z' - 'A' + 1);

inline void preprocess() {
    cost[0] = 1;

    for (int i = 1; i <= 'Z' - 'A'; ++i) {
        if (i & 1) cost[i] = cost[i - 1] * 5;
        else cost[i] = cost[i - 1] * 2;
    }
}

inline void solve() {
    string s; cin >> s;
    int n = sz(s);

    vector<int> maxLetter(n, 0);
    if (s[n - 1] != '?') maxLetter[n - 1] = s[n - 1] - 'A';
    for (int i = n - 2; i >= 0; --i) {
        if (s[i] == '?') maxLetter[i] = maxLetter[i + 1];
        else maxLetter[i] = max(maxLetter[i + 1], ll(s[i] - 'A'));
    }

    vector<int> pos;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') pos.push_back(i);
    }

    if (pos.empty()) {
        int ans = 0;

        for (int i = 0; i < n; ++i) {
            int letter = s[i] - 'A';
            if (letter < maxLetter[i]) ans -= cost[letter];
            else ans += cost[letter];
        }

        cout << ans << "\n" << s << "\n";
        return;
    }

    int ans = -LINF;
    string sAns;

    function<void(int)> rec = [&](int i) {
        for (int letter = 0; letter < 26; ++letter) {
            s[pos[i]] = char('A' + letter);

            if (i == sz(pos) - 1) {
                maxLetter.assign(n, 0);
                maxLetter[n - 1] = s[n - 1] - 'A';
                for (int i = n - 2; i >= 0; --i) maxLetter[i] = max(maxLetter[i + 1], ll(s[i] - 'A'));

                int cnt = 0;

                for (int i = 0; i < n; ++i) {
                    int let = s[i] - 'A';
                    if (let < maxLetter[i]) cnt -= cost[let];
                    else cnt += cost[let];
                }

                if (ans < cnt) {
                    ans = cnt;
                    sAns = s;
                }
            }
            else {
                rec(i + 1);
            }
        }
    };

    rec(0);

    cout << ans << "\n" << sAns << "\n";
}

signed main() {
    fastio;

    preprocess();
    int q; cin >> q;
    while (q--) solve();

    return 0;
}