#include <bits/stdc++.h>

using namespace std;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MAXN = signed(1e5) + 100;

struct SegmentTree {
    int n;
    vector<int> t;

    SegmentTree(int _n) {
        n = _n;
        t.resize(4 * n, 1);
    }

    inline int lson(int v) {
        return v * 2 + 1;
    }

    inline int rson(int v) {
        return v * 2 + 2;
    }

    inline void relax(int v) {
        t[v] = t[lson(v)] + t[rson(v)];
    }

    void update(int v, int tl, int tr, int pos, int x) {
        if (tr - tl == 1) {
            t[v] = x;
        }
        else {
            int tm = (tl + tr) / 2;

            if (pos < tm) update(lson(v), tl, tm, pos, x);
            else update(rson(v), tm, tr, pos, x);
        }
    }

    inline void update(int pos, int x) {
        update(0, 0, n, pos, x);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (r <= tl || tr <= l) return 0;
        if (l <= tl && tr <= r) return t[v];

        int tm = (tl + tr) / 2;
        return get(lson(v), tl, tm, l, r) + get(rson(v), tm, tr, l, r);
    }

    inline int get(int l, int r) {
        return get(0, 0, n, l, r + 1);
    }
};

signed main() {
    fastio;

    int n, q; cin >> n >> q;
    map<int, int> t, getidx;
    vector<pair<int, int>> trees;

    for (int i = 0; i < n; ++i) {
        int x, h; cin >> x >> h;
        t[x] = h;
        trees.push_back({x, h});
        getidx[x] = i;
    }

    while (q--) {
        int l, r; cin >> l >> r;
        --l, --r;

        queue<int> check;
        for (int i = l; i <= r; ++i) check.push(i);
        int ans = 0;
        SegmentTree crashed(n);

        while (!check.empty()) {
            int idx = check.front();
            pair<int, int> tree = trees[idx];
            check.pop();

            if (crashed.get(idx, idx) == 0) continue;

            bool to_left = true, to_right = true;

            if (tree == trees[0]) {
                to_left = false;
            }
            else {
                pair<int, int> leftiest = *t.upper_bound(tree.first - tree.second);
                int tempidx = getidx[leftiest.first];
                if (crashed.get(tempidx, idx - 1) != 0) to_left = false;

                if (to_left && idx != l && tempidx - 1 >= l) {
                    if (crashed.get(tempidx - 1, tempidx - 1) == 1) check.push(tempidx - 1);
                }
            }

            if (tree == trees.back()) {
                to_right = false;
            }
            else {
                pair<int, int> rightiest = *prev(t.lower_bound(tree.first + tree.second));
                int tempidx = getidx[rightiest.first];
                if (crashed.get(idx + 1, tempidx) != 0) to_right = false;

                if (to_right && idx != r && tempidx + 1 <= r) {
                    if (crashed.get(tempidx + 1, tempidx + 1) == 1) check.push(tempidx + 1);
                }
            }

            if (to_left || to_right) {
                ++ans;
                crashed.update(idx, 0);
            }
        }

        cout << ans << "\n";
    }

    return 0;
}