#pragma  GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9;
const ll MOD = 228228227;

void dfs(vector <vector <pair <int, int>>> &graph, vector <bool> &discovered, vector <int> &mins, vector <int> &maxs, int v) {
    discovered[v] = true;

    for (auto [u, w]: graph[v]) {
        if (discovered[u]) continue;

        mins[u] = min(mins[v], w);
        maxs[u] = max(maxs[v], w);

        dfs(graph, discovered, mins, maxs, u);
    }
}

inline void solve() {
    int n, m;
    cin >> n >> m;

    int u, v, w;
    vector <vector  <pair <int, int>>> graph(n);
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> w;
        u--; v--;

        graph[u].push_back({v, w});
        graph[v].push_back({u, w});
    }

    vector <bool> discovered(n);
    vector <int> mins(n, INF), maxs(n, -INF);
    dfs(graph, discovered, mins, maxs, 0);

    for (int i = 1; i < n; i++) {
        cout << mins[i] + maxs[i] << '\n';
    }
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
