#include <iostream>
#include <vector>

#define maxN 500000

struct Tree {
	long long x, h;
} trees[maxN];

struct Forest {
	long long l, r;
	std::vector<long long> t;
} t[4 * maxN];

long long n, q;
std::vector<long long> temp;

long long cut(long long ir, long long xl) {
	if (temp.empty()) {
		return ir;
	}
	long long curTree = temp[temp.size() - 1];
	temp.pop_back();
	if (trees[curTree].x - xl >= trees[curTree].h) {
		return cut(ir, xl);
	}
	else {
		long long xr = cut(ir, trees[curTree].x);
		if (xr - trees[curTree].x >= trees[curTree].h) {
			return cut(ir, xl);
		}
		temp.push_back(curTree);
	}
	return trees[curTree].x;
}

void unite(Forest& f1, Forest& f2, Forest& f) {
	f.l = f1.l;
	f.r = f2.r;
	for (long long j = (long long)f2.t.size() - 1; j >= 0; j--) {
		temp.push_back(f2.t[j]);
	}
	for (long long j = (long long)f1.t.size() - 1; j >= 0; j--) {
		temp.push_back(f1.t[j]);
	}
	cut(f.r, f.l);
	while (!temp.empty()) {
		f.t.push_back(temp[temp.size() - 1]);
		temp.pop_back();
	}
	return;
}

void build(long long i, long long tl, long long tr) {
	if (tr - tl == 1) {
		if (tl == 0) {
			t[i].l = trees[0].x;
		}
		else {
			t[i].l = trees[tl - 1].x;
		}
		if (tr == n) {
			t[i].r = trees[n - 1].x;
		}
		else {
			t[i].r = trees[tl + 1].x;
		}
		if (trees[tl].x - t[i].l < trees[tl].h && t[i].r - trees[tl].x < trees[tl].h) {
			t[i].t.push_back(tl);
		}
		return;
	}
	long long tm = (tl + tr) / 2;
	build(2 * i + 1, tl, tm);
	build(2 * i + 2, tm, tr);
	unite(t[2 * i + 1], t[2 * i + 2], t[i]);
	return;
}

Forest get(long long i, long long tl, long long tr, long long l, long long r) {
	if (l <= tl && tr <= r) {
		return t[i];
	}
	long long tm = (tl + tr) / 2;
	Forest t1, t2, t0;
	if (tm > l) {
		t1 = get(2 * i + 1, tl, tm, l, r);
		if (r > tm) {
			t2 = get(2 * i + 2, tm, tr, l, r);
			unite(t1, t2, t0);
			return t0;
		}
		return t1;
	}
	else {
		return get(2 * i + 2, tm, tr, l, r);
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n >> q;
	for (long long i = 0; i < n; i++) {
		std::cin >> trees[i].x >> trees[i].h;
	}
	build(0, 0, n);
	long long l, r;
	for (long long i = 0; i < q; i++) {
		std::cin >> l >> r; --l;
		std::cout << r - l - get(0, 0, n, l, r).t.size() << "\n";
	}
	return 0;
}