#include <iostream>
#include <vector>
#include <algorithm>

#define maxN 300000

struct Edge {
	long long u, v, w, i;
};

struct Elem {
	long long to, ans, size;
};

long long n, m, u, v, t;
std::vector<Edge> edges;
Elem DSU[maxN];

bool cmp(Edge e1, Edge e2){
	if (e1.w < e2.w) {
		return true;
	}
	if (e1.w > e2.w) {
		return false;
	}
	return e1.i < e2.i;
}

long long get(long long u) {
	if (DSU[u].to == u) {
		return u;
	}
	long long to = get(DSU[u].to);
	DSU[u].ans = std::max(DSU[u].ans, DSU[DSU[u].to].ans);
	DSU[u].to = to;
	return to;
}

void unite(long long u, long long v, long long w) {
	u = get(u);
	v = get(v);
	if (u == v) {
		return;
	}
	if (u == 0) {
		DSU[v].to = u;
		DSU[v].ans = w;
	}
	else if (v == 0) {
		DSU[u].to = v;
		DSU[u].ans = w;
	}
	else {
		if (DSU[u].size > DSU[v].size) {
			DSU[v].to = u;
			DSU[u].size += DSU[v].size;
		}
		else {
			DSU[u].to = v;
			DSU[v].size += DSU[u].size;
		}
	}
	return;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n >> m;
	for (long long i = 0; i < n; i++) {
		DSU[i].to = i;
		DSU[i].ans = 0;
		DSU[i].size = 1;
	}
	for (long long i = 0; i < m; i++) {
		std::cin >> u >> v >> t;
		edges.push_back({ --u, --v, t, i });
	}
	std::sort(edges.begin(), edges.end(), cmp);
	for (long long i = 0; i < m; i++) {
		unite(edges[i].u, edges[i].v, edges[i].w);
	}
	for (long long i = 1; i < n; i++) {
		get(i);
		std::cout << DSU[i].ans << "\n";
	}
	return 0;
}