#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

#define int ll

const int N = 3e5 + 10, INF = 0x3f3f3f3f;

int ans[N];

struct DSU {
	int parent[N];
	int wei[N];

	DSU() {
		iota(all(parent), 0);
		fill(all(wei), 0);
	}

	pair<int, int> get(int u) {
		if (parent[u] == u)
			return {u, 0};
		int cw = wei[u];
		tie(parent[u], wei[u]) = get(parent[u]);
		wei[u] = max(wei[u], cw);
		return make_pair(parent[u], wei[u]);
	}

	void merge(int a, int b, int w) {
		a = get(a).x;
		b = get(b).x;
		parent[b] = a;
		wei[b] = w;
	}
} dsu;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<pair<int, pair<int, int>>> vs;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u, --v;
		vs.push_back({w, {u, v}});
	}
	sort(all(vs));
	for (auto e : vs) {
		int acurr = dsu.get(0).x;
		int bcurr = dsu.get(e.y.x).x;
		if (acurr == bcurr)
			dsu.merge(e.y.x, e.y.y, e.x);
		else
			dsu.merge(e.y.y, e.y.x, e.x);
	}
	for (int i = 1; i < n; ++i)
		cout << dsu.get(i).y << "\n";
	return 0;
}