#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

#define int ll

const int N = 5e3 + 10, INF = 0x7f7f7f7f;

struct DSU {
	int parent[N], rank[N];

	DSU() {
		clear();
	}

	void clear() {
		iota(all(parent), 0);
		fill(all(rank), 0);
	}

	int get(int u) {
		if (parent[u] == u)
			return u;
		return parent[u] = get(parent[u]);
	}

	bool merge(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b)
			return false;
		if (rank[a] == rank[b])
			++rank[a];
		if (rank[a] < rank[b])
			swap(a, b);
		parent[b] = a;
		return true;
	}
} dsu2;

struct Edge {
	int v, w, i;
	int idx;
	int cut;
};

int version = 15;

vector<Edge> g[N];
int tin[N], fup[N], used[N], mn[N], color[N], ans[N];
int timer = 15;

void dfs_mn(int u, int bound, int cc) {
	used[u] = version + 2;
	color[u] = cc;
	for (auto e : g[u]) {
		if (e.w > bound)
			break;
		if (e.cut == version)
			continue;
		mn[cc] = min(mn[cc], e.w);
		if (used[e.v] == version + 2)
			continue;
		dsu2.merge(u, e.v);
		dfs_mn(e.v, bound, cc);
	}
}

void dfs_ans(int u, int bound, int cc = +INF) {
	used[u] = version + 1;
	cc = min(cc, mn[color[u]]);
	ans[u] = min(ans[u], bound + cc);
	for (auto e : g[u]) {
		if (e.w > bound)
			break;
		if (used[e.v] == version + 1)
			continue;
		dfs_ans(e.v, bound, min(cc, e.w));
	}
}

void dfs(int u, int bound, int p = -1) {
	used[u] = version;
	fup[u] = tin[u] = timer++;
	for (auto &e : g[u]) {
		if (e.w > bound)
			break;
		if (e.idx == p)
			continue;
		// cout << bound << "edge " << u << " " << e.v << endl;
		if (used[e.v] == version) {
			fup[u] = min(tin[e.v], fup[u]);
		} else {
			// fup[e.v] = tin[u];
			dfs(e.v, bound, e.idx);
			fup[u] = min(fup[e.v], fup[u]);
			// cout << fup[e.v] << " " << tin[u] << endl;
			if (fup[e.v] > tin[u]) {
				// cout << bound << " cut from " << u << " " << e.v << endl;
				e.cut = version;
				g[e.v][e.i].cut = version;
			}
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	map<int, vector<pair<int, int>>> edges;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u, --v;
		edges[w].push_back({u, v});
	}
	{
		int i = 0;
		for (auto es : edges) {
			for (auto e : es.y) {
				int w = es.x, u = e.x, v = e.y;
				g[u].push_back({v, w, sz(g[v]), i, 0});
				g[v].push_back({u, w, sz(g[u]) - 1, i, 0});
				++i;
			}
		}
	}
	fill(ans, ans + n, +INF);
	for (auto es : edges) {
		bool flag = 0;
		for (auto ee : es.y) {
			flag |= dsu2.get(ee.x) != dsu2.get(ee.y);
		}
		if (!flag)
			continue;
		dsu2.clear();
		version += 5;
		int bound = es.x;
		dfs(0, bound);
		fill(mn, mn + n, +INF);
		int cc = 0;
		for (int u = 0; u < n; ++u)
			if (used[u] != version + 2)
				dfs_mn(u, bound, cc++);
		dfs_ans(0, bound);
	}
	for (int i = 1; i < n; ++i)
		cout << ans[i] << "\n";
	return 0;
}