#include <bits/stdc++.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define vi vector<int>
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(a) ((int)a.size())
#define pb push_back

typedef long long ll;

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
}

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int INF = 1e9 + 7;
const ll INFL = 4e18;
const int MAXN = 3e5 + 10;

#define int ll

int val[26], cnt[26][MAXN];
vi poses;
int dp[MAXN][26], par[MAXN][26];

int GetSum(int symb, int l, int r) {
    if (l > r) {
        return 0;
    }
    if (l == 0) {
        return cnt[symb][r];
    }
    return cnt[symb][r] - cnt[symb][l - 1];
}

int Get(int lSymb, int rSymb, int l, int r) {
    int ans = 0;
    for (int i = lSymb; i <= rSymb; i++) {
        ans += GetSum(i, l, r) * val[i];
    }
    return ans;
}

int CalcSingle(string s) {
    vector<char> maOnSuf(sz(s));
    maOnSuf.back() = s.back();
    for (int i = sz(s) - 2; i >= 0; i--) {
        maOnSuf[i] = max(s[i], maOnSuf[i + 1]);
    }
    int ans = 0;
    for (int i = sz(s) - 1; i >= 0; i--) {
        if (i + 1 < sz(s) && maOnSuf[i + 1] > s[i]) {
            ans -= val[s[i] - 'A'];
        } else {
            ans += val[s[i] - 'A'];
        }
    }
    return ans;
}

void CalcVal() {
    val[0] = 1;
    for (int i = 1; i < 26; i++) {
        if (i & 1) {
            val[i] = val[i - 1] * 5;
        } else {
            val[i] = val[i - 1] * 2;
        }
    }
}

void Solve() {
    string s;
    cin >> s;
    vi prevQ(sz(s)), posQ, maOnSuf(sz(s));
    for (int i = sz(s) - 1; i >= 0; i--) {
        if (i + 1 == sz(s)) {
            maOnSuf[i] = s[i] - 'A';
            continue;
        }
        maOnSuf[i] = max(maOnSuf[i + 1], (int) (s[i] - 'A'));
    }
    int last = -1;
    for (int i = 0; i < sz(s); i++) {
        prevQ[i] = last;
        if (s[i] == '?') {
            posQ.pb(i);
            last = i;
        }
    }
    forn (i, sz(s)) {
        forn (j, 26) {
            cnt[j][i] = 0;
        }
    }
    forn (i, sz(posQ)) {
        forn (j, 26) {
            dp[i][j] = -INFL;
            par[i][j] = -1;
        }
    }
    forn (i, sz(s)) {
        if (s[i] != '?') {
            cnt[s[i] - 'A'][i] = 1;
        }
    }
    forn (i, 26) {
        for (int j = 1; j < sz(s); j++) {
            cnt[i][j] += cnt[i][j - 1];
        }
    }
    if (sz(posQ) == 0) {
        cout << CalcSingle(s) << nl;
        cout << s << nl;
        return;
    }
    forn (i, sz(posQ)) {
        if (i == 0) {
            forn (j, 26) {
                int ma = max(j, maOnSuf[posQ[0]]);
                string cur = s.substr(0, posQ[0]);
                cur += 'A' + j;
                cur += 'A' + ma;
                dp[0][j] = CalcSingle(cur) - val[ma];
                if (maOnSuf[posQ[0]] > j) {
                    dp[0][j] -= 2 * val[j];
                }
            }
            continue;
        }
        forn (j, 26) {
            int ma = max(j, maOnSuf[posQ[i]]);
            string cur = s.substr(posQ[i - 1] + 1, posQ[i] - posQ[i - 1] - 1);
            cur += 'A' + j;
            cur += 'A' + ma;
            dp[i][j] = CalcSingle(cur) - val[ma];
            if (maOnSuf[posQ[i]] > j) {
                dp[i][j] -= 2 * val[j];
            }
            auto pos = max_element(dp[i - 1] + j, dp[i - 1] + 26) - dp[i - 1];
            dp[i][j] += dp[i - 1][pos];
            par[i][j] = pos;
        }
    }
    auto pos = max_element(dp[sz(posQ) - 1], dp[sz(posQ) - 1] + 26) - dp[sz(posQ) - 1];
    int ans = dp[sz(posQ) - 1][pos];
    if (s.back() != '?') {
        ans += CalcSingle(s.substr(posQ.back() + 1, sz(s) - posQ.back() - 1));
    }
    for (int i = sz(posQ) - 1; i >= 0; i--) {
        s[posQ[i]] = 'A' + pos;
        pos = par[i][pos];
    }
    cout << ans << nl;
    cout << s << nl;
}

signed main() {
    IO();
    CalcVal();
    int t = 1;
    cin >> t;
    while (t--) {
        Solve();
    }
}