// ConsoleApplication2.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include <set>
#include <string>

using namespace std;

typedef long long ll;

vector<int> x, h;
vector<vector<int>> graph;
vector<int> top;
vector<bool> used;

void dfs(int v) {
	used[v] = true;
	for (auto to : graph[v]) {
		if (to != 0 && to != graph.size() && !used[to]) {
			dfs(to);
		}
	}
	top.push_back(v);
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, q;
	cin >> n >> q;
	x.resize(n + 1);
	h.resize(n + 1);
	graph.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (j < i) {
				if (x[i] - h[i] < x[j] && x[j] < x[i])
					graph[i].push_back(j);
			}
			if (j > i) {
				if (x[i] + h[i] > x[j] && x[j] > x[i])
					graph[i].push_back(j);
			}
		}
		if (i == 1) {
			graph[i].push_back(0);
		}
		if (i == n) {
			graph[i].push_back(n + 1);
		}
	}
	used.resize(n + 1);
	top.push_back(0);
	for (int i = 1; i <= n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	vector<int> inds(n + 1);
	for (int i = 1; i <= n; i++) {
		inds[top[i]] = i;
	}
	while (q--) {
		int l, r;
		cin >> l >> r;
		vector<int> pp;
		for (int i = l; i <= r; i++) {
			pp.push_back(i);
		}
		sort(pp.begin(), pp.end(), [&inds](int a, int b) {
			return inds[a] < inds[b];
			});
		set<int> s;
		for (auto v : pp) {
			bool flag1 = true;
			for (auto to : graph[v]) {
				if (to < v) {
					if (s.find(to) == s.end()) {
						flag1 = false;
						break;
					}
				}
			}
			if (flag1) {
				s.insert(v);
			}
			bool flag2 = true;
			for (auto to : graph[v]) {
				if (to > v) {
					if (s.find(to) == s.end()) {
						flag2 = false;
						break;
					}
				}
			}
			if (flag2) {
				s.insert(v);
			}
		}
		cout << s.size() << '\n';
	}
}