#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

int n, m;
const int MAX_N = 300000 + 566;
const int MAX_LOG = 20;
vector<pair<int, ll>> graph[MAX_N];
vector<ll> answer;

void dfs(int v, int parent = -1, ll cur_min = LONG_LONG_MAX, ll cur_max = 0) {
    answer[v] = cur_max + cur_min;
    for (auto [u, t] : graph[v]) {
        if (u == parent) continue;
        dfs(u, v, min(cur_min, t), max(cur_max, t));
    }
}


void reset() {
    answer.clear();
    answer.resize(n);
    for (int i = 0; i < n; ++i) {
        graph[i].clear();
    }
}

int solve() {
    if (!(cin >> n >> m))
        return 1;
    reset();
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll t;
        cin >> u >> v >> t;
        u--; v--;
        graph[u].emplace_back(make_pair(v, t));
        graph[v].emplace_back(make_pair(u, t));
    }
    if (m == n - 1) {
        dfs(0);
        for (int i = 1; i < n; ++i) {
            cout << answer[i] << '\n';
        }
    }

    return 0;
}


int main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    for (int i = 0; i < tests; ++i) {
        if (solve())
            break;

#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
}
