#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

#define int long long
#define X first
#define Y second

using namespace std;

const int INF = 1e18;
const int N = 3e5;
const int M = 2 * N - 2;

vector<int> cntin(N + 1), cntout(N + 1);
vector<vector<pair<int, int>>> in(N + 1), out(N + 1);

bool visited[N + 1];
bool used_edges[M + 1];

vector<pair<pair<int, int>, pair<int, int>>> ans;

void dfs(int u, int p) {
    visited[u] = true;

    for (auto v : out[u])
        if (!visited[v.X])
            dfs(v.X, u);


    int i = 0, j = 0;
    while (i < in[u].size() && j < out[u].size()) {
        while (i < in[u].size() && (used_edges[in[u][i].Y] || in[u][i].X == p))
            ++i;
        while (j < out[u].size() && (used_edges[out[u][j].Y] || out[u][j].X == p))
            ++j;

        if (i < in[u].size() && j < out[u].size()) {
            used_edges[in[u][i].Y] = true;
            used_edges[out[u][j].Y] = true;

            ans.push_back({{in[u][i].X, u},
                           {u,          out[u][j].X}});
            --cntout[in[u][i].X];
            --cntin[out[u][j].X];

            --cntout[u];
            --cntin[u];
        }
    }

    i = 0, j = 0;
    if (cntin[u] != 0 && cntout[u] != 0) {
        while (i < in[u].size() && j < out[u].size()) {
            while (i < in[u].size() && (used_edges[in[u][i].Y]))
                ++i;
            while (j < out[u].size() && (used_edges[out[u][j].Y]))
                ++j;

            if (i < in[u].size() && j < out[u].size()) {
                if (in[u][i].X == p && out[u][j].X == p) {
                    ++i;
                    continue;
                }
                used_edges[in[u][i].Y] = true;
                used_edges[out[u][j].Y] = true;

                ans.push_back({{in[u][i].X, u},
                               {u,          out[u][j].X}});
                --cntout[in[u][i].X];
                --cntin[out[u][j].X];

                --cntout[u];
                --cntin[u];
            }
        }
    }
    i = 0, j = 0;
    if (cntin[u] != 0 && cntout[u] != 0) {
        while (i < in[u].size() && j < out[u].size()) {
            while (i < in[u].size() && (used_edges[in[u][i].Y]))
                ++i;
            while (j < out[u].size() && (used_edges[out[u][j].Y]))
                ++j;

            if (i < in[u].size() && j < out[u].size()) {
                if (in[u][i].X == p && out[u][j].X == p) {
                    ++j;
                    continue;
                }
                used_edges[in[u][i].Y] = true;
                used_edges[out[u][j].Y] = true;

                ans.push_back({{in[u][i].X, u},
                               {u,          out[u][j].X}});
                --cntout[in[u][i].X];
                --cntin[out[u][j].X];

                --cntout[u];
                --cntin[u];
            }
        }
    }

    i = 0, j = 0;
    if (cntin[u] != 0 && cntout[u] != 0) {
        while (i < in[u].size() && j < out[u].size()) {
            while (i < in[u].size() && (used_edges[in[u][i].Y]))
                ++i;
            while (j < out[u].size() && (used_edges[out[u][j].Y]))
                ++j;

            if (i < in[u].size() && j < out[u].size()) {
                used_edges[in[u][i].Y] = true;
                used_edges[out[u][j].Y] = true;

                ans.push_back({{in[u][i].X, u},
                               {u,          out[u][j].X}});
                --cntout[in[u][i].X];
                --cntin[out[u][j].X];

                --cntout[u];
                --cntin[u];
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        in[v].push_back({u, i});
        out[u].push_back({v, i});
        ++cntin[v];
        ++cntout[u];
    }

    for (int i = 1; i <= n; ++i)
        if (!visited[i])
            dfs(i, -1);

    for (int i = 1; i <= n; ++i){
        if (cntin[i] != 0 || cntout[i] != 0){
            cout << "No";
            return;
        }
    }
    if (ans.size() * 2 == m) {
        cout << "Yes\n";
        for (auto e : ans)
            cout << e.X.X << " " << e.X.Y << " " << e.Y.X << " " << e.Y.Y << endl;
    }
    else{
        cout << "No\n";
    }
}

signed main() {
    solve();
    return 0;
}
