#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

using edge = pair<int, int>;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> forest(n);
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        forest[u].push_back(v);
        forest[v].push_back(u);
        edges.emplace_back(u, v);
    }
    vector<int> roots;
    vector<int> depth(n, 0);
    vector<int> cmp(n, -1);
    int c = 0;
    function<void(int, int, int)> dfs = [&](int i, int color, int d) {
        if (cmp[i] == color) return;
        cmp[i] = color;
        depth[i] = d;
        for (int next : forest[i]) dfs(next, color, d + 1);
    };
    for (int i = 0; i < n; ++i) {
        if (cmp[i] == -1) {
            dfs(i, c++, 0);
            roots.push_back(i);
        }
    }
    auto d = [&](edge e) { return max(depth[e.first], depth[e.second]); };
    sort(edges.begin(), edges.end(), [&](auto e1, auto e2) { return d(e1) > d(e2); });
    vector<vector<edge>> free_begin(n);
    vector<vector<edge>> free_end(n);
    vector<tuple<int, int, int, int>> ans;
    for (auto[u1, v1] : edges) {
        if (depth[u1] > depth[v1]) {
            if (!free_end[u1].empty()) {
                auto[u2, v2] = free_end[u1].back();
                ans.emplace_back(u1, v1, u2, v2);
                free_end[u1].pop_back();
            } else if (!free_begin[v1].empty()) {
                auto[u2, v2] = free_begin[v1].back();
                ans.emplace_back(u1, v1, u2, v2);
                free_begin[v1].pop_back();
            } else {
                free_end[v1].emplace_back(u1, v1);
            }
        } else {
            if (!free_begin[v1].empty()) {
                auto[u2, v2] = free_begin[v1].back();
                ans.emplace_back(u1, v1, u2, v2);
                free_begin[v1].pop_back();
            } else if (!free_end[u1].empty()) {
                auto[u2, v2] = free_end[u1].back();
                ans.emplace_back(u1, v1, u2, v2);
                free_end[u1].pop_back();
            } else {
                free_begin[u1].emplace_back(u1, v1);
            }
        }
    }
    if (ans.size() * 2 != m) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for (auto[a, b, c, d] : ans) {
            cout << a + 1 << ' ' << b + 1 << ' ' << c + 1 << ' ' << d + 1 << '\n';
        }
    }
}