#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const ll INFL = 2e18;

struct edge {
    int t, r;

    bool operator<(const edge &a) const {
        return t < a.t || t == a.t && r < a.r;
    }
};

vector<vector<int>> ans;
bool ok;

void dfs(vector<set<edge>> &g, vector<int> &used, int v, int p) {
    vector<int> from, to;
    for (auto it = g[v].begin(); it != g[v].end();) {
        auto i = *it;
        auto ne = it;
        if (!used[i.t]) {
            used[i.t] = 1;
            dfs(g, used, i.t, v);
            ne = g[v].find({i.t, -i.r});
            if (ne != g[v].end()) {
                ans.push_back({v, i.t, i.t, v});
                g[v].erase(ne);
            } else if (i.r == 1) {
                to.push_back(i.t);
            } else {
                from.push_back(i.t);
            }
            ne = next(it);
            g[v].erase(it);
            it = ne;
        } else {
            ++it;
        }
    }
    ok &= abs((int) from.size() - (int) to.size()) < 2;
    int i = 0, j = 0;
    for (; i < from.size() && j < to.size(); i++, j++)
        ans.push_back({from[i], v, v, to[i]});
    if (ok) {
        if (p == -1 && (i < from.size() || j < to.size()))
            ok = false;
        else if (i < from.size()) {
            auto it = g[p].find({v, -1});
            ok &= it != g[p].end();
            if (ok) {
                ans.push_back({from.back(), v, v, p});
                g[p].erase(it);
            }
        } else if (j < to.size()) {
            auto it = g[p].find({v, 1});
            ok &= it != g[p].end();
            if (ok) {
                ans.push_back({p, v, v, to.back()});
                g[p].erase(it);
            }

        }
    }
}


int main() {
    input();
    int n, m;
    cin >> n >> m;
    vector<set<edge>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].insert({v, 1});
        g[v].insert({u, -1});
    }
    vector<int> used(n);
    ok = true;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = true;
            dfs(g, used, i, -1);
        }
    }
    if (ok) {
        cout << "Yes\n";
        for (auto &i : ans) {
            for (auto &j : i) {
                cout << j + 1 << " ";
            }
            cout << "\n";
        }
    } else {
        cout << "No";
    }
    return 0;
}