#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const ll INFL = 2e18;

struct tree {
    int x, h;

    bool operator<(const tree &a) const {
        return h < a.h || h == a.h && x < a.x;
    }
};

int main() {
    input();
    int n, q;
    cin >> n >> q;
    vector<tree> forest(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> forest[i].x >> forest[i].h;
    }
    for (int _ = 0; _ < q; _++) {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        set<int> inds;
        queue<int> del;
        vector<int> prev(n + 2), next(n + 2);
        for (int i = 0; i <= n; i++)
            prev[i] = i - 1,
            next[i] = i + 1;
        for (int i = l; i <= r; i++) {
            int j = i - 1;
            if (j == -1)
                j++;
            if (forest[i].x - forest[i].h >= forest[j].x) {
                next[prev[i]] = next[i];
                prev[next[i]] = prev[i];
                del.push(next[i]);
                ++ans;
                continue;
            }
            j = i + 1;
            if (j == n)
                --j;
            if (forest[i].x + forest[i].h <= forest[j].x) {
                ++ans;
                next[prev[i]] = next[i];
                prev[next[i]] = prev[i];
                del.push(next[i]);
            }
        }
        while (!del.empty()) {
            auto it = del.front();
            //auto left = inds.lower_bound(it);
            int left = it;
            if (prev[left] != l - 1) {
                int mid1;
                if (left == r + 1)
                    mid1 = min(r + 1, n);
                else
                    mid1 = left;
                left = prev[left];
                if (forest[left].x + forest[left].h <= forest[mid1].x) {
                    ++ans;
                    next[prev[left]] = next[left];
                    prev[next[left]] = prev[left];
                    del.push(next[left]);
                }
            }
            //auto right = inds.upper_bound(it);
            int right = it;
            if (right != r + 1) {
                int mid1;
                if (prev[right] == l - 1) {
                    mid1 = max(1, l - 1);
                } else {
                    mid1 = prev[right];
                }
                if (forest[right].x - forest[right].h >= forest[mid1].x) {
                    del.push(next[right]);
                    ++ans;
                    inds.erase(right);
                    next[prev[right]] = next[right];
                    prev[next[right]] = prev[right];
                }
            }
            del.pop();
        }
        cout << ans << "\n";
    }
    return 0;
}