#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ios>
#include <cassert>
#include <queue>
#include <cassert>
using namespace std;

const int INF = 1e9;

vector<vector<pair<int, int>>> g;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	g.resize(n);

	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		g[a].push_back({ b, c });
		g[b].push_back({ a, c });

		if (a == 0 || b == 0) {
			if (c != 0) {
				exit(3);
			}
		}
	}

	vector<char> used(n);
	vector<int> max_edge(n, INF);
	max_edge[0] = -INF;
	set<pair<int, int>> not_used;
	not_used.insert({ max_edge[0], 0 });

	while (!not_used.empty()) {
		auto [max_e, v] = *not_used.begin();
		not_used.erase(not_used.begin());
		used[v] = true;

		for (auto [w, e] : g[v]) {
			if (used[w])
				continue;
			int new_max = max(e, max_e);
			if (max_edge[w] > new_max) {
				not_used.erase({ max_edge[w], w });
				max_edge[w] = e;
				not_used.insert({ max_edge[w], w });
			}
		}
	}

	for (int i = 1; i < n; i++) {
		cout << max_edge[i] << "\n";
	}
}