#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define mp make_pair
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
const ll inf = 2e18;
const ll MAXN = 4e5 + 10;

using namespace std;

struct edge{
    int v, u, ind;
    edge(int v, int u, int ind): v(v), u(u), ind(ind) {}
    edge() {}
};

vector<edge> g[MAXN];
vector<edge> bg[MAXN];
int used[MAXN];
int used_edges[MAXN];
vector<edge> edges;
vector<pii> pairings;

void dfs(int v, int p = -1) {
    used[v] = 1;
    vector<edge> out, in;
    edge out_par = edge(-1, -1, -1);
    bool outp = 0;
    edge in_par = edge(-1, -1, -1);
    bool inp = 0;
    for (edge u : g[v]) {
        if (used[u.u]) continue;
        dfs(u.u, v);
    }
    for (edge u : bg[v]) {
        if (used[u.u]) continue;
        dfs(u.u, v);
    }
    for (edge u : g[v]) {
        if (p == u.u) {
            if (!used_edges[u.ind]) out_par = u, outp = 1;
            continue;
        }
        if (!used_edges[u.ind]) out.push_back(u);
    }
    for (edge u : bg[v]) {
        if (p == u.u) {
            if (!used_edges[u.ind]) in_par = u, inp = 1;
            continue;
        }
        if (!used_edges[u.ind]) in.push_back(u);
    }
    if ((in.size() > out.size() + outp) || (out.size() > in.size() + inp)) {
        cout << "No\n";
        exit(0);
    }
    while (in.size() && out.size()) {
        auto e1 = in.back();
        auto e2 = out.back();
        used_edges[e1.ind] = 1;
        used_edges[e2.ind] = 1;
        pairings.push_back(mp(e1.ind, e2.ind));
        in.pop_back();
        out.pop_back();
    }
    if (in.size()) {
        auto e1 = in.back();
        auto e2 = out_par;
        used_edges[e1.ind] = 1;
        used_edges[e2.ind] = 1;
        pairings.push_back(mp(e1.ind, e2.ind));
    }
    if (out.size()) {
        auto e1 = out.back();
        auto e2 = in_par;
        used_edges[e1.ind] = 1;
        used_edges[e2.ind] = 1;
        pairings.push_back(mp(e1.ind, e2.ind));
    }
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int v, u; cin >> v >> u;
        --v, --u;
        g[v].push_back(edge(v, u, edges.size()));
        bg[u].push_back(edge(u, v, edges.size()));
        edges.push_back(edge(v, u, edges.size()));
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(i, -1);
    }
    cout << "Yes\n";
    for (auto x : pairings) {
        cout << edges[x.first].v + 1 << " " << edges[x.first].u + 1 << " " <<
        edges[x.second].v + 1 << " " << edges[x.second].u + 1 << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);

//    int t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
