#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <random>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>

#define ll long long
#define ld long double

using namespace std;

const int N = 5e5 + 3;
vector<pair<pair<int, int>, pair<int, int>>>ans;
set<int> a[N];
vector<int> b[N];
bool used[N];

pair<int, int> dfs(int v) {
	used[v] = 1;
	vector<int>in;
	vector<int>out;
	for (auto to : b[v]) {
		if (!used[to]) {
			pair<int, int>res = dfs(to);
			if (res.second == -2) return { -2, -2 };
			if (res.second == -1) {
				if (a[v].find(to) != a[v].end()) {
					ans.push_back({ { v, to }, { to, res.first } });
					a[v].erase(to);
					a[to].erase(res.first);
				}
				else {
					return { -2, -2 };
				}
			}
			if (res.second == 1) {
				if (a[to].find(v) != a[to].end()) {
					ans.push_back({ { res.first, to }, { to, v } });
					a[to].erase(v);
					a[res.first].erase(to);
				}
				else {
					return { -2, -2 };
				}
			}
			if (a[v].find(to) != a[v].end()) {
				if (a[to].find(v) != a[to].end()) {
					ans.push_back({ { v, to }, {to, v} });
					a[to].erase(v);
					a[v].erase(to);
				}
				else {
					in.push_back(to);
				}
			}
			else {
				if (a[to].find(v) != a[to].end()) {
					out.push_back(to);
				}
			}
		}
	}
	int ind = 0;
	while (ind < in.size() && ind < out.size()) {
		ans.push_back({ { out[ind], v }, {v, in[ind]} });
		ind += 1;
	}
	if (ind < in.size()) {
		if (ind < in.size() - 1) {
			return { -2, -2 };
		}
		else {
			return { in[ind], -1 };
		}
	}
	else if (ind < out.size()) {
		if (ind < out.size() - 1) {
			return { -2, -2 };
		}
		else {
			return { out[ind], 1 };
		}
	}
	else {
		return { -1, 0 };
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		a[x - 1].insert(y - 1);
		b[x - 1].push_back(y - 1);
		b[y - 1].push_back(x - 1);
	}
	bool flag = true;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			pair<int, int>res = dfs(i);
			if (res.second != 0) {
				flag = false;
				break;
			}
		}
	}
	if (flag) {
		cout << "Yes" << '\n';
		for (int i = 0; i < ans.size(); ++i) {
			cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' ' << ans[i].second.first + 1 << ' ' << ans[i].second.second + 1 << '\n';
		}
	}
	else {
		cout << "No";
	}
}