#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cassert>
//#define int long long

using namespace std;

vector<vector<int>> b;
vector<int> r;
vector<int> l;
vector<bool> vis;

void dfs(int v, bool color = 0) {
	if (vis[v])
		return;
	vis[v] = true;
	r[v] = color;
	for (int u : b[v])
		dfs(u, !color);
}

bool kuhn(int v) {
	if (vis[v])
		return false;
	vis[v] = true;
	for (int u : b[v])
		if (r[u] == -1) {
			r[u] = v;
			l[v] = u;
			vis[v] = false;
			return true;

		}
	for (int u : b[v])
		if (r[u] != v && kuhn(r[u])) {
			r[u] = v;
			l[v] = u;
			vis[v] = false;
			return true;
		}
	vis[v] = false;
	return true;
}


int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> g(m);
	vector<vector<vector<int>>> nodes(n, vector<vector<int>>(2, vector<int>(0)));
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		g[i] = { x, y };
		--x, --y;
		nodes[x][1].push_back(i);
		nodes[y][0].push_back(i);
	}
	b.resize(m);
	r.resize(m);
	l.resize(m, -1);
	vis.resize(m);
	for (int i = 0; i < n; ++i) {
		for (int u : nodes[i][0])
			for (int v : nodes[i][1])
			{
				b[u].push_back(v);
				b[v].push_back(u);
			}
	}
	for (int i = 0; i < m; ++i)
		if (!vis[i])
			dfs(i, 0);
	vector<int> left;
	for (int i = 0; i < m; ++i)
		if (!r[i])
			left.push_back(i);
	r.assign(m, -1);
	vis.assign(m, 0);
	if (left.size() != m / 2) {
		cout << "No\n";
		return 0;
	}
	for (int i = 0; i < m / 2; ++i)
		if (l[left[i]] == -1)
			kuhn(left[i]);
	vector<pair<int, int>> ans;
	for (int i = 0; i < m / 2; ++i) {
		if (l[left[i]] != -1)
			ans.push_back({ left[i], l[left[i]] });
		else {
			cout << "No\n";
			return 0;
		}
	}
	vis.assign(m, 0);
	for (auto t : ans) {
		assert(!vis[t.first]);
		assert(!vis[t.second]);
		//assert(g[t.first].second == g[t.second].first || g[t.first].first == g[t.second].second);
		vis[t.first] = true, vis[t.second] = true;
	}
	cout << "Yes\n";
	for (auto t : ans) {
		if (g[t.first].second != g[t.second].first)
			swap(t.first, t.second);
		cout << g[t.first].first << ' ' << g[t.first].second << ' ' << g[t.second].first << ' ' << g[t.second].second << '\n';
	}
}