#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cassert>

using namespace std;

vector<bool> used;
vector<int> dist;
vector<bool> vis;
vector < pair<pair<int, int>, int>> b;
vector<vector<pair<pair<int, int>, int>>> g;

void treedfs(int v = 0, int ma = 0, int mi = 1000000100) {
	if (vis[v])
		return;
	vis[v] = true;
	dist[v] = ma + mi;
	for (auto z : g[v]) {
		auto k = z.first;
		assert(k.first >= 0);
		treedfs(k.first, max(ma, k.second), min(mi, k.second));
	}
	
}

void brutedfs(int v, int e = 0, int ma = 0, int mi = 1000000100) {
	if (used[e])
		return;
	used[e] = true;
	if (dist[v] == -1 || ma + mi < dist[v])
		dist[v] = ma + mi;
	for (auto z : g[v]) {
		auto k = z.first;
		//assert(k.first >= 0);
		brutedfs(k.first, z.second, max(ma, k.second), min(mi, k.second));
	}
	used[e] = false;
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vis.resize(n);
	g.resize(n);
	used.resize(m);
	dist.resize(n, -1);
	dist[0] = 0;
	for (int i = 0; i < m; ++i) {
		int x, y, c;
		cin >> x >> y >> c;
		--x, --y;
		//b.push_back({ {x, y}, c });
		g[x].push_back({ { y, c }, i });
		g[y].push_back({ { x, c }, i });

	}
	/*if (m == n - 1) {
		treedfs();
	}
	else*/ if (n <= 2000 && m <= 2000) {
		brutedfs(0);
	}
	else if (g[0][0].second == 0) {

	}
	else {

	}
	for (int i = 1; i < n; ++i)
		cout << dist[i] << '\n';
}