#include<iostream>
#include<string>
#include<vector>

using namespace std;

typedef long long int ll;

vector<ll> pw10(15, 1);

void init_pw10() {
	for (ll i = 1; i < 15; i++) pw10[i] = 10 * pw10[i - 1];
}

ll maxll(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll pow(ll a, ll b) {
	if (b == 0) return 1;
	if (b == 1) return a;
	ll c = pow(a, b / 2);
	c *= c;
	if (b % 2 == 1) return c *= a;
	return c;
}

ll preob(ll a) {
	ll res = pw10[a/2];
	if (a % 2 == 1) res *= 5;
	return res;
}

ll moscow_to_normal(vector<ll>& a, vector<ll>& b, ll n) {
	ll sum = 0;
	for (ll i = 0; i < n - 1; i++) if (b[i] >= a[i]) sum += preob(b[i]);
	else sum -= preob(b[i]);
	sum += preob(b[n - 1]);
	return sum;
}

int main() {
	init_pw10();
	ll t;
	cin >> t;
	for (ll u = 0; u < t; u++) {
		string s;
		cin >> s;
		vector<ll> a(s.size(), -1);
		for (ll i = 0; i < s.size(); i++) {
			if (s[i] != '?') a[i] = (s[i] - 'A');
		}
		vector<ll> b(s.size());
		ll n = s.size(), kq = 0;
		for (ll i = 0; i < n; i++) if (a[i] == -1) kq++;
		if (kq == 0) {
			b[n - 1] = -1;
			for (ll i = n - 2; i > -1; i--) b[i] = maxll(b[i + 1], a[i + 1]);
			cout << moscow_to_normal(b, a, n) << endl;
			cout << s << endl;
		}
		else {
			vector<ll> res(0);
			vector<ll> q(0);
			ll sum = -10000000000000000;
			for (ll i = 0; i < n; i++) if (a[i] == -1) {
				q.push_back(i);
				res.push_back(-1);
			}
			if (kq == 1) {
				for (ll i = 0; i < 26; i++) {
					a[q[0]] = i;
					b[n - 1] = -1;
					for (ll i = n - 2; i > -1; i--) b[i] = maxll(b[i + 1], a[i + 1]);
					ll sum2 = moscow_to_normal(b, a, n);
					if (sum2 > sum) {
						sum = sum2;
						res[0] = i;
					}
				}
				a[q[0]] = res[0];
				cout << sum << endl;
				for (ll i = 0; i < n; i++) cout << char(a[i] + 'A');
				cout << endl;
			}
			else if (kq == 2) {
				for (ll i = 0; i < 26; i++) {
					for (ll j = 0; j < 26; j++) {
						a[q[0]] = i;
						a[q[1]] = j;
						b[n - 1] = -1;
						for (ll i = n - 2; i > -1; i--) b[i] = maxll(b[i + 1], a[i + 1]);
						ll sum2 = moscow_to_normal(b, a, n);
						if (sum2 > sum) {
							sum = sum2;
							res[0] = i;
							res[1] = j;
						}
					}
				}
				a[q[0]] = res[0];
				a[q[1]] = res[1];
				cout << sum << endl;
				for (ll i = 0; i < n; i++) cout << char(a[i] + 'A');
				cout << endl;
			}
			else {
				for (ll i = 0; i < 26; i++) {
					for (ll j = 0; j < 26; j++) {
						for (ll k = 0; k < 26; k++) {
							a[q[0]] = i;
							a[q[1]] = j;
							a[q[2]] = k;
							b[n - 1] = -1;
							for (ll i = n - 2; i > -1; i--) b[i] = maxll(b[i + 1], a[i + 1]);
							ll sum2 = moscow_to_normal(b, a, n);
							if (sum2 > sum) {
								sum = sum2;
								res[0] = i;
								res[1] = j;
								res[2] = k;
							}
						}
					}
				}
				a[q[0]] = res[0];
				a[q[1]] = res[1];
				a[q[2]] = res[2];
				cout << sum << endl;
				for (ll i = 0; i < n; i++) cout << char(a[i] + 'A');
				cout << endl;
			}
		}
	}
}