#include <iostream>
#include <map>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

map<int, int>* gr;
bool* used;
int* type;

bool ok = true;

void dfs(int v, int p, int p_type)
{
	used[v] = 1;
	int cnt[2] = { 0, 0 };
	for (const auto& to : gr[v])
	{
		int u = to.first, child_type = to.second;
		if (u == p)
			continue;
		dfs(u, v, child_type);
		if (type[u] == 2)
			continue;
		cnt[type[u]]++;
	}
	if (cnt[0] == cnt[1])
		type[v] = p_type;
	else if (abs(cnt[0] - cnt[1]) > 1)
		ok = false;
	else
	{
		int stay_type = (cnt[0] > cnt[1] ? 0 : 1);
		if (p_type == 2)
			type[v] = 1 - stay_type;
		else if (stay_type != p_type)
			ok = false;
		else
			type[v] = 2;
	}
}

vector<pair<pair<int, int>, pair<int, int>>> ans;

void build_ans(int v, int p)
{
	used[v] = 1;
	for (const auto& to : gr[v])
	{
		int u = to.first;
		if (u == p)
			continue;
		build_ans(u, v);
	}
	vector<int> children_of_type[2];
	for (const auto& to : gr[v])
	{
		int u = to.first, child_type = to.second;
		if (u == p)
			continue;
		if (type[u] == 2)
			continue;
		children_of_type[type[u]].push_back(u);
	}
	int cnt[2] = { children_of_type[0].size(), children_of_type[1].size() };

	for (int i = 0; i < cnt[0] && i < cnt[1]; i++)
		ans.push_back({ { children_of_type[0][i], v }, { v, children_of_type[1][i] } });

	if (cnt[0] == cnt[1] && type[v] == 2 && p != -1)
		ans.push_back({ { v, p }, { p, v } });

	if (cnt[0] > cnt[1])
	{
		int child = children_of_type[0].back();
		ans.push_back({ { child, v }, { v, p } });
	}
	else if (cnt[1] > cnt[0])
	{
		int child = children_of_type[1].back();
		ans.push_back({ { p, v }, { v, child } });
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	gr = new map<int, int>[n];
	int u, v;
	for (int i = 0; i < m; i++)
	{
		cin >> u >> v;
		u--, v--;
		if (gr[u].count(v) == 0)
		{
			gr[u][v] = 1;
			gr[v][u] = 0;
		}
		else
		{
			gr[u][v] = 2;
			gr[v][u] = 2;
		}
	}
	used = new bool[n];
	type = new int[n];
	memset(type, 0, n * sizeof(int));
	memset(used, 0, n * sizeof(bool));
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
			dfs(i, -1, 2);
	}
	if (!ok)
	{
		cout << "No" << "\n";
		return 0;
	}
	cout << "Yes" << "\n";
	memset(used, 0, n * sizeof(bool));
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
			build_ans(i, -1);
	}
	for (const auto& el : ans)
		cout << el.first.first + 1 << " " << el.first.second + 1 << " " << el.second.first + 1 << " " << el.second.second + 1 << "\n";
}
