#include <iostream>
#include <vector>
#include <cstring>
#include <algorithm>
#include <cmath>

using namespace std;

const int INF = 1e9 + 7;

vector<pair<pair<int, int>, int>>* gr;
bool* bridge;
int* tin, * fout;
bool* used;

int timer = 0;
void dfs(int v, int num)
{
	used[v] = 1;
	fout[v] = tin[v] = timer++;
	for (const auto& to : gr[v])
	{
		if (to.second == num)
			continue;
		int u = to.first.first;
		if (used[u])
		{
			fout[v] = min(fout[v], tin[u]);
			continue;
		}
		dfs(u, to.second);
		if (fout[u] <= tin[v])
			bridge[to.second] = 1;
	}
}

int* num_cmp;
vector<int> min_in_cmp;
vector<pair<int, int>>* cmp_gr;

int find_cmp_dfs(int v, int cmp)
{
	int mn = INF;
	if (num_cmp[v] != -1)
		return mn;
	num_cmp[v] = cmp;
	for (const auto& to : gr[v])
	{
		if (bridge[to.second])
			continue;
		mn = min(mn, to.first.second);
		mn = min(mn, find_cmp_dfs(to.first.first, cmp));
	}
	return mn;
}

int* min_on_way;

void min_on_way_dfs(int cmp)
{
	if (used[cmp])
		return;
	used[cmp] = 1;
	for (const auto& to : cmp_gr[cmp])
	{
		if (used[to.first])
			continue;
		min_on_way[to.first] = min({ min_on_way[cmp], min_in_cmp[to.first], to.second });
		min_on_way_dfs(to.first);
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	gr = new vector<pair<pair<int, int>, int>>[n];
	int u, v, t;
	for (int i = 0; i < m; i++)
	{
		cin >> u >> v >> t;
		u--, v--;
		gr[u].push_back({ { v, t }, i });
		gr[v].push_back({ { u, t }, i });
	}
	tin = new int[n], fout = new int[n], used = new bool[n];
	memset(used, 0, n * sizeof(bool));
	bridge = new bool[m];
	memset(bridge, 0, m * sizeof(bool));
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
			dfs(i, -1);
	}
	num_cmp = new int[n];
	memset(num_cmp, -1, n * sizeof(int));
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (num_cmp[i] == -1)
			min_in_cmp.push_back(find_cmp_dfs(i, cnt++));
	}
	cmp_gr = new vector<pair<int, int>>[cnt];
	for (int i = 0; i < n; i++)
	{
		for (const auto& to : gr[i])
		{
			int j = to.first.first;
			if (num_cmp[i] != num_cmp[j])
			{
				cmp_gr[num_cmp[i]].push_back({ num_cmp[j], to.first.second });
				cmp_gr[num_cmp[j]].push_back({ num_cmp[i], to.first.second });
			}
		}
	}
	used = new bool[cnt];
	memset(used, 0, cnt * sizeof(bool));
	min_on_way = new int[cnt];
	min_on_way[0] = min_in_cmp[0];
	min_on_way_dfs(0);
	for (int k = 1; k < n; k++)
		cout << int(min_on_way[num_cmp[k]] + 1e9) << "\n";
}
