#include <iostream>
#include <vector>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;
typedef vector <pii> vpii;
typedef vector <vpii> vvpii;

const int INF = 1e9;

vvpii g;
vi mi, ma;

void dfs(int v, int p = -1) {
  for (auto [u, w] : g[v]) {
    if (u == p) {
      continue;
    }
    if (p == -1) {
      mi[u] = ma[u] = w;
    } else {
      mi[u] = min(mi[v], w);
      ma[u] = max(ma[v], w);
    }
    dfs(u, v);
  }
}

int main() {
  int n, m;
  cin >> n >> m;
  g.resize(n);
  bool group2 = true, group3 = true;
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    if (u > v) {
      swap(u, v);
    }
    g[u].push_back({v, w});
    g[v].push_back({u, w});
    if (u == 1) {
      if (w != 0) {
        group2 = false;
      }
      if (w != INF) {
        group3 = false;
      }
    }
  }
  mi.resize(n), ma.resize(n);
  dfs(0);
  for (int v = 1; v < n; v++) {
    cout << mi[v] + ma[v] << '\n';
  }
  return 0;
}