#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>

using namespace std;
using ll = int;
using ld = long double;

//const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

map <char, ll> h;

void init() {
	ll cur = 1;
	for (char c = 'A'; c <= 'Z'; ++c) {
		h[c] = cur;
		if (c & 1) {
			cur *= 5;
		}
		else {
			cur *= 2;
		}
	}
}

vector <vector <pair <ll, ll>>> g;
vector <map <ll, ll>> cnte;

vector <ll> mp;
vector <ll> color;

vector <pair <ll, ll>> dp;
vector <pair <ll, ll>> edge;
vector <bool> used;

vector <pair <ll, ll>> ans;

pair <ll, ll> dfs(int v, int p = -1) {
	if (dp[v] != make_pair(-1ll, -1ll)) {
		return dp[v];
	}
	used[v] = true;
	vector <ll> in, out;
	for (auto& x : g[v]) {
//		cout << v << '\n';
//		cout << '\t' << x.first << '\n';
		bool eused = false;
		if (x.first != p) {
			auto t = dfs(x.first, v);
			if (t.first && x.second > 0) {
				ans.push_back(make_pair(x.second, edge[x.first].first));
				--dp[x.first].first;
				eused = true;
			}
			if (t.second && x.second < 0) {
				ans.push_back(make_pair(abs(x.second), edge[x.first].second));
				--dp[x.second].second;
				eused = true;
			}
			if (t.first && x.second < 0 && cnte[v][x.first] == 0) {
				cout << "No\n";
				exit(0);
			}
			if (t.second && x.second > 0 && cnte[v][x.first] == 0) {
				cout << "No\n";
				exit(0);
			}
			if ((t.first >= 1 || t.second >= 1) && cnte[v][x.first] == 0) {
				cout << "No\n";
				exit(0);
			}
			--cnte[v][x.first];
		}
		if (x.first != p && !eused) {
//			cout << "From " << v + 1 << " to " << x.first + 1 << "\n";
			if (x.second > 0) {
				out.push_back(abs(x.second));
			}
			else {
				in.push_back(abs(x.second));
			}
		}
	}
	ll mine = min(in.size(), out.size());
	for (int i = 0; i < mine; ++i) {
		ans.push_back(make_pair(abs(in.back()), abs(out.back())));
		in.pop_back();
		out.pop_back();
	}
//	cout << v + 1 << ' ' << out << ' ' << in << '\n';
	edge[v] = { (out.empty() ? -1 : out.back()), (in.empty() ? -1 : in.back()) };
	return dp[v] = { out.size(), in.size() };
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> n >> m;
	g.resize(n);
	dp.resize(n, make_pair(-1ll, -1ll));
	edge.resize(n);
	map <ll, pair <ll, ll>> rev;
	cnte.resize(n);
	for (int i = 0; i < m; ++i) {
		ll a, b;
		cin >> a >> b;
		--a; --b;
		g[a].push_back({ b, i + 1 });
		g[b].push_back({ a, -(i + 1) });
		cnte[a][b]++;
		cnte[b][a]++;
		rev[i + 1] = { a, b };
	}

//	cout << "popa\n";
	used.assign(n, false);
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
//			cout << i << '\n';
			auto it = dfs(i);
			if (it.first >= 1 || it.second >= 1) {
				cout << "No\n";
				return 0;
			}
		}
	}
//	cout << "opa\n";

	cout << "Yes\n";
	for (auto& x : ans) {
		if (x.first == -1 || x.second == -1) {
			cout << "No\n";
		}
		cout << rev[x.first].first + 1 << ' ' << rev[x.first].second + 1 << ' ' << rev[x.second].first + 1 << ' ' << rev[x.second].second + 1 << '\n';
	}

	return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
 
4 4
2 1
2 3
2 4
4 2
 
4 4
1 2
2 1
3 4
4 3
*/