#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


struct edge {
	ll u, c;

	edge(ll u = 0, ll c = 0) : u(u), c(c) {};
};

vector <vector <edge>> g;
vector <ll> dist;
vector <bool> used;

void Dijkstra() {
	priority_queue <pair <ll, ll>> q;
	q.push({ 0, 0 });
	dist.assign(n, INF);
	dist[0] = 0;
	used.assign(n, false);
	while (!q.empty()) {
		ll v = q.top().second;
		q.pop();
		if (used[v]) continue;
		used[v] = true;
		for (auto& x : g[v]) {
			if (mini(dist[x.u], max(dist[v], x.c))) {
				q.push({ -dist[x.u], x.u });
			}
		}
	}
}

int main() {
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		ll a, b, c;
		cin >> a >> b >> c;
		--a; --b;
		g[a].push_back(edge(b, c));
		g[b].push_back(edge(a, c));
	}
	Dijkstra();
	for (int i = 1; i < n; ++i) {
		cout << dist[i] << '\n';
	}
	
	return 0;
}