#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <numeric>
using namespace std;

int n, m;
vector<vector<pair<int, int>>> graph;

int main()
{
	cin >> n >> m;
	graph.resize(n);
	for (int i = 0; i < m; ++i)
	{
		int a, b, t; cin >> a >> b >> t; --a; --b;
		graph[a].emplace_back(b, t);
		graph[b].emplace_back(a, t);
	}

	vector<int> dist(n, 1e9); dist[0] = 0;
	
	vector<int> ord(n); iota(ord.begin(), ord.end(), 0);
	while (next_permutation(ord.begin(), ord.end()))
	{
		if (ord[0] != 0) break;

		int mn = 1e9, mx = -1e9;
		for (int i = 1; i < n; ++i)
		{
			for (auto&j: graph[ord[i]])
				if (j.first == ord[i - 1])
				{
					mn = min(mn, j.second);
					mx = max(mx, j.second);
					break;
				}

			dist[i] = min(dist[i], mn + mx);
		}
	}

	for (int i = 1; i < n; ++i)
		cout << dist[i] << '\n';

	return 0;
}