#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>
#include <map>
#include <queue>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

#define int long long

typedef long long ll;
typedef long double ld;

const ll SZ = 3e5 + 100, INF = INT64_MAX / 2 - 2;

ll n, q;
vector<pair<ll, ll>> vec;
ll used[SZ], curit = 0;
ll lt[SZ], rt[SZ];

bool good(int i) {
	ll ltI = lt[i], rtI = rt[i];
	if (vec[ltI].first <= vec[i].first - vec[i].second) return 1;
	if (vec[rtI].first >= vec[i].first + vec[i].second) return 1;

	return 0;
}

void clr() {
	curit++;

	for (int i = 0; i < vec.size(); i++) {
		lt[i] = i - 1;
		rt[i] = i + 1;
	}
}

ll askBrute(ll l, ll r) {
	queue<int> q;

	for (int i = l; i <= r; i++) {
		if (good(i)) {
			q.push(i);
			used[i] = curit;
		}
	}

	ll cnt = 0;
	while (!q.empty()) {
		cnt++;
		int v = q.front();
		
		q.pop();

		rt[lt[v]] = rt[v];
		lt[rt[v]] = lt[v];

		if (rt[v] <= r && good(rt[v]) && used[rt[v]] != curit) {
			used[rt[v]] = curit;
			q.push(rt[v]);
		}

		if (lt[v] >= l && good(lt[v]) && used[lt[v]] != curit) {
			used[lt[v]] = curit;
			q.push(lt[v]);
		}
	}

	return cnt;
}

signed main() {
	fastInp;

	cin >> n >> q;
	vec.resize(n);
	for (int i = 0; i < n; i++) cin >> vec[i].first >> vec[i].second;

	vec.insert(vec.begin(), vec[0]);
	vec.push_back(vec.back());

	while (q--) {
		clr();
		ll l, r;
		cin >> l >> r;
		cout << askBrute(l, r) << "\n";
	}

	return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/