#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>
#include <map>
#include <queue>
#include <set>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

#define int long long

typedef long long ll;
typedef long double ld;

const ll SZ = 25, INF = 2e9 + 100;

ll n, m;
vector<vector<pair<ll, ll>>> gr;
ll ans[SZ];
ll par[SZ];

ll find(int v) {
	if (par[v] == v) return v;
	else return par[v] = find(par[v]);
}

void uni(int v, int u) {
	v = find(v);
	u = find(u);

	if (u != v) {
		if (gr[u].size() > gr[v].size()) swap(u, v);
		par[u] = v;
		for (auto c : gr[u]) gr[v].push_back(c);
		gr[u].clear();
		gr[u].shrink_to_fit();
	}
}

ll vis[SZ];
bool u2[SZ];
void dfs(int v, int par = -1) {
	u2[find(v)] = 1;
	for (auto to : gr[v]) {
		ll to1 = find(to.first);
		if (to1 == v) continue;
		if (!u2[to1]) {
			vis[to1] = v;
			dfs(to1, v);
		}
		else if (to1 != par) {
			ll vrt = v;
			while (vrt != to1) {
				ll v2 = find(vis[find(vrt)]);
				uni(vrt, to.first);
				vrt = v2;
			}

			return dfs(find(to.first), find(vis[find(to.first)]));
		}
	}
}

ll val[SZ];
vector<vector<pair<ll, ll>>> tree;

ll cur[SZ], prt[SZ], us[SZ];

void dfs2(int u) {
	queue<ll> q;

	for (int i = 0; i < n; i++) {
		us[i] = 0;
		cur[i] = INF;
	}
	q.push(u);
	us[u] = 1;
	while (!q.empty()) {
		ll v = q.front();
		q.pop();
		cur[v] = min(cur[v], val[v]);
		for (auto to : tree[v]) {
			if (to.first != prt[v]) {
				prt[to.first] = v;
				cur[to.first] = min(cur[to.first], min(cur[v], to.second));
			}
			if (!us[to.first]) {
				us[to.first] = 1;
				q.push(to.first);
			}
		}
	}

}

bool used[SZ];

signed main() {
	fastInp;

	cin >> n >> m;

	gr.resize(n);
	vector<tuple<ll, ll, ll>> e, us;
	vector<ll> prm;
	for (int i = 0; i < m; i++) {
		prm.push_back(i);
		ll u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		e.push_back({ u, v, t });
	}

	us = e;
	for (int i = 0; i < n; i++) ans[i] = INF;

	do {
		pair<ll, ll> nw = { -INF, INF };
		
		for (int i = 0; i < e.size(); i++) {
			e[i] = us[prm[i]];
		}
		ll pr = 0;
		for (int i = 0; i < e.size(); i++) {
			nw.first = max(nw.first, get<2>(e[i]));
			nw.second = min(nw.second, get<2>(e[i]));
			if (get<0>(e[i]) == pr) {
				ans[get<1>(e[i])] = min(ans[get<1>(e[i])], nw.first + nw.second);
				pr = get<1>(e[i]);
				continue;
			}
			if (get<1>(e[i]) == pr) {
				ans[get<0>(e[i])] = min(ans[get<0>(e[i])], nw.first + nw.second);
				pr = get<0>(e[i]);
				continue;
			}

			break;
		}
	} while (next_permutation(prm.begin(), prm.end()));

	for (int i = 1; i < n; i++) cout << ans[i] << "\n";

	return 0;
}

/*
4 4
1 2 2
3 2 0
2 4 3
4 3 1
*/