//#pragma GCC optimize("Ofast")

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cassert>
#include <queue>
#include <cstring>

//const int MAX_MEM = 1e9;
//char MEM[MAX_MEM];
//int m_pos = 0;
//
//void* operator new(size_t n) {
//    assert((m_pos += n) <= MAX_MEM);
//    return (void*) (MEM + m_pos - n);
//}
//
//void operator delete(void*) {}

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 3e5 + 4;
const int inf = 2e18;

int n, m;
set<int> g[SZ];
set<pair<int, int>> e;

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].insert(v);
        g[v].insert(u);
        e.insert({u, v});
    }
}

bool suka[SZ];

void paint(int u, int p = -1, bool z = true) {
    suka[u] = z;
    for (int v : g[u]) {
        if (v == p) continue;
        paint(v, u, !z);
    }
}

vector<int> G[SZ];
bool used[SZ];
int mt[SZ];

bool dfs(int u) {
    if (used[u]) return false;
    used[u] = true;

    for (int v : G[u]) {
        if (mt[v] == -1 || dfs(mt[v])) {
            mt[v] = u;
            return true;
        }
    }

    return false;
}

void solve() {
    paint(0);
    vector<pair<int, int>> e1;
    vector<pair<int, int>> e2;
    for (auto [u, v] : e) {
        if (suka[v]) {
            e1.emplace_back(u, v);
        } else {
            e2.emplace_back(u, v);
        }
    }

    for (int i = 0; i < e1.size(); ++i) {
        for (int j = 0; j < e2.size(); ++j) {
            if (e1[i].second == e2[i].first || e1[i].first == e2[i].second) G[i].push_back(j);
        }
    }

    memset(mt, 255, e2.size() * sizeof(int));
    for (int i = 0; i < e1.size(); ++i) {
        memset(used, 0, e1.size() * sizeof(bool));
        dfs(i);
    }

    for (int i = 0; i < e2.size(); ++i) {
        if (mt[i] == -1) {
            cout << "No\n";
            return;
        }
    }

    cout << "Yes\n";
    for (int i = 0; i < e1.size(); ++i) {
        cout << e1[i].first + 1 << " " << e1[i].second + 1 << " " << e2[mt[i]].first + 1 << " " << e2[mt[i]].second + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}