#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
#pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int MAXN = 1e4;
vector<int> X(MAXN), H(MAXN);
vector<vector<int>> G(MAXN);
vector<int> l_cnt(MAXN, 0), r_cnt(MAXN, 0);


void f(int i, int j) {
    if (j < i && X[j] > X[i] - H[i]) {
        G[j].push_back(i);
        ++l_cnt[i];
    }
    if (j > i && X[j] < X[i] + H[i]) {
        G[j].push_back(i);
        ++r_cnt[i];
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> X[i] >> H[i];
    }
    //
    vector<int> left(n, -1), right(n, -1);
    vector<int> stack;
    for (int i = 0; i < n; ++i) {
        while (!stack.empty() && H[stack.back()] <= H[i]) {
            right[stack.back()] = i;
            stack.pop_back();
        }
        stack.push_back(i);
    }
    //
    for (int i = n - 1; i >= 0; --i) {
        while (!stack.empty() && H[i] >= H[stack.back()]) {
            left[stack.back()] = i;
            stack.pop_back();
        }
        stack.push_back(i);
    }
    //
    for (int i = 0; i < n; ++i) {
        if (left[i] != -1) {
            f(i, left[i]);
            f(left[i], i);
        }
        if (right[i] != -1) {
            f(i, right[i]);
            f(right[i], i);
        }
    }
    //
    for (int _ = 0; _ < q; ++_) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        queue<int> Q;
        vector<int> used(n, 0);
        vector<int> l_cnt2(n, 0), r_cnt2(n, 0);
        for (int i = l; i <= r; ++i) {
            if (l_cnt[i] == 0 && X[i] - H[i] >= X[0]) {
                Q.push(i);
                used[i] = 1;
            } else if (r_cnt[i] == 0 && X[i] + H[i] <= X[n - 1]) {
                Q.push(i);
                used[i] = 1;
            }
        }
        //
        while (!Q.empty()) {
            int i = Q.front();
            Q.pop();
            for (int j : G[i]) {
                if (used[j] || j < l || r < j) {
                    continue;
                }
                if (i < j) {
                    ++l_cnt2[j];
                    if (l_cnt2[j] == l_cnt[j] && X[j] - H[j] >= X[0]) {
                        Q.push(j);
                        used[j] = 1;
                    }
                } else {
                    ++r_cnt2[j];
                    if (r_cnt2[j] == r_cnt[j] && X[j] + H[j] <= X[n - 1]) {
                        Q.push(j);
                        used[j] = 1;
                    }
                }
            }
        }
        cout << accumulate(used.begin(), used.end(), 0) << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}