#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
// #pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int MAXN = 3e5;
int T[MAXN];
vector<pair<int, int>> G[MAXN];
bitset<MAXN> used;
int up[MAXN];
int t_in[MAXN];
int timer = 0;
bitset<MAXN> flag;


void dfs(int v, int p_i = -1) {
    t_in[v] = up[v] = timer++;
    used[v] = true;
    for (auto [u, i] : G[v]) {
        if (!used[u]) {
            dfs(u, i);
            if (up[u] < t_in[v]) {
                flag[i] = true;
            }
            up[v] = min(up[v], up[u]);
        } else if (i != p_i){
            up[v] = min(up[v], t_in[u]);
        }
    }
}


vector<int> best(MAXN);


void dfs2(int v, int mn) {
    used[v] = true;
    best[v] = mn;
    for (auto [u, i] : G[v]) {
        if (!used[u]) {
            dfs2(u, min(mn, T[i]));
        }
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b >> T[i];
        --a;
        --b;
        G[a].emplace_back(b, i);
        G[b].emplace_back(a, i);
    }
    dfs(0);
    int mn = inf;
    for (int i = 0; i < m; ++i) {
        if (!flag[i]) {
            mn = min(mn, T[i]);
        }
    }
    dfs2(0, mn);
    //
    for (int v = 1; v < n; ++v) {
        cout << 1000000000 + best[v] << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}