#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

const long long inf = 1e15;

void dfs(int v, vector < vector < pair < int, long long > > >& g,
	vector < pair < long long, long long > >& f, int prev = -1) {
	for (auto to : g[v]) {
		if (to.first == prev) continue;
		f[to.first] = f[v];
		f[to.first].first = min(f[to.first].first, to.second);
		f[to.first].second = max(f[to.first].second, to.second);
		dfs(to.first, g, f, v);
	}
	return;
}

void uwu(int n, int m, vector < vector < pair < int, long long > > >& g) {
	vector < pair < long long, long long > > f(n);
	f[0] = { inf, 0 };
	dfs(0, g, f);
	for (int i = 1; i < n; i++) cout << f[i].first + f[i].second << "\n";
	return;
}

map < pair < int, int >, bool > used;
void owo(int v, vector < vector < pair < int, long long > > >& g, vector < long long >& dist, long long ma = 0, long long mi = inf) {
	dist[v] = min(dist[v], ma + mi);
	for (auto to : g[v]) {
		if (!used[{to.first, v}] && dist[to.first] > max(ma, to.second) + min(mi, to.second)) {
			used[{to.first, v}] = used[{v, to.first}] = true;
			owo(to.first, g, dist, max(ma, to.second), min(mi, to.second));
			used[{to.first, v}] = used[{v, to.first}] = false;
		}
	}
	return;
}

int main()
{
	int n, m;
	cin >> n >> m;

	vector < vector < pair < int, long long > > > g(n);
	int v, u;
	long long t;
	for (int i = 0; i < m; i++) {
		cin >> v >> u >> t;
		v--; u--;
		g[v].push_back({ u, t });
		g[u].push_back({ v, t });
	}

	if (m == n - 1) {
		uwu(n, m, g);
		return 0;
	}
	if (n <= 20 && m <= 20) {
//		used.max_load_factor(0.25);
		vector < long long > dist(n, inf);
		owo(0, g, dist);
		for (int i = 1; i < n; i++) cout << dist[i] << "\n";
		return 0;
	}

	cout << ".";
}