#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>

#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef vector <pii> vii;
typedef vector <long long> vll;

const long long INFll = 2e18;
const int N = 6e5;

vi g[N];
vi t[N];
int ans[N];

set <pii> br;

int up[N], d[N];
bool was[N];

void find_bridges(int v, int p) {
    d[v] = d[p] + 1;
    was[v] = true;
    up[v] = d[v];
    int cnt = 0;

    for (int i = 0; i < g[v].size(); i++) {
        int u = g[v][i];
        if (u == p) {
            cnt++; continue;
        }
        if (was[u]) {
            up[v] = min(up[v], d[u]);
        } else {
            find_bridges(u, v);
            up[v] = min(up[u], up[v]);
        }
    }

    //cout << "v: " << v << " " << d[v] << " " << up[v] << endl;

    if (up[v] == d[v] && cnt == 1 && p != 0)
        br.insert(mp(p, v));
}

int clr[N];

void paint(int v, int c) {
    was[v] = true;
    clr[v] = c;
    for (int i : g[v]) {
        if (!was[i] && br.find(mp(v, i)) == br.end() && br.find(mp(i, v)) == br.end())
            paint(i, c);
    }
}

vi g2[N];
vi t2[N];

void dfs2(int v, int p, int mn) {
    ans[v] = min(ans[v], mn);
    for (int i = 0; i < g2[v].size(); i++) {
        int u = g2[v][i], c = t2[v][i];
        if (u == p) continue;
        dfs2(u, v, min(ans[v], c));
    }
}

void solve() {
    int n, m; cin >> n >> m;
    vector <pair <pii, int>> e;
    for (int i = 0; i < m; i++) {
        int x, y, tt; cin >> x >> y >> tt;
        g[x].pb(y); t[x].pb(tt);
        g[y].pb(x); t[y].pb(tt);
        e.pb(mp(x, y), tt);
    }

    fill(was, was + N, false);
    find_bridges(1, 0);

    int cc = 0;
    fill(was, was + N, false);
    for (int i = 1; i <= n; i++) {
        if (!was[i]) {
            cc++;
            paint(i, cc);
        }
    }

    fill(ans, ans + N, 2e9);
    for (auto p : e) {
        if (clr[p.fi.fi] == clr[p.fi.se]) {
            ans[clr[p.fi.fi]] = min(ans[clr[p.fi.fi]], p.se);
        } else {
            g2[clr[p.fi.fi]].pb(clr[p.fi.se]);
            t2[clr[p.fi.fi]].pb(p.se);
            g2[clr[p.fi.se]].pb(clr[p.fi.se]);
            t2[clr[p.fi.se]].pb(p.se);
        }
    }

    dfs2(1, 0, 2e9);

    //for (auto p : br)
    //    cout << p.fi << ' ' << p.se << endl;


    for (int i = 2; i <= n; i++)
        cout << 1000000000 + ans[clr[i]] << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
