#include <map>
#include <set>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const long long INF = 2e18;

long long dp1[300001][26]; //max
int par[300001][26];

long long val(int x) {
  long long ans = (x % 2 ? 5 : 1);
  x /= 2;
  while (x--)
    ans *= 10;
  return ans;
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif


  int t;
  cin >> t;
  while (t--) {
    string s;
    cin >> s;
    int n = s.size();
    fill(dp1[n], dp1[n] + 26, -INF);
    dp1[n][0] = 0;
    for (int i = n - 1; i >= 0; --i) {
      fill(dp1[i], dp1[i] + 26, -INF);
      if (s[i] == '?') {
        long long x = 1;
        for (int k = 0; k < 26; ++k) {
          for (int j = 0; j < 26; ++j) {
            if (j > k) {
              if (dp1[i][j] < dp1[i + 1][j] - x) {
                par[i][j] = k;
                dp1[i][j] = dp1[i + 1][j] - x;
              }
            } else {
              if (dp1[i][k] < dp1[i + 1][j] + x) {
                par[i][k] = -j - 1;
                dp1[i][k] = dp1[i + 1][j] + x;
              }
            }
          }
          if (k % 2)
            x *= 2;
          else
            x *= 5;
        }
      } else {
        int k = s[i] - 'A';
        long long x = val(k);
        for (int j = 0; j < 26; ++j) {
          if (j > k) {
            if (dp1[i][j] < dp1[i + 1][j] - x) {
              par[i][j] = k;
              dp1[i][j] = dp1[i + 1][j] - x;
            }
          } else {
            if (dp1[i][k] < dp1[i + 1][j] + x) {
              par[i][k] = -j - 1;
              dp1[i][k] = dp1[i + 1][j] + x;
            }
          }
        }
      }
    }
    int mx_id = 0;
    for (int i = 1; i < 26; ++i) {
      if (dp1[0][i] > dp1[0][mx_id])
        mx_id = i;
    }
    string ans;
    int cur = mx_id;
    for (int i = 0; i < n; ++i) {
      int tt = par[i][cur];
      if (tt >= 0) {
        ans += char('A' + tt);
      } else {
        ans += char('A' + cur);
        cur = -tt - 1;
      }
    }
    cout << dp1[0][mx_id] << '\n';
    cout << ans << '\n';
  }
  return 0;
}
