#include <map>
#include <set>
#include <deque>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 500500;
const int K = 707;

int x[MAXN];
int h[MAXN];

int rest[MAXN];
int rest_st, rest_end;
pair<int, int> history[MAXN];
int history_sz;

struct kek {
  int ll, rr;
  kek (int _ll, int _rr) {
    ll = _ll;
    rr = _rr;
    rest_st = rest_end = MAXN / 2;
    history_sz = 0;
  }
  void push_back() {
    history[history_sz] = make_pair(2, rr);
    ++history_sz;
    rest[rest_end] = rr;
    ++rest_end;
    ++rr;
    while (rest_end > rest_st) {
      if (x[rest[rest_end - 1]] + h[rest[rest_end - 1]] <= x[rr]) {
        history[history_sz] = make_pair(-2, rest[rest_end - 1]);
        ++history_sz;
        --rest_end;
      } else if (x[rest[rest_end - 1]] - h[rest[rest_end - 1]] >= (rest_end == rest_st + 1 ? x[ll - 1] : x[rest[rest_end - 2]])) {
        history[history_sz] = make_pair(-2, rest[rest_end - 1]);
        ++history_sz;
        --rest_end;
      } else {
        break;
      }
    }
  }
  void push_front() {
    --ll;
    history[history_sz] = make_pair(1, ll);
    ++history_sz;
    --rest_st;
    rest[rest_st] = ll;
    while (rest_end > rest_st) {
      if (x[rest[rest_st]] - h[rest[rest_st]] >= x[ll - 1]) {
        history[history_sz] = make_pair(-1, rest[rest_st]);
        ++history_sz;
        ++rest_st;
      } else if (x[rest[rest_st]] + h[rest[rest_st]] <= (rest_end == rest_st + 1 ? x[rr] : x[rest[rest_st + 1]])) {
        history[history_sz] = make_pair(-1, rest[rest_st]);
        ++history_sz;
        ++rest_st;
      } else {
        break;
      }
    }
  }
  int get() {
    return rr - ll - rest_end + rest_st;
  }
  void rollback(int sz = 0) {
    while (history_sz > sz) {
      --history_sz;
      if (history[history_sz].first == 1) {
        ++rest_st;
        ++ll;
      } else if (history[history_sz].first == -1) {
        --rest_st;
        rest[rest_st] = history[history_sz].second;
      } else if (history[history_sz].first == 2) {
        --rest_end;
        --rr;
      } else {
        rest[rest_end] = history[history_sz].second;
        ++rest_end;
      }
    }
  }
};

int n, q;
pair<int, int> queries[MAXN];
int ans1[MAXN];
vector<pair<int, pair<int, int>>> buckets[(MAXN + K - 1) / K];

void solve_smart() {
  x[0] = x[1];
  x[n + 1] = x[n];
  for (int i = 0; i < q; ++i) {
    int l = queries[i].first;
    int r = queries[i].second;
    if (l / K == r / K) {
      kek lol(l, l);
      for (int j = l; j <= r; ++j)
        lol.push_back();
      ans1[i] = lol.get();
    } else {
      buckets[l / K].emplace_back(r, make_pair(l, i));
    }
  }
  for (int i = 0; i * K <= n; ++i) {
    sort(buckets[i].begin(), buckets[i].end());
    kek lol((i + 1) * K, (i + 1) * K);
    for (auto query : buckets[i]) {
      while (lol.rr <= query.first)
        lol.push_back();
      int tmp = history_sz;
      while (lol.ll > query.second.first)
        lol.push_front();
      ans1[query.second.second] = lol.get();
      lol.rollback(tmp);
    }
    buckets[i].clear();
  }
}
/*
int ans2[MAXN];
const int MAXM = 5000;
bool dp[MAXM][MAXM];
int dp2[MAXM][MAXM];
int ll[MAXM];
int rr[MAXM];

void solve_dumb() {
  for (int i = 0; i < n; ++i)
    fill(dp[i], dp[i] + n, false);
  for (int i = 0; i < n; ++i) {
    ll[i] = upper_bound(x + 1, x + n + 1, x[i + 1] - h[i + 1]) - x - 1;
    rr[i] = lower_bound(x + 1, x + n + 1, x[i + 1] + h[i + 1]) - x - 2;
  }
  for (int i = 0; i < n; ++i) {
    if (x[i + 1] - h[i + 1] < x[1])
      ll[i] = -1;
    if (x[i + 1] + h[i + 1] > x[n])
      rr[i] = n;
  }
  for (int i = n - 1; i >= 0; --i) {
    dp[i][i] = (ll[i] == i || rr[i] == i);
    for (int j = i + 1; j < n; ++j) {
      if (dp[i + 1][j] && j >= rr[i]) {
        dp[i][j] = true;
        continue;
      }
      if (dp[i][j - 1] && i <= ll[j]) {
        dp[i][j] = true;
        continue;
      }
      for (int k = i + 1; k < j; ++k) {
        if (dp[i][k - 1] && dp[k + 1][j] && (j >= rr[k] || i <= ll[k])) {
          dp[i][j] = true;
          break;
        }
      }
    }
  }
  for (int i = n - 1; i >= 0; --i) {
    for (int j = i; j < n; ++j) {
      if (dp[i][j]) {
        dp2[i][j] = j - i + 1;
        continue;
      }
      dp2[i][j] = 0;
      for (int k = j; k >= i; --k) {
        if ((k == j || dp[k + 1][j]))
          dp2[i][j] = max(dp2[i][j], (k == i ? 0 : dp2[i][k - 1]) + j - k);
      }
    }
  }
  for (int i = 0; i < q; ++i)
    ans2[i] = dp2[queries[i].first - 1][queries[i].second - 1];
}

void gen() {
  n = rand() % 7 + 2;
  x[1] = 0;
  for (int i = 2; i <= n; ++i)
    x[i] = rand() % 6 + x[i - 1] + 1;
  for (int i = 1; i <= n; ++i)
    h[i] = rand() % 8 + 1;
  q = n * (n + 1) / 2;
  for (int i = 0; i < n; ++i) {
    for (int j = i; j < n; ++j)
      queries[i * (2 * n - i + 1) / 2 + j - i] = make_pair(i + 1, j + 1);
  }
}*/

//#define STRESS

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

#ifdef STRESS
  srand(time(0));
  for (int _ = 0; _ < 100000; ++_) {
    gen();
    solve_smart();
    solve_dumb();
    bool ok = true;
    for (int i = 0; i < q; ++i) {
      if (ans1[i] != ans2[i])
        ok = false;
    }
    if (!ok) {
      cerr << "BUG!!\n";
      cerr << n << ' ' << q << '\n';
      for (int i = 1; i <= n; ++i)
        cerr << x[i] << ' ' << h[i] << '\n';
      for (int i = 0; i < q; ++i)
        cerr << queries[i].first << ' ' << queries[i].second << '\n';
      cerr << '\n';
      cerr << "wrong: ";
      for (int i = 0; i < q; ++i)
        cerr << ans1[i] << ' ';
      cerr << '\n';
      cerr << "right: ";
      for (int i = 0; i < q; ++i)
        cerr << ans2[i] << ' ';
      cerr << '\n';
      cerr << '\n';
    }
  }
#else
  cin >> n >> q;
  for (int i = 1; i <= n; ++i)
    cin >> x[i] >> h[i];
  for (int i = 0; i < q; ++i)
    cin >> queries[i].first >> queries[i].second;
  solve_smart();
  for (int i = 0; i < q; ++i)
    cout << ans1[i] << '\n';
#endif
  return 0;
}
