#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
using namespace std;
#define int long long

void solve() {
	int n, m;
	cin >> n >> m;
	vector <pair <int, int>> eg(m);
	for (int i = 0; i < m; ++i) {
		cin >> eg[i].first >> eg[i].second;
		--eg[i].first;
		--eg[i].second;
	}
	vector <vector <int>> egIn(n), egOut(n);
	for (int i = 0; i < m; ++i) {
		egIn[eg[i].first].push_back(i);
		egOut[eg[i].second].push_back(i);
	}
	vector <int> balance(n);
	for (int i = 0; i < n; ++i) {
		if ((egIn[i].size() + egOut[i].size()) % 2 == 1) {
			balance[i] = 1;
		}
	}
	vector <pair <int, int>> tuples;
	vector <int> used(m);
	for (int i = 0; i < n; ++i) {
		for (int u : egIn[i]) {
			for (int v : egOut[i]) {
				int d1 = eg[u].second;
				int d2 = eg[v].first;
				if (d1 != d2 && !used[u] && !used[v] && balance[d1] == 1 && balance[d2] == 1) {
					tuples.push_back({ u, v });
					used[u] = true;
					used[v] = true;
					balance[d1] ^= 1;
					balance[d2] ^= 1;
				}
				if (d1 == d2 && !used[u] && !used[v] && balance[d1] == 0 && balance[d2] == 0) {
					tuples.push_back({ u, v });
					used[u] = true;
					used[v] = true;
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int u : egIn[i]) {
			for (int v : egOut[i]) {
				if (!used[u] && !used[v]) {
					tuples.push_back({ u, v });
					used[u] = true;
					used[v] = true;
				}
			}
		}
	}
	if (tuples.size() == m / 2) {
		cout << "Yes\n";
		for (auto vt : tuples) {
			cout << eg[vt.first].first + 1 << " " << eg[vt.first].second + 1 << " " << eg[vt.second].first + 1 << " " << eg[vt.second].second + 1 << "\n";
		}
	}
	else {
		cout << "No\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}