#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>

#pragma warning(disable : 4996)

using itn = int;

using namespace std;

struct edge {
	int u, v;
	long long t;
	int ind;
	edge(int _u = 0, int _v = 0, long long _t = 0, int i = 0) {
		u = _u;
		v = _v;
		t = _t;
		ind = i;
	}
};

struct dsu {
	vector <int> p;
	vector <vector <int>> in_u;
	dsu(int n = 0) {
		p.resize(n);
		in_u.resize(n);
		for (int i = 0; i < n; ++i) {
			p[i] = i;
			in_u[i] = {i};
		}
	}
	void upd(int n) {
		p.resize(n);
		in_u.resize(n);
		for (int i = 0; i < n; ++i) {
			p[i] = i;
			in_u[i] = { i };
		}
	}
	int get(int u) {
		return p[u] = (p[u] == u ? u : get(p[u]));
	}
	void merge(int u, int v) {
		u = get(u);
		v = get(v);
		if (in_u[u].size() > in_u[v].size()) {
			swap(u, v);
		}
		p[v] = u;
		for (auto el : in_u[u])
			in_u[v].push_back(el);
	}
};

int n, m;

bool cmp(edge a, edge b) {
	return a.t < b.t;
}

vector <edge> edges;

vector <long long> minimal;

vector <vector <edge>> graph;

bool used[300000];

void dfs(int u, long long mint, long long maxt) {
	if (u != 0)
		minimal[u - 1] = min(minimal[u - 1], mint + maxt);
	for (auto ed : graph[u]) {
		if (!used[ed.ind]) {
			used[ed.ind] = true;
			dfs(ed.v, min(mint, ed.t), max(maxt, ed.t));
			used[ed.ind] = false;
		}
	}
}

void print() {
	for (int i = 0; i < n - 1; ++i)
		cout << minimal[i] << "\n";
}

int main() {
	cin >> n >> m;
	int u, v, ti;
	for (int i = 0; i < m; ++i) {
		cin >> u >> v >> ti;
		--u;
		--v;
		edges.emplace_back(u, v, ti, i);
	}
	graph.resize(n);
	for (int i = 0; i < m; ++i) {
		graph[edges[i].u].push_back(edges[i]);
		graph[edges[i].v].emplace_back(edges[i].v, edges[i].u, edges[i].t, edges[i].ind);
	}
	minimal.assign(n - 1, 2e9 + 2);
	dfs(0, 2000000012, -1);
	print();
}