#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
typedef long long ll;
typedef pair<int, int> pii;

int p[300000], rnk[300000];
struct DSU {
    int n;

    DSU(int n) : n(n) {
        memset(p, 255, sizeof(p));
    }

    int get(int u) {
        if (p[u] == -1) {
            return u;
        }
        return p[u] = get(p[u]);
    }

    bool check(int u, int v) {
        return get(u) == get(v);
    }

    void merge(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) {
            return;
        }
        if (rnk[u] < rnk[v]) {
            swap(u, v);
        }
        p[v] = u;
        if (rnk[u] == rnk[v]) {
            rnk[u]++;
        }
    }
};

struct edge {
    int u, v, w;

    edge() = default;
    edge(int u, int v, int w) : u(u), v(v), w(w) {}

    bool operator<(const edge &b) const {
        return w > b.w;
    }
};

vector<edge> edges;
vector<pii> g[300000];
int res[300000];

void dfs(int u, int p = -1, int mn = 2e9, int mx = -2e9) {
    res[u] = mn + mx;
    for (auto &v : g[u]) {
        if (v.first == p) {
            continue;
        }
        dfs(v.first, u, min(mn, v.second), max(mx, v.second));
    }
}

signed main() {
    fastream;
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        edges.emplace_back(u, v, w);
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    if (m == n - 1) {
        dfs(0);
        for (int i = 1; i < n; i++) {
            cout << res[i] << endl;
        }
    } else {
        sort(all(edges));
        DSU dsu(n);
        for (int i = 0; i < n; i++) {
            g[i].clear();
        }
        for (auto &e : edges) {
            if (!dsu.check(e.u, e.v)) {
                dsu.merge(e.u, e.v);
                g[e.u].emplace_back(e.v, e.w);
                g[e.v].emplace_back(e.u, e.w);
            }
        }
        dfs(0);
        for (int i = 1; i < n; i++) {
            cout << res[i] << endl;
        }
    }
}