#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
#include<set>

using namespace std;

const long long INF = 4e18;

struct tree {
	int x, h;
	tree(int _x = 0, int _h = 0) {
		x = _x;
		h = _h;
	}
};

bool can_drop_left(tree a, tree b) {
	if (a.x + b.h <= b.x)
		return true;
	return false;
}

bool can_drop_right(tree a, tree b) {
	if (a.x + a.h <= b.x)
		return true;
	return false;
}

int main() {
	int n, q;
	cin >> n >> q;
	vector<tree> trees(n);
	for (int i = 0; i < n; ++i) {
		int x, h;
		cin >> x >> h;
		trees[i] = { x, h };
	}
	for (int i = 0; i < q; ++i) {
		int l, r;
		cin >> l >> r;
		--l; --r;
		vector<tree> our_trees;
		auto left = 0;
		if (l != 0)
			left = l - 1;
		auto right = n - 1;
		if (r != n - 1)
			right = r + 1;
		for (int i = l; i <= r; ++i) {
			if (our_trees.empty()) {
				if (can_drop_left(trees[left], trees[i])) {
					continue;
				}
				if (can_drop_right(trees[i], trees[min(right, i + 1)])) {
					continue;
				}
				our_trees.push_back(trees[i]);
			}
			else {
				if (can_drop_left(our_trees.back(), trees[i])) {
					while (!our_trees.empty() && can_drop_right(our_trees.back(), trees[min(right, i + 1)])) {
						our_trees.pop_back();
					}
				}
				else {
					if (can_drop_right(trees[i], trees[min(right, i + 1)])) {
						while (!our_trees.empty() && can_drop_right(our_trees.back(), trees[min(right, i + 1)])) {
							our_trees.pop_back();
						}
					}
					else {
						our_trees.push_back(trees[i]);
					}
				}
			}
		}
		cout << r - l + 1 - our_trees.size() << '\n';
	}

}

//5 6
//1 2
//2 1 
//1 5
//2 3
//2 4
//4 2

//4 4
//2 1
//2 3
//2 4
//4 2

//4 4
//1 2
//2 1
//3 4
//4 3