#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <memory.h>
#include <cmath>
#include <string>
#include <queue>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef set<int> si;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<ll> vll;

struct Tree {
	int x, h;
};
const int N = 5010;
si ml[N];
si mr[N];
si cml[N];
si cmr[N];

vi wml[N];
vi wmr[N];
bool used[N];

const int inf = 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector<Tree> t;
	rep(i, n) {
		int x, h;
		cin >> x >> h;
		t.pb({ x, h });
	}
	rep(i, n) {
		if (t[i].x - t[i].h < t[0].x) {
			ml[i].insert(inf);
		}
		if (t[i].x + t[i].h > t[n - 1].x) {
			mr[i].insert(inf);
		}
		for (int j = 0; j < i; j++) {
			if (t[i].x - t[i].h < t[j].x) {
				ml[i].insert(j);
				wml[j].pb(i);
			}
		}
		for (int j = i + 1; j < n; j++) {
			if (t[i].x + t[i].h > t[j].x) {
				mr[i].insert(j);
				wmr[j].pb(i);
			}
		}
	}

	for (; q; q--) {
		int l, r;
		cin >> l >> r;

		l--; r--;
		memset(used, 0, sizeof(used));
		priority_queue<pii> cur;
		for (int i = l; i <= r; i++) {
			cur.push({ -min(sz(ml[i]), sz(mr[i])), i });
			cml[i] = ml[i];
			cmr[i] = mr[i];
		}
		int ans = 0;
		while (cur.size()) {
			if (cur.top().first != 0) break;
			int v = cur.top().second;
			cur.pop();
			if (used[v]) continue;
			ans++;
			used[v] = true;
			for (int u : wml[v]) {
				if (u >= l && u <= r) {
					if (used[u]) continue;
					
					cml[u].erase(v);

					cur.push({ -min(sz(cml[u]), sz(cmr[u])), u });
				}
			}

			for (int u : wmr[v]) {
				if (u >= l && u <= r) {
					if (used[u]) continue;
					
					cmr[u].erase(v);

					cur.push({ -min(sz(cml[u]), sz(cmr[u])), u });
				}
			}
		}
		cout << ans << "\n";
	}

	return 0;
}