#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <memory.h>
#include <cmath>
#include <string>
#include <queue>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef set<int> si;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<ll> vll;

const int N = 300300;
vpii g[N];


int min_on_path[N];
int max_on_path[N];

const int inf = 2e9;

void solve_tree(int v, int p) {
	if(p == -1) min_on_path[v] = inf;
	for (auto e : g[v]) {
		int u = e.first;
		int c = e.second;
		if (u == p) continue;
		min_on_path[u] = min(min_on_path[v], c);
		max_on_path[u] = max(max_on_path[v], c);
		solve_tree(u, v);
	}
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	rep(i, m) {
		int u, v, t; 
		cin >> u >> v >> t;
		g[u].pb({ v, t });
		g[v].pb({ u, t });
	}

	if (m == n - 1) {
		solve_tree(1, -1);
		for (int v = 2; v <= n; v++) {
			cout << min_on_path[v] + max_on_path[v] << "\n";
		}
	}

	return 0;
}