#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <memory.h>
#include <cmath>
#include <string>
#include <assert.h>
#include <queue>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef set<int> si;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<ll> vll;



const int N = 300300;
struct Edge {
	int from;
	int to;
	int w;
	int num;
};
int n, m;
vector<Edge>edges;
vector<Edge> g[N];


const int inf = 2e9 + 100;

namespace First {
	int min_on_path[N];
	int max_on_path[N];
	void solve_tree(int v, int p) {
		if (p == -1) min_on_path[v] = inf;
		for (auto e : g[v]) {
			int u = e.to;
			int c = e.w;
			if (u == p) continue;
			min_on_path[u] = min(min_on_path[v], c);
			max_on_path[u] = max(max_on_path[v], c);
			solve_tree(u, v);
		}
	}
	void solve() {
		solve_tree(1, -1);
		for (int v = 2; v <= n; v++) {
			cout << min_on_path[v] + max_on_path[v] << "\n";
		}
	}
}


namespace Forth_Fifth {
	bool dp[30][1 << 21];
	int can_get[1 << 21];
	int ans[30];
	pii q[21 * (1 << 21)];
	void solve() {
		int qh = 0;
		int qe = 0;
		q[qe++] = { 1, 0 };
		dp[1][0] = true;
		while (qh < qe) {
			int v = q[qh].first;
			int mask = q[qh].second;
			qh++;
			dp[v][mask] = true;
			for (auto e : g[v]) {
				if (!(mask & (1 << e.num))) {
					int nmask = mask | (1 << e.num);
					if (!dp[e.to][nmask]) {
						dp[e.to][nmask] = true;
						q[qe++] = { e.to, nmask };
					}
				}
			}
		}
		for (int mask = 0; mask < (1 << m); mask++) {
			int mn = inf;
			int mx = 0;
			for (int i = 0; i < m; i++) {
				if (mask & (1 << i)) {
					mn = min(mn, edges[i].w);
					mx = max(mx, edges[i].w);
				}
			}
			can_get[mask] = mn + mx;
		}

		for (int v = 2; v <= n; v++) {
			ans[v] = inf;
			for (int mask = 0; mask < (1 << m); mask++) {
				if (dp[v][mask]) {
					ans[v] = min(ans[v], can_get[mask]);
				}
			}
		}
		for (int v = 2; v <= n; v++) {
			cout << ans[v] << "\n";
		}
	}
}

namespace Second {

	int dsu[N];
	int sz[N];

	void init() {
		for (int v = 1; v <= n; v++) {
			dsu[v] = v;
			sz[v] = 1;
		}
	}

	int find(int x) {
		if (x == dsu[x]) return x;
		return dsu[x] = find(dsu[x]);
	}

	void merge(int a, int b) {
		a = find(a);
		b = find(b);
		if (sz[a] < sz[b]) {
			swap(a, b);
		}
		sz[a] += sz[b];
		dsu[b] = a;
	}

	bool same(int a, int b) {
		return find(a) == find(b);
	}


	void solve() {
		sort(all(edges), [&](Edge e1, Edge e2) {return e1.w < e2.w;});
		vi L(n + 1, -1);
		vi R(n + 1, m - 1);
		for (int round = 0; round < 20; round++) {
			vector<vi>check(m);
			for (int v = 1; v <= n; v++) {
				int M = (L[v] + R[v]) / 2;
				check[M].pb(v);
			}
			init();

			for (int i = 0; i < m; i++) {
				int a = edges[i].from;
				int b = edges[i].to;
				merge(a, b);
				for (int v : check[i]) {
					if (same(1, v)) {
						R[v] = i;
					}
					else {
						L[v] = i;
					}
				}
			}
		}


		for (int v = 2; v <= n; v++) {
			cout << edges[R[v]].w << "\n";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	bool all_zero = true;
	rep(i, m) {
		int u, v, t;
		cin >> u >> v >> t;
		if ((v == 1 || u == 1) && t != 0) {
			all_zero = false;
		}
		edges.pb({ u, v, t, i });
		g[u].pb({ u, v, t, i });
		g[v].pb({ v, u, t, i });
	}

	if (all_zero) {
		Second::solve();
		return 0;
	}

	if (m == n - 1) {
		First::solve();
		return 0;
	}

	if (n <= 20 && m <= 20) {
		Forth_Fifth::solve();
		return 0;
	}

	

	return 0;
}