#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <random>

using namespace std;

mt19937 rng(10);

const int MOD = 65521;
const int BASE = 3; 

int add(int a, int b) {
	if (a + b < MOD) {
		return a + b;
	}
	return a + b - MOD;
}

int sub(int a, int b) {
	if (a >= b) {
		return a - b;
	}
	return a - b - MOD;
}

int mul(int a, int b) {
	return 1LL * a * b % MOD;
}

string encode(string s) {
	string ret;
	int n = (int)s.size();
	ret = s;
	int h = 0;
	for (auto t : s) {
		h = mul(h, BASE);
		h = add(h, t - '0');
	}
	cerr << h << endl;
	int c = 0;
	for (int i = 0; i < 16; i++) {
		c += ((h >> i) & 1);
		ret.push_back('0' + ((h >> i) & 1));
	}
	ret.push_back('0' + (c & 1));
	return ret;
}

string decode(string s) {
	int n = (int)s.size() - 17;
	{
		int c = 0;
		for (int i = n; i < n + 16; i++) {
			c += (s[i] - '0');
		}
		cerr << (c & 1) << ' ' << s[n + 16] << endl;
		if ((c & 1) != s[n + 16] - '0') {
			return s.substr(0, n);
		}
	}
	int h = 0;
	for (int i = n; i < n + 16; i++) {
		h += (s[i] - '0') * (1 << (i - n));
	}
	int ch = 0;
	for (int i = 0; i < n; i++) {
		ch = mul(ch, BASE);
		ch = add(ch, s[i] - '0');
	}
	cerr << h << ' ' << ch << endl;
	string ans = s.substr(0, n);
	if (h == ch) {
		return ans;
		exit(0);
	}
	int cp = 1;
	for (int i = n - 1; i >= 0; i--) {
		ch = sub(ch, mul(cp, s[i] - '0'));
		int nch = add(ch, mul(cp, 1 - (s[i] - '0')));
		if (nch == h) {
			ans[i] = '0' + '1' - ans[i];
			return ans;
		}
		ch = add(ch, mul(cp, s[i] - '0'));
		cp = mul(cp, BASE);
	}
	assert(false);
}

void run() {
	int n = 10;
	string s(n, '$');
	for (int i = 0; i < n; i++) {
		s[i] = '0' + (rng() & 1);
	}
	cerr << s << endl;
	string code = encode(s);
	cerr << code << endl;
	int i = rng() % (int)code.size();
	code[i] = '0' + '1' - code[i];
	cerr << code << endl;
	string res = decode(code);
	assert(res == s);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	string s;
	cin >> s;
	if (t == 1) {
		s = encode(s);
	} else {
		s = decode(s);
	}
	cout << s << endl;

	// while (true) {
	// 	run();
	// }
}