#include <bits/stdc++.h>

class bigInt {
private:
    std::vector<int> num;
    bool negative;
public:
    explicit bigInt(std::vector<int> num) : num(std::move(num)), negative(false) {}

    bigInt(std::vector<int> num, const bool &negative) : num(std::move(num)), negative(negative) {}

    bigInt(const std::string &s) {
        int ind = 0;
        if (s[0] == '-') negative = true, ind++;
        else negative = false;
        for (int i = s.size() - 1; i >= ind; i--) num.push_back(s[i] - '0');
    }

    std::vector<int> getNum() const {
        return num;
    }

    bigInt operator+(const bigInt &sec) const;

    bigInt operator-(const bigInt &sec) const;

    bigInt operator-() const {
        bigInt res = *this;
        res.negative ^= 1;
        return res;
    }

    std::string to_string() const {
        std::string res;
        for (auto &i : num) res += i + '0';

        while (res.size() > 1 && res.back() == '0') res.pop_back();
        std::reverse(res.begin(), res.end());
        if (res != "0" && negative) res = "-" + res;
        return res;
    }
};

bigInt bigInt::operator-(const bigInt &sec) const {
    return bigInt(sec);
}

bigInt bigInt::operator+(const bigInt &sec) const {
    bool neg = (negative && sec.negative);
    if (negative && !sec.negative) {
        return sec - *this;
    }
    if (!negative && sec.negative) {
        return *this - sec;
    }

    std::vector<int> ans = sec.getNum();
    ans.resize(std::max(sec.num.size() + 1, num.size() + 1));
    int shift = 0;
    for (int i = 0; i < ans.size(); i++) {
        int first = (i < num.size() ? num[i] : 0);
        int second = (i < sec.num.size() ? sec.num[i] : 0);
        int val = (first + second + shift);
        ans[i] = val % 10;
        shift = val / 10;
    }

    return bigInt(ans, neg);
}

int main() {
    std::string f, s;
    std::cin >> f >> s;
    bigInt f1(f), s1(s);
    std::cout << (f1 + s1).to_string() << '\n';
}
