#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll alp = 26;

#define vec vector
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

struct Kar {
	Kar* p, * link;
	Kar* next[alp], * go[alp];
	ll sym, ans, fl;
	Kar() {
		for (ll i = 0; i < alp; ++i) {
			next[i] = go[i] = NULL;
		}
		p = link = NULL;
		sym = -1;
		ans = -1;
		fl = 0;
	}
};

Kar* root = new Kar();

Kar* go(Kar* v, ll c);

Kar* get_link(Kar* v) {
	if (!v->link) {
		if (!v->p || !v->p->p)
			v->link = root;
		else
			v->link = go(get_link(v->p), v->sym);
	}
	return v->link;
}

Kar* go(Kar* v, ll c) {
	if (!v->go[c]) {
		if (v->next[c])
			v->go[c] = v->next[c];
		else
			v->go[c] = !v->p ? root : go(get_link(v), c);
	}
	return v->go[c];
}

ll get_ans(Kar* v) {
	if (!v->p)
		return v->ans = 0;
	if (v->ans == -1)
		v->ans = v->fl + get_ans(get_link(v));
	return v->ans;
}

void add_str(Kar* v, string& s) {
	for (auto t : s) {
		t -= 'a';
		if (!v->next[t]) {
			v->next[t] = new Kar();
			v->next[t]->p = v;
			v->next[t]->sym = t;
		}
		v = v->next[t];
	}
	v->fl++;
}

void run() {
	string s(5e5, 'a');
	for (ll i = 0; i < s.size(); ++i) {
		s[i] = char(i%26 + 'a');
	}
	add_str(root, s);
	reverse(all(s));
	add_str(root, s);
	ll a, b;
	cin >> a >> b;
	cout << a + b;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}