#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

#define int long long

int p = 7123, mod = 228228227;

void sol1() {
    string s;
    cin >> s;
    assert(s.size() < 1000);
    if (s.size() <= 1000) {
        cout << s << s << s;
        return;
    }
    int H = 0;
    for (char i : s) {
        H = (H * p + i) % mod;
    }
    string num;
    H %= (1<<17);
    cout << H << endl;
    for (int i = 0; i < 17; ++i) {
        num += char('0' + (H%2));
        H /= 2;
    }
    cout << s + num;
}


const int mxn = 1e5 + 100;
int P[mxn];

int seg(int l, int r, vector<int> &H) {
    if (l > r) return 0;
    return ((H[r] - H[l-1] * P[r-l])%mod + mod) % mod;
}

void sol2() {
    P[0] = 1;
    for (int i = 1; i < mxn; ++i) {
        P[i] = (P[i-1] * p) % mod;
    }

    string s, t;
    cin >> s;
    if (s.size() <= 1000) {
        string h = s;
        map<string, int> cnt;
        int n = h.size();
        for (int i = 0; i < n; i += n / 3) {
            cnt[h.substr(i, n / 3)]++;
        }
        for (auto i : cnt) {
            if (i.second >= 2) {
                cout << i.first;
            }
        }
        return;
    }

    for (int i = 0; i < 17; ++i) {
        t += s.back()-'0';
        s.pop_back();
    }
    reverse(t.begin(), t.end());

    int hs = 0, b = 1;
    for (char c : t) {
        hs += (c) * b;
        b *= 2;
    }
    int n = s.size();
    vector<int> H(n+1);
    for (int i = 1; i <= n; ++i) {
        H[i] = (H[i-1] * p + s[i-1]) % mod;
    }

    for (int i = 0; i < n; ++i) {
        int hh = 0;
        if (i > 0) hh = seg(1, i, H);
        hh = hh * p + '0';
        if (i < n-1) hh = hh * P[n-1-i] + seg(i+2, n, H);
        hh %= mod;
        hh %= (1<<17);
        if (hh == hs) {
            for (int j = 0; j < i; ++j) cout << s[j];
            cout << s[i];
            for (int j = i+1; j < n; ++j) cout << s[j];
            return;
        }
    }

    for (int i = 0; i < n; ++i) {
        int hh = 0;
        if (i > 0) hh = seg(1, i, H);
        hh = hh * p + '1';
        if (i < n-1) hh = hh * P[n-1-i] + seg(i+2, n, H);
        hh %= mod;
        hh %= (1<<17);
        if (hh == hs) {
            for (int j = 0; j < i; ++j) cout << s[j];
            cout << s[i];
            for (int j = i+1; j < n; ++j) cout << s[j];
            return;
        }
    }
}


int32_t main() {
    int t;
    cin >> t;
    if (t == 1) {
        sol1();
    } else {
        sol2();
    }
}