#include <algorithm>
#include <cassert>
#include <iostream>

using namespace std;

#define SZ(c) (int)c.size()

const int MOD = 777777773;
const int P = 239;

int get_h(string s) {
  int res = 0;
  for (int i = 0; i < SZ(s); ++i) {
    res = (res * 1LL * P + s[i]) % MOD;
  }
  return res;
}

const int K = 17;

string to_bin(int x) {
  string res;
  for (int i = 0; i < K; ++i) {
    res.push_back((x >> i & 1) + '0');
  }
  return res;
}

void solve1() {
  string s;
  cin >> s;
  int h = get_h(s);
  cout << s << to_bin(h) << '\n';
}

void solve2() {
  string s;
  cin >> s;
  string h = s.substr(SZ(s) - K, K);
  s.erase(s.begin() + SZ(s) - K, s.end());
  if (to_bin(get_h(s)) == h) {
    cout << s << '\n';
    return;
  }
  for (int i = 0; i < SZ(s); ++i) {
    s[i] = (s[i] == '0' ? '1' : '0');
    if (to_bin(get_h(s)) == h) {
      cout << s << '\n';
      return;
    }
    s[i] = (s[i] == '0' ? '1' : '0');
  }
  cout << s << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  int t;
  cin >> t;
  if (t == 1) {
    solve1();
  } else {
    solve2();
  }
}
