#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx2")
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstdio>
#include <set>
#include <map>
#include <random>
#include <vector>
using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = (n-1); i >= 0; i--) 
#define mp make_pair
#define each(x, a) for (auto x : a)
#define debug(x) { cerr << #x << " = " << x << endl; }
#define pb push_back
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()
typedef long long ll;
typedef vector<int > vi;
typedef pair<int, int> pii;
typedef set<int> si;
typedef vector<pii> vpii;
typedef  vector<ll> vll;
typedef pair<ll, ll> pll;

mt19937 rng(201108);

namespace Solution {
	int n = 100000;
	int add = 17;
	si secret;
	void init() {
		rep(i, 17) {
			secret.insert(rng() % n + 1);
		}
	}

	void first_sovle(string x) {
		cout << x + x + x << endl;
	}

	void second_solve(string y) {
		int n = sz(y) / 3;
		rep(i, n) {
			map<char, int> cnt;
			cnt[y[i]]++;
			cnt[y[i + n]]++;
			cnt[y[i + n + n]]++;
			if (cnt['0'] >= 2) {
				cout << '0';
			}
			else {
				cout << '1';
			}
		}
		cout << endl;
	}
	void solve_stupid(int t, string x) {
		if (t == 1) {
			first_sovle(x);
		}
		else {
			second_solve(x);
		}
	}


	void solve_clever(int t, string x) {
		x = "0" + x;
		if (t == 1) {
			vi b(add);
			for (int i = 1; i <= n; i++) {
				if (x[i] == '1') {
					for (int bit = 0; bit < add; bit++) {
						if (i & (1 << bit)) {
							b[bit]++;
						}
					}
				}
			}
			rep(bit, add) {
				b[bit] %= 2;
			}


			string y(n + add + 1, '0');

			int pnt = 0;
			int bt = 0;
			for (int i = 1; i <= n + add; i++) {
				if (secret.count(i)) {
					y[i] = b[bt++] + '0';
				}
				else {
					y[i] = x[pnt++];
				}
			}

			cout << y << endl;
		}
		else {
			vi b(add);
			int bt = 0;
			for (int q : secret) {
				b[bt++] = x[q] - '0';
			}
			for (int i = 1; i <= n + add; i++) {
				if (secret.count(i) == 0 && x[i] == '1') {
					for (int bit = 0; bit < add; bit++) {
						if (i & (1 << bit)) {
							b[bit]++;
						}
					}
				}
			}
			int ch = 0;
			for (int bit = 0; bit < add; bit++) {
				b[bit] %= 2;
				if (b[bit]) {
					ch += (1 << bit);
				}
			}
			x[ch] = (x[ch] - ' 0' + 1) % 2 + '0';
			for (int i = 1; i <= n + add; i++) {
				if (secret.count(i) == 0) {
					cout << x[i];
				}
			}
			cout << endl;
		}
	}



	void solve() {
		int t;
		string x;
		cin >> t >> x;
		if (sz(x) <= 30) {
			solve_stupid(t, x);
		}
		else {
			solve_clever(t, x);
		}
	}
}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	Solution::solve();
	

	return 0;
}